import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { PropertyEditorDescriptionObject as PropertyEditorDescriptionObject_internal } from './PropertyEditorDescriptionObject';
import { IgcPropertyEditorDescriptionObject as IgcPropertyEditorDescriptionObject } from './igc-property-editor-description-object';
export class IgcPropertyEditorDescriptionObjectCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcPropertyEditorDescriptionObject.$type) {
            IgcPropertyEditorDescriptionObject.$type = markType(IgcPropertyEditorDescriptionObject, "IgcPropertyEditorDescriptionObject");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcPropertyEditorDescriptionObject.$type) {
            IgcPropertyEditorDescriptionObject.$type = markType(IgcPropertyEditorDescriptionObject, "IgcPropertyEditorDescriptionObject");
        }
        let coll = new SyncableObservableCollection$2(IgcPropertyEditorDescriptionObject.$type, PropertyEditorDescriptionObject_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgcPropertyEditorDescriptionObject();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
