import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionButton } from "./ToolActionButton";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionButtonComponent = /*@__PURE__*/ (() => {
    class IgcToolActionButtonComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionButton();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent == null) {
                let names = getAllPropertyNames(IgcToolActionButtonComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent = names;
            }
            return IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent;
        }
        static register() {
            if (!IgcToolActionButtonComponent._isElementRegistered) {
                IgcToolActionButtonComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionButtonComponent.htmlTagName, IgcToolActionButtonComponent);
            }
        }
    }
    IgcToolActionButtonComponent._observedAttributesIgcToolActionButtonComponent = null;
    IgcToolActionButtonComponent.htmlTagName = "igc-tool-action-button";
    IgcToolActionButtonComponent._isElementRegistered = false;
    return IgcToolActionButtonComponent;
})();
