import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from './ToolActionEventDetail';
import { IgcToolActionEventDetail as IgcToolActionEventDetail } from './igc-tool-action-event-detail';
export class IgcToolActionEventDetailCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcToolActionEventDetail.$type) {
            IgcToolActionEventDetail.$type = markType(IgcToolActionEventDetail, "IgcToolActionEventDetail");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcToolActionEventDetail.$type) {
            IgcToolActionEventDetail.$type = markType(IgcToolActionEventDetail, "IgcToolActionEventDetail");
        }
        let coll = new SyncableObservableCollection$2(IgcToolActionEventDetail.$type, ToolActionEventDetail_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgcToolActionEventDetail();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
