import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionLabel } from "./ToolActionLabel";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionLabelComponent = /*@__PURE__*/ (() => {
    class IgcToolActionLabelComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionLabel();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent == null) {
                let names = getAllPropertyNames(IgcToolActionLabelComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent = names;
            }
            return IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent;
        }
        static register() {
            if (!IgcToolActionLabelComponent._isElementRegistered) {
                IgcToolActionLabelComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionLabelComponent.htmlTagName, IgcToolActionLabelComponent);
            }
        }
    }
    IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent = null;
    IgcToolActionLabelComponent.htmlTagName = "igc-tool-action-label";
    IgcToolActionLabelComponent._isElementRegistered = false;
    return IgcToolActionLabelComponent;
})();
