/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, delegateCombine, enumGetBox, typeCast, delegateRemove, fromEn, EnumUtil } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ToolPanel } from "./ToolPanel";
import { DOMExecutionContext } from "igniteui-webcomponents-core";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { ICommandStateChangedListener_$type } from "igniteui-webcomponents-core";
import { SRProvider } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { ToolActionCollection } from "./ToolActionCollection";
import { ToolbarOrientation_$type } from "./ToolbarOrientation";
import { ToolAction } from "./ToolAction";
import { NativeUIInputsFactory } from "igniteui-webcomponents-core";
import { NativeUIXInputsFactory } from "igniteui-webcomponents-inputs";
import { Visibility_$type } from "igniteui-webcomponents-core";
import { SvgIconRegistry } from "igniteui-webcomponents-core";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var ToolbarView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolbarView, _super);
    function ToolbarView() {
        var _this = _super.call(this) || this;
        _this.n = null;
        _this.m = null;
        _this.a = null;
        _this.i = null;
        _this.l = null;
        _this.e = null;
        _this.k = null;
        _this.b = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 13;
            $ret.q = "Normal";
            $ret.s = "Normal";
            $ret.o = "Normal";
            return $ret;
        })());
        _this.aa = new Size();
        _this.c = null;
        _this._gridExternal = null;
        _this.f = false;
        _this.j = null;
        return _this;
    }
    ToolbarView.prototype.p = function () {
        return this.i;
    };
    ToolbarView.prototype.v = function () {
    };
    ToolbarView.prototype.t = function (a) {
        if (a == null) {
            this.i = null;
            return;
        }
        this.a.b = new DOMExecutionContext(a);
        this.i = a;
        this.l = this.i.createElement("canvas");
        this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
        this.k = this.i.createElement("div");
        this.y();
        var b = new ToolPanel();
        var c = this.i.createElement("div");
        c.setStyleProperty("width", "100%");
        c.setStyleProperty("height", "100%");
        this.i.append(c);
        var d = this.i.getSubRenderer(c);
        b.provideContainer(d);
        var e = this.i.getExternal(b, this.i.rootWrapper, this.i.getExternal(this.a, null, null));
        this.a.b6(b);
        var f = Math.round(a.rootWrapper.width());
        var g = Math.round(a.rootWrapper.height());
        this.i.rootWrapper.setStyleProperty("position", "relative");
    };
    ToolbarView.prototype.y = function () {
    };
    ToolbarView.prototype.x = function () {
        if (this.i != null) {
        }
    };
    ToolbarView.prototype.s = function () {
        if (this.i == null) {
            return;
        }
        var a = this.i.rootWrapper.width();
        var b = this.i.rootWrapper.height();
        this.aa = new Size(1, a, b);
        this.a.b9(this.aa);
    };
    ToolbarView.prototype.z = function () {
        var a = this.i;
        if (null == a) {
            return;
        }
        var b = a.rootWrapper;
        if (null != b) {
            NativeUI.p(b, this.a.c5);
            NativeUI.l(b, this.a.cw);
        }
    };
    ToolbarView.prototype.d = function () {
        return this.b;
    };
    ToolbarView.prototype.u = function () {
    };
    ToolbarView.prototype.w = function () {
    };
    ToolbarView.prototype.r = function () {
    };
    ToolbarView.prototype.g = function () {
        return this.aa.width;
    };
    ToolbarView.prototype.h = function (a) {
        this.c = this.a.t();
        return FontUtil.measureStringWidth(a, this.c, this.e);
    };
    ToolbarView.prototype.q = function (a, b) {
        if (this.j == null) {
            this.j = this.i.createElement("div");
        }
        b(this.j.getNativeElement());
    };
    ToolbarView.$t = markType(ToolbarView, 'ToolbarView');
    return ToolbarView;
}(Base));
export { ToolbarView };
/**
 * @hidden
 */
var Toolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Toolbar, _super);
    function Toolbar() {
        var _this = _super.call(this) || this;
        _this.l = null;
        _this.w = false;
        _this.u = null;
        _this.n = null;
        _this.o = 0;
        _this.e = new ToolActionCollection();
        _this.c = new ToolActionCollection();
        _this.d = new ToolActionCollection();
        _this.i = Toolbar.j;
        _this.q = null;
        _this.ax = Toolbar.ay;
        _this.ck = null;
        _this.cs = null;
        _this.cm = null;
        _this.cr = null;
        _this.co = null;
        _this.ct = null;
        _this.cl = null;
        _this.cn = null;
        _this.cv = null;
        _this.cu = null;
        _this.al = NaN;
        _this.am = NaN;
        _this.cp = null;
        _this.cq = null;
        _this.r = null;
        _this.ai = NaN;
        _this.aj = NaN;
        _this.ak = NaN;
        _this.ah = NaN;
        _this.ae = NaN;
        _this.af = NaN;
        _this.ag = NaN;
        _this.ad = NaN;
        _this.z = true;
        _this.y = false;
        _this.x = false;
        _this.propertyChanged = null;
        _this.a = null;
        _this.onCommand = null;
        var a = _this.actions;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.by));
        var b = _this.actualActions;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.b0));
        var c = _this.actualActions;
        c.collectionResetting = delegateCombine(c.collectionResetting, runOn(_this, _this.b1));
        NativeUIInputsFactory.n();
        NativeUIXInputsFactory.j();
        var d = new ToolbarView();
        d.a = _this;
        _this.l = d;
        _this.l.v();
        return _this;
    }
    Object.defineProperty(Toolbar.prototype, "v", {
        get: function () {
            if (this.u == null) {
                this.u = new SRProvider(this.l.i);
                this.u.cb("Layouts");
            }
            return this.u;
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.b6 = function (a) {
        this.n = a;
        this.n.r = this.o == 0 ? 1 : this.o;
        var b = this.n;
        b.onCommand = delegateCombine(b.onCommand, runOn(this, this.bx));
        this.n.o = this.k;
        this.n.ac = this.ac;
        this.n.fh = this.c5;
        this.n.e8 = this.cx;
        this.n.e7 = this.cw;
        this.n.fg = this.c4;
        this.n.e9 = this.cy;
        this.n.fb = this.cz;
        this.n.ff = this.c3;
        this.n.fc = this.c0;
        this.n.fj = this.c7;
        this.n.fi = this.c6;
        this.n.bl = this.av;
        this.n.bm = this.aw;
        this.n.fd = this.c1;
        this.n.fe = this.c2;
        this.n.be = this.ao;
        this.n.bf = this.ap;
        this.n.bg = this.aq;
        this.n.bd = this.an;
        this.n.bi = this.as;
        this.n.bj = this.at;
        this.n.bk = this.au;
        this.n.bh = this.ar;
    };
    Toolbar.prototype.bx = function (a, b) {
        if (this.onCommand != null) {
            this.onCommand(this, b);
        }
        if (this.q != null) {
            this.q.onToolCommandExecuting(b.a);
        }
    };
    Toolbar.prototype.b9 = function (a) {
        this.n.notifySizeChanged();
    };
    Object.defineProperty(Toolbar.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ca("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "autoGeneratedActions", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ca("AutoGeneratedActions", b, this.e);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "actions", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ca("Actions", b, this.c);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "actualActions", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.ca("ActualActions", b, this.d);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "k", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.ca("Orientation", enumGetBox(ToolbarOrientation_$type, b), enumGetBox(ToolbarOrientation_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "target", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.ca("Target", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cw", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.ca("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c4", {
        get: function () {
            return this.cs;
        },
        set: function (a) {
            var b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.ca("SubmenuBackgroundColor", b, this.cs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cy", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.ca("GroupHeaderBackgroundColorPropertyName", b, this.cm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c3", {
        get: function () {
            return this.cr;
        },
        set: function (a) {
            var b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.ca("SeparatorBackgroundColor", b, this.cr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c0", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.co;
            this.co = a;
            if (b != this.co) {
                this.ca("HoverBackgroundColor", b, this.co);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c5", {
        get: function () {
            return this.ct;
        },
        set: function (a) {
            var b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.ca("TextColor", b, this.ct);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cx", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.ca("DisabledTextColor", b, this.cl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "cz", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.ca("GroupHeaderTextColor", b, this.cn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c7", {
        get: function () {
            return this.cv;
        },
        set: function (a) {
            var b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.ca("ToolTipTextColor", b, this.cv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c6", {
        get: function () {
            return this.cu;
        },
        set: function (a) {
            var b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.ca("ToolTipBackgroundColor", b, this.cu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "av", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.ca("ToolTipCornerRadius", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "aw", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.ca("ToolTipElevation", b, this.am);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c1", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.ca("IconFill", b, this.cp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "c2", {
        get: function () {
            return this.cq;
        },
        set: function (a) {
            var b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.ca("IconStroke", b, this.cq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ca("CellTextStyle", b, this.r);
            }
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.t = function () {
        if (this.s == null) {
            return this.l.d();
        }
        return this.s;
    };
    Object.defineProperty(Toolbar.prototype, "as", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.ca("SeparatorVerticalPaddingLeft", b, this.ai);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "at", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.ca("SeparatorVerticalPaddingRight", b, this.aj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "au", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.ca("SeparatorVerticalPaddingTop", b, this.ak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ar", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.ca("SeparatorVerticalPaddingBottom", b, this.ah);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ao", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.ca("SeparatorHorizontalPaddingLeft", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ap", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.ca("SeparatorHorizontalPaddingRight", b, this.af);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "aq", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.ca("SeparatorHorizontalPaddingTop", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "an", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.ca("SeparatorHorizontalPaddingBottom", b, this.ad);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "ac", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ca("ShowOnHover", b, this.z);
            }
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.by = function (a, b) {
        var e_1, _a, e_2, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        var d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bz));
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        var f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.bz));
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        this.b8();
    };
    Toolbar.prototype.b0 = function (a, b) {
        this.cj();
    };
    Toolbar.prototype.b1 = function (a, b) {
        for (var c = 0; c < this.actualActions.count; c++) {
            if (typeCast(INotifyPropertyChanged_$type, this.actualActions._inner[c]) !== null) {
                var d = this.actualActions._inner[c];
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bz));
            }
            this.actualActions._inner[c].b = null;
        }
    };
    Toolbar.prototype.cj = function () {
        var a = this.p == 0 ? 1 : this.p;
        if (this.n != null) {
            this.n.r = a;
        }
        for (var b = 0; b < this.actualActions.count; b++) {
            this.actualActions._inner[b].l = a;
        }
    };
    Toolbar.prototype.bz = function (a, b) {
    };
    Toolbar.prototype.b8 = function () {
        this.ce();
    };
    Toolbar.prototype.ce = function () {
        if (this.x) {
            return;
        }
        if (this.b != null) {
            this.x = true;
            this.b.enqueueAction(runOn(this, this.b4));
        }
        else {
            this.y = true;
        }
    };
    Toolbar.prototype.b4 = function () {
        if (!this.x) {
            return;
        }
        this.x = false;
        this.cf();
        if (this.n.actions != this.actualActions) {
            this.n.actions = this.actualActions;
        }
    };
    Toolbar.prototype.cf = function () {
        var _this = this;
        this.actualActions.clear();
        for (var a = 0; a < this.autoGeneratedActions.count; a++) {
            this.actualActions.add(this.autoGeneratedActions._inner[a]);
        }
        var b = null;
        var c = null;
        var d = false;
        var e = false;
        var f = -1;
        var g = 0;
        var _loop_1 = function (h) {
            var i = this_1.actions._inner[h];
            if (!stringIsNullOrEmpty(i.cw)) {
                if (((function () { var j = _this.aa(i.cw, _this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                    b._inner[f].d3(i);
                }
            }
            else {
                if (!stringIsNullOrEmpty(i.b9)) {
                    if (i.d != null) {
                        i.d.actions.remove(i);
                    }
                    if (((function () { var j = _this.aa(i.b9, _this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        c = i.b9;
                        d = true;
                        e = false;
                    }
                }
                else if (!stringIsNullOrEmpty(i.b6)) {
                    if (i.d != null) {
                        i.d.actions.remove(i);
                    }
                    if (((function () { var j = _this.aa(i.b6, _this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        c = i.b6;
                        d = false;
                        e = true;
                        g = 0;
                    }
                }
                if (!stringIsNullOrEmpty(c)) {
                    if (d) {
                        b.insert(f, i);
                        f++;
                    }
                    else if (e) {
                        b.insert(f + 1 + g, i);
                        g++;
                    }
                }
                else {
                    this_1.actualActions.add(i);
                }
            }
        };
        var this_1 = this;
        for (var h = 0; h < this.actions.count; h++) {
            _loop_1(h);
        }
    };
    Toolbar.prototype.aa = function (a, b, c, d) {
        var _this = this;
        var _loop_2 = function (e) {
            var f = b._inner[e];
            if (f.cu != null && f.cu == a) {
                c = b;
                d = e;
                return { value: {
                        ret: true,
                        p2: c,
                        p3: d
                    } };
            }
            if (f.actions.count > 0) {
                if (((function () { var g = _this.aa(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                    return { value: {
                            ret: true,
                            p2: c,
                            p3: d
                        } };
                }
            }
        };
        for (var e = 0; e < b.count; e++) {
            var state_1 = _loop_2(e);
            if (typeof state_1 === "object")
                return state_1.value;
        }
        c = c;
        d = d;
        return {
            ret: false,
            p2: c,
            p3: d
        };
    };
    Toolbar.prototype.ab = function (a, b, c, d) {
        var _this = this;
        var _loop_3 = function (e) {
            var f = b._inner[e];
            if (f.cd == null) {
                if (f.cu != null && f.cu == a) {
                    c = b;
                    d = e;
                    return { value: {
                            ret: true,
                            p2: c,
                            p3: d
                        } };
                }
            }
            else if (f.cd != null && f.cd == a) {
                c = b;
                d = e;
                return { value: {
                        ret: true,
                        p2: c,
                        p3: d
                    } };
            }
            if (f.actions.count > 0) {
                if (((function () { var g = _this.aa(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                    return { value: {
                            ret: true,
                            p2: c,
                            p3: d
                        } };
                }
            }
        };
        for (var e = 0; e < b.count; e++) {
            var state_2 = _loop_3(e);
            if (typeof state_2 === "object")
                return state_2.value;
        }
        c = c;
        d = d;
        return {
            ret: false,
            p2: c,
            p3: d
        };
    };
    Toolbar.prototype.b5 = function () {
        if (this.x) {
            this.b4();
        }
    };
    Toolbar.prototype.notifySizeChanged = function () {
        this.l.s();
    };
    Toolbar.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Toolbar.prototype.provideContainer = function (a) {
        this.l.t(a);
    };
    Toolbar.prototype.ca = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.cc(a, b, c);
    };
    Toolbar.prototype.cc = function (a, b, c) {
        switch (a) {
            case "CellTextStyle":
                this.ce();
                break;
            case "BackgroundColor":
            case "TextColor":
            case "SubmenuBackgroundColor":
            case "GroupHeaderBackgroundColorPropertyName":
            case "GroupHeaderTextColor":
            case "SeparatorBackgroundColor":
            case "HoverBackgroundColor":
            case "IconFill":
            case "IconStroke":
            case "ToolTipTextColor":
            case "ToolTipBackgroundColor":
            case "ToolTipCornerRadius":
            case "ToolTipElevation":
            case "Orientation":
            case "ShowOnHover":
                this.ci();
                break;
            case "Target":
                var d = c;
                var e = b;
                this.cb(e, d);
                break;
            case "BaseTheme":
                this.cj();
                break;
            case "ExecutionContext":
                if (this.b != null && this.y) {
                    this.ce();
                    this.y = false;
                }
                break;
        }
    };
    Toolbar.prototype.ci = function () {
        if (this.n != null) {
            this.n.ac = this.ac;
            this.n.e7 = this.cw;
            this.n.fh = this.c5;
            this.n.e8 = this.cx;
            this.n.fg = this.c4;
            this.n.e9 = this.cy;
            this.n.fb = this.cz;
            this.n.ff = this.c3;
            this.n.fc = this.c0;
            this.n.o = this.k;
            this.n.fj = this.c7;
            this.n.fi = this.c6;
            this.n.bl = this.av;
            this.n.bm = this.aw;
            this.n.fd = this.c1;
            this.n.fe = this.c2;
            this.n.be = this.ao;
            this.n.bf = this.ap;
            this.n.bg = this.aq;
            this.n.bd = this.an;
            this.n.bi = this.as;
            this.n.bj = this.at;
            this.n.bk = this.au;
            this.n.bh = this.ar;
        }
    };
    Toolbar.prototype.cb = function (a, b) {
        this.q = b;
        if (a != null) {
            this.autoGeneratedActions.clear();
            a.removeCommandStateChangedListener(this);
            this.ce();
        }
        if (b != null) {
            this.autoGeneratedActions.clear();
            var c = b.getDesiredToolbarActions();
            if (c != null) {
                for (var d = 0; d < c.length; d++) {
                    var e = ToolAction.c(c[d]);
                    this.autoGeneratedActions.add(e);
                }
            }
            b.addCommandStateChangedListener(this);
            this.ce();
        }
    };
    Object.defineProperty(Toolbar.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ca("ExecutionContext", b, this.a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Toolbar.prototype.b2 = function () {
        if (this.n != null) {
            this.n.dc();
        }
    };
    Toolbar.prototype.onCommandStateChanged = function (a, b, c) {
        var _this = this;
        var d = null;
        var e = -1;
        if (((function () { var f = _this.ab(a, _this.actualActions, d, e); d = f.p2; e = f.p3; return f.ret; })())) {
            var f = d._inner[e];
            switch (b) {
                case 2:
                    switch (f.m) {
                        case 2:
                            f.e4 = c;
                            break;
                        case 5:
                            f.e5 = c;
                            break;
                        case 6:
                            f.e4 = c;
                            break;
                    }
                    break;
                case 0:
                    f.e1 = EnumUtil.getEnumValue(Visibility_$type, c);
                    break;
                case 1:
                    f.ah = c;
                    break;
            }
        }
    };
    Toolbar.prototype.cg = function (a, b) {
        for (var c = 0; c < a.count; c++) {
            var d = a._inner[c];
            if (d.cl == b) {
                d.cl = null;
                d.cl = b;
            }
            if (d.actions != null && d.actions.count > 0) {
                this.cg(d.actions, b);
            }
        }
    };
    Toolbar.prototype.ch = function (a, b, c) {
        SvgIconRegistry.instance.addSvgPathString(a, b, c);
        this.cg(this.actualActions, b);
    };
    Toolbar.prototype.a9 = function (a, b) {
        return SvgIconRegistry.instance.getSvgPathString(a, b);
    };
    Toolbar.$t = markType(Toolbar, 'Toolbar', Base.$, [INotifyPropertyChanged_$type, ICommandStateChangedListener_$type]);
    Toolbar.j = 1;
    Toolbar.ay = null;
    return Toolbar;
}(Base));
export { Toolbar };
