import { PropertyEditorDataSource as PropertyEditorDataSource_internal } from "./PropertyEditorDataSource";
var IgcPropertyEditorDataSource = /** @class */ /*@__PURE__*/ (function () {
    function IgcPropertyEditorDataSource() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgcPropertyEditorDataSource.prototype.createImplementation = function () {
        return new PropertyEditorDataSource_internal();
    };
    Object.defineProperty(IgcPropertyEditorDataSource.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcPropertyEditorDataSource.prototype.onImplementationCreated = function () {
    };
    IgcPropertyEditorDataSource.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgcPropertyEditorDataSource.prototype, "descriptionType", {
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcPropertyEditorDataSource.prototype, "context", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    IgcPropertyEditorDataSource.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgcPropertyEditorDataSource;
}());
export { IgcPropertyEditorDataSource };
