import { __extends } from "tslib";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionLabel } from "./ToolActionLabel";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcToolActionLabelComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionLabelComponent, _super);
    function IgcToolActionLabelComponent() {
        return _super.call(this) || this;
    }
    IgcToolActionLabelComponent.prototype.createImplementation = function () {
        return new ToolActionLabel();
    };
    Object.defineProperty(IgcToolActionLabelComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionLabelComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionLabelComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionLabelComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent == null) {
                var names = getAllPropertyNames(IgcToolActionLabelComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent = names;
            }
            return IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionLabelComponent.register = function () {
        if (!IgcToolActionLabelComponent._isElementRegistered) {
            IgcToolActionLabelComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionLabelComponent.htmlTagName, IgcToolActionLabelComponent);
        }
    };
    IgcToolActionLabelComponent._observedAttributesIgcToolActionLabelComponent = null;
    IgcToolActionLabelComponent.htmlTagName = "igc-tool-action-label";
    IgcToolActionLabelComponent._isElementRegistered = false;
    return IgcToolActionLabelComponent;
}(IgcToolActionComponent));
export { IgcToolActionLabelComponent };
