import { __extends } from "tslib";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionNumberInput } from "./ToolActionNumberInput";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcToolActionNumberInputComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionNumberInputComponent, _super);
    function IgcToolActionNumberInputComponent() {
        return _super.call(this) || this;
    }
    IgcToolActionNumberInputComponent.prototype.createImplementation = function () {
        return new ToolActionNumberInput();
    };
    Object.defineProperty(IgcToolActionNumberInputComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionNumberInputComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionNumberInputComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionNumberInputComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent == null) {
                var names = getAllPropertyNames(IgcToolActionNumberInputComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent = names;
            }
            return IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionNumberInputComponent.register = function () {
        if (!IgcToolActionNumberInputComponent._isElementRegistered) {
            IgcToolActionNumberInputComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionNumberInputComponent.htmlTagName, IgcToolActionNumberInputComponent);
        }
    };
    Object.defineProperty(IgcToolActionNumberInputComponent.prototype, "value", {
        /**
         * Gets or sets the value for the input.
        */
        get: function () {
            return this.i.e5;
        },
        set: function (v) {
            this.i.e5 = +v;
            this._a("value", this.i.e5);
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionNumberInputComponent.prototype.fromInfo = function (info) {
        this.i.dp(info);
    };
    IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent = null;
    IgcToolActionNumberInputComponent.htmlTagName = "igc-tool-action-number-input";
    IgcToolActionNumberInputComponent._isElementRegistered = false;
    return IgcToolActionNumberInputComponent;
}(IgcToolActionComponent));
export { IgcToolActionNumberInputComponent };
