import { IgcToolActionEventDetail } from "./igc-tool-action-event-detail";
import { IgcToolActionEventDetailCollection } from "./igc-tool-action-event-detail-collection";
import { ToolActionPerformedEventArgs as ToolActionPerformedEventArgs_internal } from "./ToolActionPerformedEventArgs";
import { ensureBool } from "igniteui-webcomponents-core";
import { ToolActionEventDetailCollection as ToolActionEventDetailCollection_internal } from "./ToolActionEventDetailCollection";
import { ToolActionEventDetail } from "./ToolActionEventDetail";
import { SyncableObservableCollection$1 } from "igniteui-webcomponents-core";
var IgcToolActionPerformedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcToolActionPerformedEventArgs() {
        this._detailCollection = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgcToolActionPerformedEventArgs.prototype.createImplementation = function () {
        return new ToolActionPerformedEventArgs_internal();
    };
    Object.defineProperty(IgcToolActionPerformedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionPerformedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcToolActionPerformedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgcToolActionPerformedEventArgs.prototype, "isAggregate", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionPerformedEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgcToolActionEventDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcToolActionPerformedEventArgs.prototype, "detailCollection", {
        get: function () {
            if (this._detailCollection === null) {
                var coll = new IgcToolActionEventDetailCollection();
                var innerColl = this.i.b;
                if (!innerColl) {
                    innerColl = new ToolActionEventDetailCollection_internal();
                }
                this._detailCollection = coll._fromInner(innerColl);
                this.i.b = innerColl;
            }
            return this._detailCollection;
        },
        set: function (v) {
            if (this._detailCollection !== null) {
                this._detailCollection._setSyncTarget(null);
                this._detailCollection = null;
            }
            var coll = new IgcToolActionEventDetailCollection();
            this._detailCollection = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(ToolActionEventDetail.$type);
            var innerColl = this.i.b;
            if (!innerColl) {
                innerColl = new ToolActionEventDetailCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._detailCollection._setSyncTarget(syncColl);
            this.i.b = innerColl;
        },
        enumerable: false,
        configurable: true
    });
    return IgcToolActionPerformedEventArgs;
}());
export { IgcToolActionPerformedEventArgs };
