import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-webcomponents-core";
import { DomRenderer, DomWrapper } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ToolPanel } from "./ToolPanel";
import { Size } from "igniteui-webcomponents-core";
import { ICommandStateChangedListener } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { ToolActionCollection } from "./ToolActionCollection";
import { ToolbarOrientation } from "./ToolbarOrientation";
import { IToolbarTarget } from "igniteui-webcomponents-core";
import { Brush } from "igniteui-webcomponents-core";
import { IExecutionContext } from "igniteui-webcomponents-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolCommandStateType } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class ToolbarView extends Base {
    static $t: Type;
    private n;
    private m;
    constructor();
    p(): any;
    a: Toolbar;
    v(): void;
    i: DomRenderer;
    l: DomWrapper;
    e: RenderingContext;
    k: DomWrapper;
    t(a: DomRenderer): void;
    y(): void;
    x(): void;
    s(): void;
    z(): void;
    private b;
    private aa;
    private c;
    private _gridExternal;
    d(): FontInfo;
    u(): void;
    w(): void;
    r(): void;
    g(): number;
    h(a: string): number;
    f: boolean;
    private j;
    q(a: any, b: (arg1: any) => void): void;
}
/**
 * @hidden
 */
export declare class Toolbar extends Base implements INotifyPropertyChanged, ICommandStateChangedListener {
    static $t: Type;
    l: ToolbarView;
    private w;
    constructor();
    private u;
    private get v();
    private n;
    b6(a: ToolPanel): void;
    private bx;
    b9(a: Size): void;
    private o;
    get p(): BaseControlTheme;
    set p(a: BaseControlTheme);
    private e;
    get autoGeneratedActions(): ToolActionCollection;
    set autoGeneratedActions(a: ToolActionCollection);
    private c;
    get actions(): ToolActionCollection;
    set actions(a: ToolActionCollection);
    private d;
    get actualActions(): ToolActionCollection;
    set actualActions(a: ToolActionCollection);
    static j: ToolbarOrientation;
    private i;
    get k(): ToolbarOrientation;
    set k(a: ToolbarOrientation);
    q: IToolbarTarget;
    static ay: any;
    private ax;
    get target(): any;
    set target(a: any);
    private ck;
    get cw(): Brush;
    set cw(a: Brush);
    private cs;
    get c4(): Brush;
    set c4(a: Brush);
    private cm;
    get cy(): Brush;
    set cy(a: Brush);
    private cr;
    get c3(): Brush;
    set c3(a: Brush);
    private co;
    get c0(): Brush;
    set c0(a: Brush);
    ct: Brush;
    get c5(): Brush;
    set c5(a: Brush);
    cl: Brush;
    get cx(): Brush;
    set cx(a: Brush);
    private cn;
    get cz(): Brush;
    set cz(a: Brush);
    private cv;
    get c7(): Brush;
    set c7(a: Brush);
    private cu;
    get c6(): Brush;
    set c6(a: Brush);
    private al;
    get av(): number;
    set av(a: number);
    private am;
    get aw(): number;
    set aw(a: number);
    private cp;
    get c1(): Brush;
    set c1(a: Brush);
    private cq;
    get c2(): Brush;
    set c2(a: Brush);
    private r;
    get s(): FontInfo;
    set s(a: FontInfo);
    t(): FontInfo;
    private ai;
    get as(): number;
    set as(a: number);
    private aj;
    get at(): number;
    set at(a: number);
    private ak;
    get au(): number;
    set au(a: number);
    private ah;
    get ar(): number;
    set ar(a: number);
    private ae;
    get ao(): number;
    set ao(a: number);
    private af;
    get ap(): number;
    set ap(a: number);
    private ag;
    get aq(): number;
    set aq(a: number);
    private ad;
    get an(): number;
    set an(a: number);
    private z;
    get ac(): boolean;
    set ac(a: boolean);
    private by;
    private b0;
    private b1;
    private cj;
    private bz;
    private b8;
    private y;
    private x;
    protected ce(): void;
    private b4;
    private cf;
    private aa;
    private ab;
    private b5;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected ca(a: string, b: any, c: any): void;
    protected cc(a: string, b: any, c: any): void;
    private ci;
    private cb;
    private a;
    get b(): IExecutionContext;
    set b(a: IExecutionContext);
    b2(): void;
    onCommand: (sender: any, args: ToolCommandEventArgs) => void;
    onCommandStateChanged(a: string, b: ToolCommandStateType, c: any): void;
    private cg;
    ch(a: string, b: string, c: string): void;
    a9(a: string, b: string): string;
}
