import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionCheckbox } from "./ToolActionCheckbox";
import { ToolActionInfo } from "igniteui-webcomponents-core";
export declare class IgcToolActionCheckboxComponent extends IgcToolActionComponent {
    protected createImplementation(): ToolActionCheckbox;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionCheckbox;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcToolActionCheckboxComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets if the tool action is checked.
    */
    get isChecked(): boolean;
    set isChecked(v: boolean);
    fromInfo(info: ToolActionInfo): void;
}
