/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, runOn, delegateCombine, delegateRemove, EnumUtil, typeGetValue, enumGetBox, INotifyPropertyChanged_$type, PropertyChangedEventArgs, fromEn, fromEnum, typeCast, String_$type } from "igniteui-webcomponents-core";
import { INativeUIElementFactory_$type } from "igniteui-webcomponents-core";
import { NativeUIComponent } from "igniteui-webcomponents-core";
import { XComponentBridge } from "igniteui-webcomponents-inputs";
import { INativeUIToolPanelBridge_$type } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-webcomponents-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolPanelOrientation_$type } from "./ToolPanelOrientation";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ListPanel } from "./ListPanel";
import { DOMExecutionContext } from "igniteui-webcomponents-core";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { Popup } from "igniteui-webcomponents-core";
import { Rect } from "igniteui-webcomponents-core";
import { Visibility_$type } from "igniteui-webcomponents-core";
import { ToolActionType_$type } from "igniteui-webcomponents-core";
import { BrushUtil } from "igniteui-webcomponents-core";
import { ObservableCollection$1 } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { ToolCommandArgument } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolCommand } from "igniteui-webcomponents-core";
import { CSSColorUtil } from "igniteui-webcomponents-core";
import { Thickness } from "igniteui-webcomponents-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { isNaN_, isPositiveInfinity, truncate, tryParseNumber } from "igniteui-webcomponents-core";
import { SvgIconRegistry } from "igniteui-webcomponents-core";
import { TooltipTextPresenter } from "./TooltipTextPresenter";
import { DelayManager } from "igniteui-webcomponents-core";
import { NativeUIWindow } from "igniteui-webcomponents-core";
import { NativeUIIconButton } from "igniteui-webcomponents-core";
import { BrushUtilCore } from "igniteui-webcomponents-core";
import { CornerRadius } from "igniteui-webcomponents-core";
import { SRProvider } from "igniteui-webcomponents-core";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { NativeUIXInputsFactory } from "igniteui-webcomponents-inputs";
import { NativeUIInputsFactory } from "igniteui-webcomponents-core";
import { TranslateTransform } from "igniteui-webcomponents-core";
import { AnimationKeyFrameProperty } from "igniteui-webcomponents-core";
import { Queue$1 } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffect } from "igniteui-webcomponents-core";
import { KeyFrameAnimationFactory } from "igniteui-webcomponents-core";
import { MatrixTransform } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let NativeUILayoutFactory = /*@__PURE__*/ (() => {
    class NativeUILayoutFactory extends Base {
        constructor() {
            super(...arguments);
            this.c = 2;
        }
        static get b() {
            if (NativeUILayoutFactory.a == null) {
                NativeUILayoutFactory.a = new NativeUILayoutFactory();
            }
            return NativeUILayoutFactory.a;
        }
        static e() {
            NativeUIComponent.ap(NativeUILayoutFactory.b);
        }
        get flavor() {
            return this.c;
        }
        createComponent(a, b, c) {
            switch (b) {
                case 13:
                    this.d(a, c);
                    break;
            }
        }
        createComponentSync(a, b, c) {
            this.createComponent(a, b, c);
        }
        supportsComponent(a) {
            switch (a) {
                case 13: return true;
            }
            return false;
        }
        d(a, b) {
            let c = a;
            let d = c.createElement("div");
            let e = c.getSubRenderer(d);
            let f = new ToolPanel();
            f.provideContainer(e);
            let g = new XToolPanelBridge(f);
            let h = new NativeUIToolPanel();
            h.al = d;
            h.d = g;
            b(h);
        }
    }
    NativeUILayoutFactory.$t = /*@__PURE__*/ markType(NativeUILayoutFactory, 'NativeUILayoutFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUILayoutFactory.a = null;
    return NativeUILayoutFactory;
})();
/**
 * @hidden
 */
export let XToolPanelBridge = /*@__PURE__*/ (() => {
    class XToolPanelBridge extends XComponentBridge {
        constructor(a) {
            super(a);
            this.u = null;
            this.x = null;
            this.v = null;
            this.y = null;
            this.w = null;
            this.z = null;
        }
        getDesiredSize(a, b) {
            return this.t.fk();
        }
        addHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 10:
                    e.drillDownRequested = delegateCombine(e.drillDownRequested, runOn(this, this.ab));
                    this.u = d;
                    this.x = b;
                    break;
                case 11:
                    e.drillUpRequested = delegateCombine(e.drillUpRequested, runOn(this, this.ac));
                    this.v = d;
                    this.y = b;
                    break;
                case 16:
                    e.onCommand = delegateCombine(e.onCommand, runOn(this, this.aa));
                    this.w = d;
                    this.z = b;
                    break;
            }
        }
        removeHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 10:
                    e.drillDownRequested = delegateRemove(e.drillDownRequested, runOn(this, this.ab));
                    this.u = null;
                    this.x = null;
                    break;
                case 11:
                    e.drillUpRequested = delegateRemove(e.drillUpRequested, runOn(this, this.ac));
                    this.v = null;
                    this.y = null;
                    break;
                case 16:
                    e.onCommand = delegateRemove(e.onCommand, runOn(this, this.aa));
                    this.w = null;
                    this.z = null;
                    break;
            }
        }
        ab(a, b) {
            if (this.u != null) {
                this.u(this.x, b);
            }
        }
        ac(a, b) {
            if (this.v != null) {
                this.v(this.y, b);
            }
        }
        aa(a, b) {
            if (this.w != null) {
                this.w(this.z, b);
            }
        }
        setValue(a, b, c) {
            let d = a;
            switch (b) {
                case 27:
                    d.actions = c;
                    break;
                case 30:
                    d.o = EnumUtil.getEnumValue(ToolPanelOrientation_$type, c);
                    break;
                case 28:
                    d.bn = typeGetValue(c);
                    break;
                case 18:
                    d.r = EnumUtil.getEnumValue(BaseControlTheme_$type, c);
                    break;
            }
        }
        getValue(a, b) {
            let c = a;
            switch (b) {
                case 27: return c.actions;
                case 30: return enumGetBox(ToolPanelOrientation_$type, c.o);
                case 28: return c.bn;
                case 29: return c.a2;
                case 18: return enumGetBox(BaseControlTheme_$type, c.r);
            }
            return null;
        }
        refresh(a) {
            a.dw();
        }
        notifySizeChanged(a, b) {
            a.notifySizeChanged();
        }
    }
    XToolPanelBridge.$t = /*@__PURE__*/ markType(XToolPanelBridge, 'XToolPanelBridge', XComponentBridge.$, [INativeUIToolPanelBridge_$type]);
    return XToolPanelBridge;
})();
/**
 * @hidden
 */
export let ToolPanelView = /*@__PURE__*/ (() => {
    class ToolPanelView extends Base {
        constructor() {
            super();
            this.s = null;
            this.r = null;
            this.c = null;
            this.n = null;
            this.q = null;
            this.g = null;
            this.p = null;
            this.d = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.ag = new Size();
            this.e = null;
            this._gridExternal = null;
            this.h = false;
            this.o = null;
        }
        v() {
            return this.n;
        }
        ab() {
        }
        get t() {
            return this.n.rootWrapper;
        }
        z(a) {
            if (a == null) {
                this.n = null;
                return;
            }
            this.c.a = new DOMExecutionContext(a);
            this.n = a;
            this.q = this.n.createElement("canvas");
            this.g = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
            this.p = this.n.createElement("div");
            this.ad();
            let b = new ListPanel();
            let c = this.n.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.n.append(c);
            let d = this.n.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            b.externalListPanel = e;
            this.c.dh(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.n.rootWrapper.setStyleProperty("position", "relative");
            this.n.rootWrapper.setStyleProperty("width", "100%");
        }
        ad() {
        }
        y() {
            if (this.n == null) {
                return;
            }
            let a = this.n.rootWrapper.width();
            let b = this.n.rootWrapper.height();
            this.ag = new Size(1, a, b);
            this.c.dm(this.ag);
            if (this.c.v != null) {
            }
        }
        k() {
            let a = this.n.rootWrapper.getNativeElement();
            return a.offsetWidth;
        }
        j() {
            let a = this.n.rootWrapper.getNativeElement();
            return a.offsetHeight;
        }
        ae() {
            let a = this.n;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.p(b, this.c.fh);
                NativeUI.l(b, this.c.e7);
            }
        }
        f() {
            return this.d;
        }
        aa() {
        }
        ac() {
        }
        x() {
        }
        i() {
            return this.ag.width;
        }
        l(a) {
            this.e = this.c.u();
            return FontUtil.measureStringWidth(a, this.e, this.g);
        }
        m(a, b) {
            return FontUtil.measureStringWidth(a, b, this.g);
        }
        w(a, b) {
            if (this.o == null) {
                this.o = this.n.createElement("div");
            }
            b(this.o.getNativeElement());
        }
        a() {
            let a = new Popup();
            let b = this.n.getExternal(a, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            return a;
        }
        b(a) {
            let b = new ToolPanel();
            let c = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            let d = a.al;
            d.appendChild(b.p.n.rootWrapper.getNativeElement());
            return b;
        }
        af(a) {
            let ele_ = a;
            let bounds_ = (ele_.getBoundingClientRect());
            let b = bounds_["left"];
            let c = bounds_["top"];
            let d = bounds_["width"];
            let e = bounds_["height"];
            return new Rect(0, b, c, d, e);
        }
    }
    ToolPanelView.$t = /*@__PURE__*/ markType(ToolPanelView, 'ToolPanelView');
    return ToolPanelView;
})();
/**
 * @hidden
 */
export let NativeUIToolPanel = /*@__PURE__*/ (() => {
    class NativeUIToolPanel extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bl = null;
            this.bg = null;
            this.bh = null;
            this.bn = null;
        }
        get bk() {
            return this.d;
        }
        get bp() {
            return this.ae(27);
        }
        set bp(a) {
            this.a0(27, a);
        }
        get bs() {
            return this.ae(28);
        }
        set bs(a) {
            this.a0(28, a);
        }
        get br() {
            return this.ae(29);
        }
        get bq() {
            return EnumUtil.getEnumValue(ToolPanelOrientation_$type, this.ae(30));
        }
        set bq(a) {
            this.a0(30, enumGetBox(ToolPanelOrientation_$type, a));
        }
        get b1() {
            return this.ae(33);
        }
        set b1(a) {
            this.a0(33, a);
        }
        get bw() {
            return this.ae(34);
        }
        set bw(a) {
            this.a0(34, a);
        }
        get bv() {
            return this.ae(23);
        }
        set bv(a) {
            this.a0(23, a);
        }
        get b0() {
            return this.ae(50);
        }
        set b0(a) {
            this.a0(50, a);
        }
        get bx() {
            return this.ae(51);
        }
        set bx(a) {
            this.a0(51, a);
        }
        get by() {
            return this.ae(52);
        }
        set by(a) {
            this.a0(52, a);
        }
        get bz() {
            return this.ae(53);
        }
        set bz(a) {
            this.a0(53, a);
        }
        get bm() {
            return this.bl;
        }
        set bm(a) {
            let b = this.bl;
            this.bl = a;
            if (this.bl != null) {
                this.an(9, this.bl);
            }
            else {
                this.ay(9, b);
            }
        }
        get bi() {
            return this.bg;
        }
        set bi(a) {
            let b = this.bg;
            this.bg = a;
            if (this.bg != null) {
                this.an(10, this.bg);
            }
            else {
                this.ay(10, b);
            }
        }
        get bj() {
            return this.bh;
        }
        set bj(a) {
            let b = this.bh;
            this.bh = a;
            if (this.bh != null) {
                this.an(11, this.bh);
            }
            else {
                this.ay(11, b);
            }
        }
        get bo() {
            return this.bn;
        }
        set bo(a) {
            let b = this.bn;
            this.bn = a;
            if (this.bn != null) {
                this.an(16, this.bn);
            }
            else {
                this.ay(16, b);
            }
        }
        bu() {
            this.bk.refresh(this.ak);
        }
        bt(a) {
            this.bk.notifySizeChanged(this.ak, a);
        }
    }
    NativeUIToolPanel.$t = /*@__PURE__*/ markType(NativeUIToolPanel, 'NativeUIToolPanel', NativeUIComponent.$);
    return NativeUIToolPanel;
})();
/**
 * @hidden
 */
export let ToolAction = /*@__PURE__*/ (() => {
    class ToolAction extends Base {
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.dx("ExecutionContext", b, this.a);
            }
        }
        get cs() {
            if (this.cu != null) {
                return this.cu;
            }
            if (this.da != null) {
                return this.c5(this.da);
            }
            return null;
        }
        get actions() {
            return this.e;
        }
        get bi() {
            return this.a0;
        }
        set bi(a) {
            this.a0 = a;
        }
        constructor() {
            super();
            this.j = null;
            this.a = null;
            this.d = null;
            this.e = new ToolActionCollection();
            this.a0 = NaN;
            this.bs = null;
            this.b9 = null;
            this.b6 = null;
            this.cw = null;
            this.bo = null;
            this.bn = null;
            this.bj = null;
            this.k = 0;
            this.aw = NaN;
            this.ao = NaN;
            this.ax = NaN;
            this.ap = NaN;
            this.av = NaN;
            this.an = NaN;
            this.ay = NaN;
            this.aq = NaN;
            this.ed = null;
            this.ek = null;
            this.ei = BrushUtil.g(0, 0, 0, 0);
            this.eb = null;
            this.eh = null;
            this.eg = null;
            this.en = null;
            this.ec = null;
            this.ej = null;
            this.o = null;
            this.q = null;
            this.ab = false;
            this.br = null;
            this.bu = null;
            this.bt = null;
            this.az = 30;
            this.bq = null;
            this.bp = null;
            this.as = NaN;
            this.at = NaN;
            this.au = NaN;
            this.ar = NaN;
            this.el = null;
            this.ee = null;
            this.em = null;
            this.ef = null;
            this.e0 = 0;
            this.propertyChanged = null;
            this.p = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.onCommand = null;
            this.performed = null;
            this.x = null;
            this.w = null;
            this.u = null;
            this.z = null;
            this.aa = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.dq));
            let b = this.actions;
            b.collectionResetting = delegateCombine(b.collectionResetting, runOn(this, this.dr));
        }
        dd() {
        }
        dq(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    c.dd();
                    c.d = null;
                }
            }
            if (b.newItems != null) {
                for (let d of fromEn(b.newItems)) {
                    d.d = this;
                }
            }
        }
        dr(a, b) {
            for (let c of fromEnum(this.actions)) {
                c.dd();
                c.d = null;
            }
        }
        c5(a) {
            return stringReplace(a, " ", "_");
        }
        g(a) {
            return ((() => {
                let $ret = new ToolActionEventDetail();
                $ret.a = this;
                $ret.d = a;
                return $ret;
            })());
        }
        n() {
            return ((() => {
                let $ret = new ToolCommandArgument();
                $ret.argumentName = this.c3();
                $ret.value = this.bl();
                return $ret;
            })());
        }
        c3() {
            if (this.ca != null) {
                return this.ca;
            }
            return this.cs != null ? this.cs : "Unknown";
        }
        bl() {
            if (this.bk != null) {
                return this.bk;
            }
            return this.bm();
        }
        bm() {
            return null;
        }
        get c1() {
            return this.bs;
        }
        set c1(a) {
            let b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.dx("ParentId", b, this.bs);
            }
        }
        c4() {
            if (this.cd != null) {
                return this.cd;
            }
            return this.cs;
        }
        get cd() {
            return this.bo;
        }
        set cd(a) {
            let b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.dx("CommandId", b, this.bo);
            }
        }
        get ca() {
            return this.bn;
        }
        set ca(a) {
            let b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.dx("CommandArgument", b, this.bn);
            }
        }
        get bk() {
            return this.bj;
        }
        set bk(a) {
            let b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.dx("CommandArgumentValue", b, this.bj);
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.dx("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get be() {
            return this.aw;
        }
        set be(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.dx("PaddingLeft", b, this.aw);
            }
        }
        get a2() {
            return this.ao;
        }
        set a2(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.dx("ActualPaddingLeft", b, this.ao);
            }
        }
        get bf() {
            return this.ax;
        }
        set bf(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.dx("PaddingRight", b, this.ax);
            }
        }
        get a3() {
            return this.ap;
        }
        set a3(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.dx("ActualPaddingRight", b, this.ap);
            }
        }
        get bd() {
            return this.av;
        }
        set bd(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.dx("PaddingBottom", b, this.av);
            }
        }
        get a1() {
            return this.an;
        }
        set a1(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.dx("ActualPaddingBottom", b, this.an);
            }
        }
        get bg() {
            return this.ay;
        }
        set bg(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.dx("PaddingTop", b, this.ay);
            }
        }
        get a4() {
            return this.aq;
        }
        set a4(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.dx("ActualPaddingTop", b, this.aq);
            }
        }
        get eq() {
            return this.ed;
        }
        set eq(a) {
            let b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.dx("ActualHoverBackground", b, this.ed);
            }
        }
        get ew() {
            return this.ek;
        }
        set ew(a) {
            let b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.dx("HoverBackground", b, this.ek);
            }
        }
        get eo() {
            return this.eb;
        }
        set eo(a) {
            let b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.dx("ActualBackground", b, this.eb);
            }
        }
        get eu() {
            return this.eh;
        }
        set eu(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.dx("Background", b, this.eh);
            }
        }
        get et() {
            return this.eg;
        }
        set et(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.dx("ActualTextColor", b, this.eg);
            }
        }
        get ez() {
            return this.en;
        }
        set ez(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.dx("TextColor", b, this.en);
            }
        }
        get ep() {
            return this.ec;
        }
        set ep(a) {
            let b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.dx("ActualDisabledTextColor", b, this.ec);
            }
        }
        get ev() {
            return this.ej;
        }
        set ev(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.dx("DisabledTextColor", b, this.ej);
            }
        }
        get r() {
            return this.o;
        }
        set r(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.dx("ActualTextStyle", b, this.o);
            }
        }
        get t() {
            return this.q;
        }
        set t(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.dx("TextStyle", b, this.q);
            }
        }
        get ah() {
            return this.ab;
        }
        set ah(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.dx("IsDisabled", b, this.ab);
            }
        }
        get ag() {
            return this.c1 != null;
        }
        get cu() {
            return this.br;
        }
        set cu(a) {
            let b = this.br;
            this.br = a;
            if (b != this.br) {
                this.dx("Name", b, this.br);
            }
        }
        get da() {
            return this.bu;
        }
        set da(a) {
            let b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.dx("Title", b, this.bu);
            }
        }
        get c6() {
            return this.bt;
        }
        set c6(a) {
            let b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.dx("Subtitle", b, this.bt);
            }
        }
        get bh() {
            return this.az;
        }
        set bh(a) {
            this.az = a;
        }
        get cl() {
            return this.bq;
        }
        set cl(a) {
            let b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.dx("IconName", b, this.bq);
            }
        }
        get ci() {
            return this.bp;
        }
        set ci(a) {
            let b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.dx("IconCollectionName", b, this.bp);
            }
        }
        get ba() {
            return this.as;
        }
        set ba(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.dx("IconViewBoxLeft", b, this.as);
            }
        }
        get bb() {
            return this.at;
        }
        set bb(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.dx("IconViewBoxTop", b, this.at);
            }
        }
        get bc() {
            return this.au;
        }
        set bc(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.dx("IconViewBoxWidth", b, this.au);
            }
        }
        get a9() {
            return this.ar;
        }
        set a9(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.dx("IconViewBoxHeight", b, this.ar);
            }
        }
        get ex() {
            return this.el;
        }
        set ex(a) {
            let b = this.el;
            this.el = a;
            if (b != this.el) {
                this.dx("IconFill", b, this.el);
            }
        }
        get er() {
            return this.ee;
        }
        set er(a) {
            let b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.dx("ActualIconFill", b, this.ee);
            }
        }
        get ey() {
            return this.em;
        }
        set ey(a) {
            let b = this.em;
            this.em = a;
            if (b != this.em) {
                this.dx("IconStroke", b, this.em);
            }
        }
        get es() {
            return this.ef;
        }
        set es(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.dx("ActualIconStroke", b, this.ef);
            }
        }
        get e1() {
            return this.e0;
        }
        set e1(a) {
            let b = this.e0;
            this.e0 = a;
            if (b != this.e0) {
                this.dx("Visibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.e0));
            }
        }
        get_ad() {
            return true;
        }
        get ad() {
            return this.get_ad();
        }
        get_ae() {
            return true;
        }
        get ae() {
            return this.get_ae();
        }
        get_ai() {
            return true;
        }
        get ai() {
            return this.get_ai();
        }
        get_ak() {
            return true;
        }
        get ak() {
            return this.get_ak();
        }
        get_ac() {
            return true;
        }
        get ac() {
            return this.get_ac();
        }
        dx(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.d4(a, b, c);
        }
        get_m() {
            return 0;
        }
        get m() {
            return this.get_m();
        }
        d4(a, b, c) {
            switch (a) {
                case "Background":
                case "TextColor":
                case "TextStyle":
                    this.d9();
                    break;
                case "ActualBackground":
                    if (this.y != null) {
                        this.y.a4 = this.eo;
                    }
                    break;
                case "ActualTextColor":
                    if (this.aa != null) {
                        this.aa.a6 = this.et;
                    }
                    break;
                case "ActualTextStyle":
                    if (this.aa != null) {
                        this.aa.bg = this.r;
                    }
                    break;
                case "IsDisabled":
                    if (this.aa != null) {
                        this.aa.a6 = this.ah ? this.ep : this.et;
                    }
                    break;
                case "ActualIconFill":
                case "ActualIconStroke":
                    if (this.z != null) {
                        this.z.a7 = this.er;
                        this.z.a8 = this.es;
                    }
                    break;
                case "Visibility":
                    if (this.j != null) {
                        this.j.dx();
                    }
                    break;
                case "IconName":
                case "IconCollectionName":
                    this.dw();
                    break;
            }
        }
        d9() {
            if (this.j == null) {
                return;
            }
            this.l = this.j.r;
            this.eo = this.eu != null ? this.eu : this.ei;
            this.et = this.ez != null ? this.ez : this.j.e4;
            this.ep = this.ev != null ? this.ev : this.j.ev;
            this.eq = this.ew != null ? this.ew : this.j.ez;
            this.er = this.ex != null ? this.ex : this.j.e0;
            this.es = this.ey != null ? this.ey : this.j.e1;
            this.r = this.t != null ? this.t : this.p;
            this.a2 = !isNaN_(this.be) ? this.be : DeviceUtils.g(12);
            this.a3 = !isNaN_(this.bf) ? this.bf : DeviceUtils.g(12);
            this.a4 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(2);
            this.a1 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(2);
            this.ea();
        }
        ea() {
        }
        dw() {
            if (this.z != null) {
                this.z.bl = this.cl;
                this.z.bk = this.ci;
            }
        }
        dz(a, b, c, d) {
            this.dn(c.b, c, d, (e) => {
                this.de(c.b);
                this.x = e;
                this.dm(c.b, this.x, d, () => {
                    c.b.bo = this.x;
                    this.d7(this.w, this.z, this.aa);
                    this.d1(this.w == null ? this.x : this.w, c, d);
                });
            });
        }
        d1(a, b, c) {
        }
        d0(a, b, c, d) {
        }
        di(a, b) {
            this.dj(a, b);
        }
        dj(a, b) {
            b.f = this.a6(a, b);
            b.h = this.a8(a, b);
            b.g = this.a7(a, b);
            b.b = this.a5(a, b);
            if (b.a == 1) {
                let c = 0;
                if (!isNaN_(b.f)) {
                    c += b.f;
                }
                if (!isNaN_(b.h)) {
                    c += b.h;
                }
                if (!isNaN_(b.g)) {
                    c += b.g;
                }
                if (!isNaN_(b.b)) {
                    c += b.b;
                }
                c += (this.a2 + this.a3);
                b.e = c;
            }
            else {
                if (!isNaN_(this.bi)) {
                    b.e = this.bi;
                }
                else {
                    let d = 0;
                    if (!isNaN_(b.f)) {
                        d += b.f;
                    }
                    if (!isNaN_(b.h)) {
                        d += b.h;
                    }
                    if (!isNaN_(b.g)) {
                        d += b.g;
                    }
                    if (!isNaN_(b.b)) {
                        d += b.b;
                    }
                    d += (this.a2 + this.a3);
                    if (isNaN_(b.c) || isPositiveInfinity(b.c) || d > b.c) {
                        b.e = d;
                    }
                    else {
                        b.e = b.c;
                    }
                }
            }
        }
        a7(a, b) {
            return NaN;
        }
        a8(a, b) {
            if (this.da == null) {
                return NaN;
            }
            let c = this.s(a);
            let d = a.p.m(this.da, c);
            return d + this.bh;
        }
        a6(a, b) {
            if (!stringIsNullOrEmpty(this.cl)) {
                return DeviceUtils.g(36);
            }
            return NaN;
        }
        s(a) {
            return a.u();
        }
        a5(a, b) {
            return NaN;
        }
        dy(a, b) {
            this.d5();
            if (this.ag) {
                let c = this.j.f(this.c1);
                if (c != null) {
                    c.dt(this);
                }
            }
            else {
                if (this.j.ab(this)) {
                    if (this.performed != null) {
                        let d = new ToolActionEventDetailCollection();
                        this.dh(this, d, b);
                        this.performed(this, ((() => {
                            let $ret = new ToolActionPerformedEventArgs();
                            $ret.c = true;
                            $ret.b = d;
                            return $ret;
                        })()));
                    }
                }
                else {
                    if (this.performed != null) {
                        this.performed(this, ((() => {
                            let $ret = new ToolActionPerformedEventArgs();
                            $ret.c = false;
                            $ret.a = a;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        d5() {
            let a = this.c4();
            if (a == null) {
                return;
            }
            let b = new ToolCommand();
            b.commandId = a;
            let c = new List$1(ToolCommandArgument.$, 0);
            this.dg(this, c);
            b.argumentsList = c.toArray();
            if (this.onCommand != null) {
                this.onCommand(this, ((() => {
                    let $ret = new ToolCommandEventArgs();
                    $ret.a = b;
                    return $ret;
                })()));
            }
            if (this.j != null) {
                this.j.dp(this, b);
            }
        }
        d6(a) {
            if (this.onCommand != null) {
                this.onCommand(this, ((() => {
                    let $ret = new ToolCommandEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
            if (this.j != null) {
                this.j.dp(this, a);
            }
        }
        al() {
            return this.onCommand != null;
        }
        dg(a, b) {
            let c = a.n();
            if (c != null) {
                b.add(c);
            }
            let d = this.j.ag(a);
            if (d != null) {
                for (let e = 0; e < d.count; e++) {
                    if (d._inner[e].af()) {
                        this.dg(d._inner[e], b);
                    }
                }
            }
        }
        af() {
            return true;
        }
        dt(a) {
            if (this.ag) {
                let b = this.j.f(this.c1);
                if (b != null) {
                    b.dt(a);
                }
            }
            else {
                this.dy(this.g(false), a);
            }
        }
        dh(a, b, c) {
            let d = a.g(a == c);
            b.add(d);
            let e = this.j.ag(a);
            if (e != null) {
                for (let f = 0; f < e.count; f++) {
                    this.dh(e._inner[f], b, c);
                }
            }
        }
        static c(a) {
            let b = null;
            switch (a.b) {
                case 2:
                    b = new ToolActionCheckbox();
                    break;
                case 1:
                    b = new ToolActionGroupHeader();
                    break;
                case 3:
                    b = new ToolActionIconButton();
                    break;
                case 4:
                    b = new ToolActionLabel();
                    break;
                case 5:
                    b = new ToolActionNumberInput();
                    break;
                case 6:
                    b = new ToolActionRadio();
                    break;
                case 7:
                    b = new ToolActionSeparator();
                    break;
                case 8:
                    b = new ToolActionIconMenu();
                    break;
                case 9:
                    b = new ToolActionButton();
                    break;
                case 0: return null;
            }
            b.dp(a);
            return b;
        }
        dp(a) {
            this.cu = a.name;
            this.da = a.title;
            this.ca = a.commandArgument;
            this.bk = a.commandArgumentValue;
            this.cd = a.commandId;
            this.cl = a.iconName;
            this.ci = a.iconCollectionName;
            this.ba = a.iconViewBoxLeft;
            this.bb = a.iconViewBoxTop;
            this.bc = a.iconViewBoxWidth;
            this.a9 = a.iconViewBoxHeight;
            this.be = a.paddingLeft;
            this.bf = a.paddingRight;
            this.bg = a.paddingTop;
            this.bd = a.paddingBottom;
            this.c1 = a.parentId;
            this.ah = a.isDisabled;
            if (!stringIsNullOrEmpty(a.textColor)) {
                this.ez = CSSColorUtil.a(a.textColor);
            }
            if (!stringIsNullOrEmpty(a.disabledTextColor)) {
                this.ev = CSSColorUtil.a(a.disabledTextColor);
            }
            if (a.actions != null && a.actions.length > 0) {
                for (let b = 0; b < a.actions.length; b++) {
                    this.actions.add(ToolAction.c(a.actions[b]));
                }
            }
        }
        aj() {
            return this.d != null && this.d.d != null && this.d.actions._inner[0] == this;
        }
        am() {
            return true;
        }
        v(a) {
            switch (a) {
                case 1:
                case 6:
                case 11:
                case 10:
                case 2:
                case 12:
                case 13: return this.am() ? 2 : 0;
                default: return 0;
            }
        }
        get y() {
            return this.x;
        }
        dn(a, b, c, d) {
            if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                NativeUIComponent.ar(this.j.p.v(), 7, (e) => {
                    let f = e;
                    this.dl(f, c);
                    this.d8(f, b, c);
                    if (d != null) {
                        d(f);
                    }
                });
            }
            else {
                let e = a.bo;
                this.d8(e, b, c);
                if (d != null) {
                    d(e);
                }
            }
        }
        dm(a, b, c, d) {
            if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                let e = [1, 7, 11, 3];
                let f = [this.v(1), this.v(7), this.v(11), this.v(3)];
                NativeUIComponent.as(this.j.p.v(), e, f, (g) => {
                    let h = g[0];
                    let i = g[1];
                    let j = g[2];
                    let k = g[3];
                    this.dk(h, i, j, k, c);
                    if (d != null) {
                        d();
                    }
                });
            }
            else {
                this.d7(this.w, this.z, this.aa);
                if (d != null) {
                    d();
                }
            }
        }
        dl(a, b) {
            a.f = b.a == 1 ? 0 : 3;
            a.bo = 0;
        }
        d8(a, b, c) {
            a.x = b.a.k;
            a.a4 = this.eo;
            a.bf = this.e1;
        }
        dk(a, b, c, d, e) {
            if (this.x.bi == 0) {
                this.x.bw(0, 2, 1);
                this.x.by(0, 2, 1);
                this.x.bj(a);
                this.x.b3(a, 0);
                this.x.b4(a, 0);
                a.bj = b;
                b.bo = 0;
                let f = this.a6(this.j, e);
                f = isNaN_(f) ? 0 : f;
                let g = this.a8(this.j, e);
                g = isNaN_(g) ? 0 : g - this.bh;
                b.by(0, 2, 1);
                b.bw(0, 1, f);
                b.bw(1, 1, g);
                b.bx(2, 2, 1, this.bh);
                b.bj(c);
                b.bj(d);
                b.b4(d, 0);
                b.b3(c, 0);
                b.b3(d, 1);
            }
            a.c = this.l;
            a.bk = 1;
            a.bi = 1;
            a.bu = new Thickness(1, 0, 0, 0, 0);
            a.g = 3;
            a.i = 3;
            a.bt = this.eq;
            a.bq = true;
            a.bo = !this.ad;
            a.bl = this.ac;
            a.bn = !this.ae;
            a.bp = true;
            a.bm = true;
            a.bh = runOn(this, this.ds);
            c.h = 1;
            c.f = 1;
            d.bh = false;
            d.h = 1;
            d.f = 0;
            this.w = b;
            this.u = a;
            this.z = c;
            this.aa = d;
        }
        ds(a, b) {
            this.dv();
        }
        d7(a, b, c) {
            if (a != null) {
                a.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
            }
            if (b != null) {
                b.bd = new Thickness(1, 0, 0, 9, 0);
                b.bh = this.ba;
                b.bi = this.bb;
                b.bj = this.bc;
                b.bg = this.a9;
                b.bl = this.cl;
                b.bk = this.ci;
                b.a7 = this.er;
                b.a8 = this.es;
                b.ad = 28;
                b.x = 28;
            }
            if (c != null) {
                c.bi = this.da;
                c.bg = this.r;
                c.a6 = this.ah ? this.ep : this.et;
            }
        }
        de(a) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (this.x != null) {
                    this.x.bq = null;
                }
            }
        }
        dv() {
        }
        du(a, b) {
        }
        d2() {
        }
        df() {
        }
        d3(a) {
            if (!stringIsNullOrEmpty(a.da)) {
                this.da = a.da;
            }
            if (!stringIsNullOrEmpty(a.c6)) {
                this.c6 = a.c6;
            }
            if (!stringIsNullOrEmpty(a.cl)) {
                this.cl = a.cl;
            }
            if (!stringIsNullOrEmpty(a.ci)) {
                this.ci = a.ci;
            }
            if (!stringIsNullOrEmpty(a.cd)) {
                this.cd = a.cd;
            }
            if (!stringIsNullOrEmpty(a.ca)) {
                this.ca = a.ca;
            }
            if (a.bk != null) {
                this.bk = a.bk;
            }
            if (a.eu != null) {
                this.eu = a.eu;
            }
            if (a.ew != null) {
                this.ew = a.ew;
            }
            if (a.ez != null) {
                this.ez = a.ez;
            }
            if (a.t != null) {
                this.t = a.t;
            }
            if (a.ev != null) {
                this.ev = a.ev;
            }
            if (a.ex != null) {
                this.ex = a.ex;
            }
            if (a.ey != null) {
                this.ey = a.ey;
            }
            if (!isNaN_(a.be)) {
                this.be = a.be;
            }
            if (!isNaN_(a.bg)) {
                this.bg = a.bg;
            }
            if (!isNaN_(a.bf)) {
                this.bf = a.bf;
            }
            if (!isNaN_(a.bd)) {
                this.bd = a.bd;
            }
            if (!isNaN_(a.bi)) {
                this.bi = a.bi;
            }
            if (this.e1 != a.e1) {
                this.e1 = a.e1;
            }
            if (a.actions != null && a.actions.count > 0) {
                this.actions.clear();
                for (let b = 0; b < a.actions.count; b++) {
                    this.actions.add(a.actions._inner[b]);
                }
            }
        }
    }
    ToolAction.$t = /*@__PURE__*/ markType(ToolAction, 'ToolAction', Base.$, [INotifyPropertyChanged_$type]);
    return ToolAction;
})();
/**
 * @hidden
 */
export let ToolActionButton = /*@__PURE__*/ (() => {
    class ToolActionButton extends ToolAction {
        constructor() {
            super(...arguments);
            this.e2 = null;
        }
        get_m() {
            return 9;
        }
        n() {
            return null;
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.a = this;
            b.b = this.m;
            b.d = a;
            return b;
        }
        a8(a, b) {
            return NaN;
        }
        a7(a, b) {
            return 88;
        }
        e4(a, b, c, d, e, f, g) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                a.bo = b;
                if (g.a == 1) {
                    b.f = 0;
                }
                else {
                    b.f = 3;
                }
                b.by(0, 2, 1);
                b.bw(0, 0, 1);
                b.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
                if (b.bi == 0) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 0);
                this.e2 = c;
                this.e2.bk = 2;
                this.e2.bh = runOn(this, this.e3);
            }
            c.bs = this.da;
            b.x = f.a.k;
        }
        e3(a, b) {
            this.dy(this.g(true), this);
        }
        d0(a, b, c, d) {
            super.d0(a, b, c, d);
            let e = c.b;
            if (e.bo == null || (e.am == null || EnumUtil.getEnumValue(ToolActionType_$type, e.am) != this.m)) {
                let f = [7, 1];
                let g = [0, 0];
                if (this.l >= 3 && this.l <= 6) {
                    g = [0, 2];
                }
                NativeUIComponent.as(b.p.v(), f, g, (h) => {
                    let i = h[0];
                    let j = h[1];
                    e.bo = i;
                    this.e4(e, i, j, a, b, c, d);
                });
                e.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let h = e.bo;
                let i = h.bh(0);
                this.e4(e, h, i, a, b, c, d);
            }
        }
    }
    ToolActionButton.$t = /*@__PURE__*/ markType(ToolActionButton, 'ToolActionButton', ToolAction.$);
    return ToolActionButton;
})();
/**
 * @hidden
 */
export let ToolActionLabel = /*@__PURE__*/ (() => {
    class ToolActionLabel extends ToolAction {
        get_ad() {
            return this.al() || this.actions.count > 0;
        }
        constructor() {
            super();
            this.e2 = null;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarDrillDownIcon") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarDrillDownIcon", ToolActionLabel.e3);
            }
        }
        get_m() {
            return 4;
        }
        a7(a, b) {
            return this.actions.count > 0 ? DeviceUtils.g(32) : super.a7(a, b);
        }
        e4(a, b, c, d) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (b.bi == 2) {
                    let e = this.a7(this.j, d);
                    b.bw(3, 1, isNaN_(e) ? 0 : e);
                    b.bj(c);
                    b.b3(c, 3);
                    b.b4(c, 0);
                    c.bl = "ToolbarDrillDownIcon";
                    c.bk = "IG_Default";
                    c.f = 1;
                    c.h = 1;
                }
            }
            c.a7 = this.et;
        }
        dv() {
            if (this.actions.count > 0) {
                this.j.dy(this);
            }
            else {
                this.dy(this.g(false), this);
            }
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                if (this.actions.count > 0) {
                    NativeUIComponent.aq(this.j.p.v(), 11, this.am() ? 2 : 0, (e) => {
                        this.e2 = e;
                        this.e4(d, a, this.e2, c);
                    });
                }
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                if (this.actions.count > 0) {
                    this.e2 = a.bh(2);
                    this.e4(d, a, this.e2, c);
                }
            }
        }
        d4(a, b, c) {
            super.d4(a, b, c);
            switch (a) {
                case "ActualTextColor":
                    if (this.e2 != null) {
                        this.e2.a6 = this.et;
                    }
                    break;
            }
        }
    }
    ToolActionLabel.$t = /*@__PURE__*/ markType(ToolActionLabel, 'ToolActionLabel', ToolAction.$);
    ToolActionLabel.e3 = "M 7.42 8.58 L 12 13.17 L 7.42 17.76 L 8.83 19.17 l 6 -6 l -6 -6 z";
    return ToolActionLabel;
})();
/**
 * @hidden
 */
export let ToolActionRadio = /*@__PURE__*/ (() => {
    class ToolActionRadio extends ToolAction {
        constructor() {
            super(...arguments);
            this.e2 = null;
            this.e5 = "channel_1";
            this.e3 = false;
        }
        get_m() {
            return 6;
        }
        get e6() {
            return this.e5;
        }
        set e6(a) {
            this.e5 = a;
        }
        get e4() {
            return this.e3;
        }
        set e4(a) {
            let b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.dx("IsChecked", b, this.e3);
            }
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.a = this;
            b.b = this.m;
            b.d = a;
            if (this.e2 != null) {
                b.c = this.e2.bj;
            }
            return b;
        }
        bm() {
            return this.e2.bj;
        }
        e8() {
            if (this.e2 != null) {
                this.e2.bj = false;
                this.e3 = this.e2.bj;
            }
        }
        a7(a, b) {
            return 30;
        }
        ea() {
            if (this.e2 != null) {
                this.e2.c = this.l;
            }
        }
        dv() {
            this.e2.bj = true;
            this.e3 = this.e2.bj;
            this.dy(this.g(true), this);
        }
        e9(a, b) {
            if (this.e3) {
                this.e2.bj = true;
                return;
            }
            this.e3 = this.e2.bj;
            this.dy(this.g(true), this);
        }
        fa(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                b.bw(3, 1, this.a7(this.j, e));
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                this.e2 = c;
                c.bi = true;
                c.f = 1;
                c.h = 1;
                c.bk = DeviceUtils.g(10);
                c.ad = DeviceUtils.g(20);
                c.x = DeviceUtils.g(20);
                c.bh = runOn(this, this.e9);
                a.am = enumGetBox(ToolActionType_$type, this.m);
            }
            this.e2.bj = this.e3;
            this.e2.c = this.l;
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                NativeUIComponent.aq(this.j.p.v(), 6, this.v(6), (e) => {
                    let f = e;
                    this.fa(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(2);
                this.fa(d, a, e, b, c);
            }
        }
        d4(a, b, c) {
            super.d4(a, b, c);
            switch (a) {
                case "IsChecked":
                    if (this.e2 != null) {
                        this.e2.bj = this.e4;
                    }
                    break;
            }
        }
        dp(a) {
            super.dp(a);
            let b = a;
            this.e4 = b.isChecked;
            this.e6 = b.channel;
        }
    }
    ToolActionRadio.$t = /*@__PURE__*/ markType(ToolActionRadio, 'ToolActionRadio', ToolAction.$);
    return ToolActionRadio;
})();
/**
 * @hidden
 */
export let ToolActionSeparator = /*@__PURE__*/ (() => {
    class ToolActionSeparator extends ToolAction {
        get e5() {
            return this.e4;
        }
        set e5(a) {
            let b = this.e4;
            this.e4 = a;
            if (b != this.e4) {
                this.dx("Size", b, this.e4);
            }
        }
        get e3() {
            return this.e2;
        }
        set e3(a) {
            let b = this.e2;
            this.e2 = a;
            if (b != this.e2) {
                this.dx("IsGroupHeaderSeparator", b, this.e2);
            }
        }
        constructor() {
            super();
            this.e4 = DeviceUtils.g(2);
            this.e2 = false;
        }
        get_m() {
            return 7;
        }
        dj(a, b) {
            super.dj(a, b);
            if (b.a == 1) {
                b.e = this.a2 + this.e5 + this.a3;
            }
            else {
                b.d = this.a4 + this.e5 + this.a1;
            }
        }
        dm(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        dl(a, b) {
            if (b.a == 1) {
                a.f = 0;
                a.h = 3;
            }
            else {
                a.f = 3;
            }
        }
        d8(a, b, c) {
            if (c.a == 1) {
                a.ad = this.e5;
            }
            else {
                a.x = this.e5;
            }
            a.bd = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
            a.a4 = this.eo;
            a.bf = this.e1;
        }
        ea() {
            super.ea();
            this.eo = this.eu != null ? this.eu : !this.e3 ? this.j.e2 : this.j.ex;
            if (this.j.o == 1) {
                this.a2 = !isNaN_(this.be) ? this.be : this.j.a4;
                this.a3 = !isNaN_(this.bf) ? this.bf : this.j.a5;
                this.a4 = !isNaN_(this.bg) ? this.bg : this.j.a6;
                this.a1 = !isNaN_(this.bd) ? this.bd : this.j.a3;
            }
            else {
                this.a2 = !isNaN_(this.be) ? this.be : this.j.a8;
                this.a3 = !isNaN_(this.bf) ? this.bf : this.j.a9;
                this.a4 = !isNaN_(this.bg) ? this.bg : this.j.ba;
                this.a1 = !isNaN_(this.bd) ? this.bd : this.j.a7;
            }
        }
        d4(a, b, c) {
            super.d4(a, b, c);
            switch (a) {
                case "Size":
                    if (this.j != null) {
                        this.j.dx();
                    }
                    break;
                case "IsGroupHeaderSeparator":
                    this.d9();
                    break;
            }
        }
        dp(a) {
            super.dp(a);
            let b = a;
            this.e5 = b.size;
            this.e3 = b.isGroupHeaderSeparator;
        }
    }
    ToolActionSeparator.$t = /*@__PURE__*/ markType(ToolActionSeparator, 'ToolActionSeparator', ToolAction.$);
    return ToolActionSeparator;
})();
/**
 * @hidden
 */
export let ToolActionIconButton = /*@__PURE__*/ (() => {
    class ToolActionIconButton extends ToolAction {
        get_m() {
            return 3;
        }
        get_ak() {
            return false;
        }
        get e8() {
            return this.e7;
        }
        get_fg() {
            return this.e3 != null;
        }
        get fg() {
            return this.get_fg();
        }
        get ff() {
            return this.fc;
        }
        set ff(a) {
            this.fc = a;
        }
        get fk() {
            return this.fj;
        }
        set fk(a) {
            this.fj = a;
        }
        constructor() {
            super();
            this.e7 = null;
            this.e3 = null;
            this.e2 = null;
            this.fh = -1;
            this.fi = -1;
            this.fd = false;
            this.fa = false;
            this.e9 = false;
            this.fc = false;
            this.fj = 500;
            this.fe = false;
            this.e4 = null;
            this.e6 = null;
            this.e5 = null;
            this.fb = false;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "igDropDownArrow") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "igDropDownArrow", "M0,0L3,3L6,0");
            }
            this.e2 = new DelayManager(0);
        }
        dd() {
            super.dd();
            NativeUIWindow.d(14, runOn(this, this.f0));
            this.e9 = false;
        }
        n() {
            return null;
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.a = this;
            b.b = this.m;
            b.d = a;
            return b;
        }
        a6(a, b) {
            return DeviceUtils.g(36);
        }
        a8(a, b) {
            return NaN;
        }
        dm(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        de(a) {
            super.de(a);
        }
        f2(a, b, c, d, e) {
            let f = c.bj;
            if (e) {
                b.b1(2);
                b.b1(1);
                if (b.bi == 0) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 0);
                c.c = this.l;
                c.bk = 2;
                c.bi = 4;
                c.bp = true;
                f.ad = DeviceUtils.g(28);
                f.x = DeviceUtils.g(28);
            }
            b.br = false;
            b.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
            f.bl = this.cl;
            f.bk = this.ci;
            f.bh = this.ba;
            f.bi = this.bb;
            f.bj = this.bc;
            f.bg = this.a9;
            f.a7 = this.et;
            f.a8 = this.et;
            if (this.e4 != c) {
                c.bh = runOn(this, this.fr);
                c.q = runOn(this, this.ft);
                c.s = runOn(this, this.fu);
                c.o = runOn(this, this.fs);
                this.e4 = c;
            }
            if (this.e6 != f) {
                this.e6 = f;
            }
        }
        f3(a, b) {
            if (this.e7 != b) {
                this.e7 = b;
                this.e7.bz = this.j.bb;
                this.e7.b6 = BrushUtil.g(255, 255, 255, 255);
                this.e7.bo = 1;
                this.e7.bw = true;
                this.e7.b0 = 100;
                this.e7.bv = true;
                this.e7.b1 = truncate(this.j.bc);
                this.e7.bx = true;
                this.e7.bt = 0;
                if (a.bi != 2) {
                    a.bj(this.e7);
                }
                this.fm();
                this.e7.q = runOn(this, this.fy);
                this.e7.s = runOn(this, this.fz);
                this.e7.n = runOn(this, this.fw);
                this.e7.o = runOn(this, this.fx);
                if (!this.e9) {
                    NativeUIWindow.c(14, runOn(this, this.f0));
                    this.e9 = true;
                }
            }
            if (this.actions.count > 0) {
                this.e7.u = true;
            }
            else {
                this.e7.u = false;
            }
        }
        fm() {
            if (this.e7.bi == 0) {
                this.e3 = new TooltipTextPresenter(this.j.p.v());
                this.e3.s(() => this.e7.bj(this.e3.e));
            }
            else {
                this.e3 = this.e7.bh(0).am;
            }
            this.e3.x = this.j.e5;
            this.e3.y = this.j.e6;
            this.e3.o = this.da;
            this.e7.b7 = this.e3.x;
        }
        fo() {
        }
        fn() {
        }
        fp() {
            if (this.e3 != null) {
                this.e7.b7 = this.j.e5;
                this.e3.x = this.j.e5;
                this.e3.y = this.j.e6;
                this.e7.bz = this.j.bb;
                this.e7.b1 = truncate(this.j.bc);
            }
        }
        f0() {
            if (this.e4 != null) {
                let a = this.e4.ba();
                this.e7.b4(a);
            }
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                NativeUIComponent.as(this.j.p.v(), [10, 12], [this.v(10), this.v(12)], (e) => {
                    this.f2(d, a, e[0], c, true);
                    this.f3(a, e[1]);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(0);
                let f = a.bh(1);
                this.f2(d, a, e, c, false);
                this.f3(a, f);
            }
        }
        ea() {
            super.ea();
            this.a2 = !isNaN_(this.be) ? this.be : DeviceUtils.g(4);
            this.a3 = !isNaN_(this.bf) ? this.bf : DeviceUtils.g(4);
            if (this.e4 != null) {
                this.e4.c = this.l;
                if (typeCast(NativeUIIconButton.$, this.e4) !== null) {
                    this.e4.a7 = this.et;
                    this.e4.a8 = this.et;
                }
            }
            if (this.e6 != null) {
                this.e6.a7 = this.et;
                this.e6.a8 = this.et;
            }
            if (this.e5 != null) {
                this.e5.a8 = this.et;
            }
            this.fp();
        }
        dw() {
            if (this.e6 != null) {
                this.e6.bl = this.cl;
                this.e6.bk = this.ci;
            }
        }
        d2() {
            if (this.actions.count > 0) {
                if (this.e7 == null || !this.fg) {
                    this.fc = true;
                }
                else {
                    this.f1();
                    this.fd = true;
                }
            }
        }
        df() {
            if (this.actions.count > 0) {
                if (this.e7 == null || !this.fg) {
                    this.fc = false;
                }
                else {
                    this.fl();
                }
            }
        }
        f1(a = false) {
            if (!this.fe) {
                this.j.dc();
                if (this.actions.count == 0 && stringIsNullOrEmpty(this.da)) {
                    return;
                }
                let b = this.e4.ba();
                this.e7.b5(b, 1, 3);
                this.fe = true;
                this.fo();
            }
            this.fd = a;
            this.fc = false;
        }
        fl() {
            if (this.fe) {
                this.e7.b2();
                this.fe = false;
                this.e2.f(() => this.fn(), 100);
                this.fd = false;
            }
        }
        fv() {
            this.f1();
            this.fi = -1;
        }
        fq() {
            this.fl();
            this.fh = -1;
        }
        ft(a, b) {
            this.fa = true;
            if (this.fh != -1) {
                this.e2.g(this.fh);
                this.fh = -1;
            }
            if (!this.fe) {
                if (this.actions.count > 0 && !this.j.ac) {
                    return;
                }
                this.fi = this.e2.f(runOn(this, this.fv), this.fk);
            }
        }
        fu(a, b) {
            if (this.fi != -1) {
                this.e2.g(this.fi);
                this.fi = -1;
            }
            if (this.fe && !this.fd) {
                this.fh = this.e2.f(runOn(this, this.fq), 50);
            }
            this.fa = false;
        }
        fr(a, b) {
            if (this.actions.count > 0) {
                if (!this.fe) {
                    if (this.fi != -1) {
                        this.e2.g(this.fi);
                        this.fi = -1;
                    }
                    this.f1();
                    this.fd = true;
                }
                else {
                    this.fl();
                }
            }
            else {
                this.dy(this.g(true), this);
            }
        }
        fy(a, b) {
            this.fb = true;
            if (this.fh != -1) {
                this.e2.g(this.fh);
                this.fh = -1;
            }
        }
        fz(a, b) {
            if (!this.fd) {
                this.fh = this.e2.f(runOn(this, this.fq), 50);
            }
            this.fb = false;
        }
        fw(a, b) {
            this.fd = true;
        }
        fx(a, b) {
            if (!this.e7.t(b.a) && !this.e4.t(b.a)) {
                this.fl();
            }
        }
        fs(a, b) {
            if (this.fe) {
                if (!this.e7.t(b.a) && !this.e4.t(b.a)) {
                    this.fl();
                }
            }
        }
        d4(a, b, c) {
            super.d4(a, b, c);
            switch (a) {
                case "ExecutionContext":
                    this.e2.b = this.b;
                    break;
                case "Title":
                    if (this.e3 != null) {
                        this.e3.o = this.da;
                    }
                    break;
            }
        }
        dp(a) {
            super.dp(a);
            let b = a;
            this.fk = b.tooltipDelay;
            if (b.isMenuOpenOnStart) {
                this.d2();
            }
        }
    }
    ToolActionIconButton.$t = /*@__PURE__*/ markType(ToolActionIconButton, 'ToolActionIconButton', ToolAction.$);
    return ToolActionIconButton;
})();
/**
 * @hidden
 */
export let ToolActionGroupHeader = /*@__PURE__*/ (() => {
    class ToolActionGroupHeader extends ToolAction {
        get_m() {
            return 1;
        }
        get_ad() {
            return false;
        }
        get_ae() {
            return false;
        }
        get_ai() {
            return false;
        }
        get fb() {
            return this.e9;
        }
        set fb(a) {
            let b = this.e9;
            this.e9 = a;
            if (b != this.e9) {
                this.dx("ActualBackIconColor", b, this.e9);
            }
        }
        get fc() {
            return this.fa;
        }
        set fc(a) {
            let b = this.fa;
            this.fa = a;
            if (b != this.fa) {
                this.dx("BackIconColor", b, this.fa);
            }
        }
        constructor() {
            super();
            this.e2 = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Bold";
                $ret.o = "Normal";
                return $ret;
            })());
            this.e3 = null;
            this.e9 = null;
            this.fa = null;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarBackButton") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarBackButton", ToolActionGroupHeader.e5);
            }
        }
        s(a) {
            return this.e2;
        }
        a5(a, b) {
            return this.aj() ? DeviceUtils.g(36) : NaN;
        }
        e8(a, b, c, d) {
            let e = c.bj;
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (b.bi == 2) {
                    b.bj(c);
                    b.bz(0, 1, this.a5(this.j, d));
                    b.b3(b.bh(0), 1);
                    b.b3(b.bh(1), 2);
                    b.b3(c, 0);
                    b.b4(c, 0);
                    c.c = this.l;
                    c.h = 1;
                    c.f = 1;
                    c.bd = new Thickness(1, -9, 0, 9, 0);
                    c.bh = runOn(this, this.e7);
                    this.e3 = c;
                    e.bl = "ToolbarBackButton";
                    e.bk = "IG_Default";
                }
            }
            e.a7 = this.fb;
        }
        e7(a, b) {
            this.j.dz(this);
        }
        de(a) {
            super.de(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (this.aj() && this.e3 != null) {
                    this.e3.bh = null;
                }
            }
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                if (this.aj()) {
                    NativeUIComponent.aq(this.j.p.v(), 10, this.am() ? 2 : 0, (e) => this.e8(d, a, e, c));
                }
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                if (this.aj()) {
                    let e = a.bh(2);
                    this.e8(d, a, e, c);
                }
            }
        }
        ea() {
            super.ea();
            if (this.e3 != null) {
                this.e3.c = this.l;
            }
            this.eo = this.eu != null ? this.eu : this.j.ew;
            this.et = this.ez != null ? this.ez : this.j.ey;
            this.fb = this.fc != null ? this.fc : this.et;
            this.r = this.t != null ? this.t : this.e2;
        }
    }
    ToolActionGroupHeader.$t = /*@__PURE__*/ markType(ToolActionGroupHeader, 'ToolActionGroupHeader', ToolAction.$);
    ToolActionGroupHeader.e5 = "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z";
    return ToolActionGroupHeader;
})();
/**
 * @hidden
 */
export let ToolActionIconMenu = /*@__PURE__*/ (() => {
    class ToolActionIconMenu extends ToolActionIconButton {
        constructor() {
            super(...arguments);
            this.f4 = null;
        }
        get_m() {
            return 8;
        }
        get_fg() {
            return this.f4 != null;
        }
        fm() {
            if (this.e8.bi > 0) {
                while (this.e8.bi > 0) {
                    this.e8.bm(0);
                }
            }
            if (this.f4 != null) {
                this.f4.s = null;
            }
            this.f4 = new ToolPanelsPresenter(this.j.p.v(), this.b);
            this.f4.n = this.l;
            this.f4.ai(() => {
                this.f4.ae(this, (a) => {
                    this.f4.aj(a);
                    if (this.actions._inner[0].eo != null && !BrushUtilCore.a(this.actions._inner[0].eo)) {
                        this.e8.b7 = this.actions._inner[0].eo;
                    }
                    else {
                        this.e8.b7 = this.j.e3;
                    }
                    if (this.ff) {
                        this.b.executeDelayed(() => this.f1(true), 100);
                    }
                });
                this.f4.r.a3 = new CornerRadius(0, 8);
                this.f4.r.a4 = this.j.e3;
                this.e8.bj(this.f4.r);
            });
            this.f4.s = runOn(this, this.f5);
        }
        fo() {
            if (this.f4 != null) {
                this.f4.am();
            }
        }
        fn() {
            if (this.f4 != null) {
                this.f4.aw();
                this.e8.b3();
            }
        }
        fp() {
            if (this.f4 != null) {
                this.f4.ax(this.l, this.j);
                if (this.actions._inner[0].eo != null && !BrushUtilCore.a(this.actions._inner[0].eo)) {
                    this.e8.b7 = this.actions._inner[0].eo;
                }
                else {
                    this.e8.b7 = this.j.e3;
                }
                this.e8.bz = 8;
                this.e8.b1 = 4;
            }
        }
        f6(a, b, c, d, e, f, g) {
            if (g) {
                a.b1(2);
                a.b1(1);
                if (a.bi == 0) {
                    c.bw(0, 1, DeviceUtils.g(28));
                    c.bw(1, 1, DeviceUtils.g(6));
                    c.bj(d);
                    c.bj(e);
                    c.b3(d, 0);
                    c.b3(e, 1);
                    b.bj = c;
                    a.bj(b);
                }
                a.b4(b, 0);
                a.b3(b, 0);
                b.c = this.l;
                b.bk = 2;
                b.bi = 4;
                b.bp = true;
                d.ad = DeviceUtils.g(28);
                d.x = DeviceUtils.g(28);
                d.h = 1;
                e.ad = DeviceUtils.g(6);
                e.x = DeviceUtils.g(3);
                e.h = 1;
                e.bd = new Thickness(1, -4, 0, 0, 0);
                e.bl = "igDropDownArrow";
                e.bk = "IG_Default";
                e.bh = 0;
                e.bi = 0;
                e.bj = 6;
                e.bg = 3;
                e.a7 = BrushUtil.g(0, 0, 0, 0);
                e.ab = DeviceUtils.g(1);
            }
            a.br = false;
            a.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
            d.bl = this.cl;
            d.bk = this.ci;
            d.bh = this.ba;
            d.bi = this.bb;
            d.bj = this.bc;
            d.bg = this.a9;
            d.a7 = this.et;
            d.a8 = this.et;
            e.a8 = this.et;
            if (this.e4 != b) {
                b.bh = runOn(this, this.fr);
                b.q = runOn(this, this.ft);
                b.s = runOn(this, this.fu);
                b.o = runOn(this, this.fs);
                this.e4 = b;
            }
            if (this.e6 != d) {
                this.e6 = d;
            }
            if (this.e5 != e) {
                this.e5 = e;
            }
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                let e = [1, 7, 11, 11, 12];
                let f = [this.v(1), this.v(7), this.v(11), this.v(11), this.v(12)];
                NativeUIComponent.as(this.j.p.v(), e, f, (g) => {
                    this.f6(a, g[0], g[1], g[2], g[3], c, true);
                    this.f3(a, g[4]);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let g = a.bh(0);
                let h = g.bj;
                let i = h.bh(0);
                let j = h.bh(1);
                let k = a.bh(1);
                this.f6(a, g, h, i, j, c, false);
                this.f3(a, k);
            }
        }
        f5(a) {
            this.d6(a.a);
        }
    }
    ToolActionIconMenu.$t = /*@__PURE__*/ markType(ToolActionIconMenu, 'ToolActionIconMenu', ToolActionIconButton.$);
    return ToolActionIconMenu;
})();
/**
 * @hidden
 */
export let ToolActionCheckbox = /*@__PURE__*/ (() => {
    class ToolActionCheckbox extends ToolAction {
        constructor() {
            super(...arguments);
            this.e2 = null;
            this.e3 = false;
        }
        get_m() {
            return 2;
        }
        get_ac() {
            return false;
        }
        get e4() {
            return this.e3;
        }
        set e4(a) {
            let b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.dx("IsChecked", b, this.e3);
            }
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.a = this;
            b.b = this.m;
            b.d = a;
            if (this.e2 != null) {
                b.c = this.e2.bj;
            }
            return b;
        }
        bm() {
            return this.e2.bj;
        }
        a7(a, b) {
            return DeviceUtils.g(32);
        }
        de(a) {
            super.de(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                if (this.e2 != null) {
                    this.e2.bh = null;
                }
            }
        }
        dv() {
            this.e2.bj = !this.e2.bj;
            this.e3 = this.e2.bj;
            this.dy(this.g(true), this);
        }
        e7(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                b.bw(3, 1, this.a7(this.j, e));
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                this.e2 = c;
                c.bi = true;
                c.f = 1;
                c.h = 1;
                c.ad = DeviceUtils.g(20);
                c.x = DeviceUtils.g(20);
                c.bh = runOn(this, this.e6);
            }
            this.e2.bj = this.e3;
            this.e2.c = this.l;
        }
        e6(a, b) {
            this.e3 = this.e2.bj;
            this.dy(this.g(true), this);
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
                NativeUIComponent.aq(this.j.p.v(), 6, this.v(6), (e) => {
                    let f = e;
                    this.e7(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(2);
                this.e7(d, a, e, b, c);
            }
        }
        ea() {
            if (this.e2 != null) {
                this.e2.c = this.l;
            }
        }
        d4(a, b, c) {
            super.d4(a, b, c);
            switch (a) {
                case "IsChecked":
                    if (this.e2 != null) {
                        this.e2.bj = this.e3;
                    }
                    break;
            }
        }
        dp(a) {
            super.dp(a);
            let b = a;
            this.e4 = b.isChecked;
        }
    }
    ToolActionCheckbox.$t = /*@__PURE__*/ markType(ToolActionCheckbox, 'ToolActionCheckbox', ToolAction.$);
    return ToolActionCheckbox;
})();
/**
 * @hidden
 */
export let ToolActionNumberInput = /*@__PURE__*/ (() => {
    class ToolActionNumberInput extends ToolAction {
        constructor() {
            super(...arguments);
            this.e2 = null;
            this.e3 = 0;
        }
        get_m() {
            return 5;
        }
        get e5() {
            return this.e3;
        }
        set e5(a) {
            let b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.dx("Value", b, this.e3);
            }
        }
        bm() {
            return this.e4();
        }
        a7(a, b) {
            return DeviceUtils.g(70);
        }
        e4() {
            let a;
            a = NaN;
            if (this.e2 != null && ((() => { let b = tryParseNumber(this.e2.bq, a); a = b.p1; return b.ret; })())) {
            }
            return a;
        }
        g(a) {
            let b = new ToolActionEventDetail();
            b.a = this;
            b.d = a;
            b.b = this.m;
            let c;
            b.f = this.e4();
            return b;
        }
        e7(a, b) {
            this.e5 = this.e4();
            let c = this.g(true);
            this.dy(c, this);
        }
        e8(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
                let f = this.a7(this.j, e);
                b.bw(3, 1, f);
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                this.e2 = c;
                c.ad = f;
                c.bj = 2;
                c.bm = 1;
                c.f = 2;
                c.h = 1;
                c.bn = 1;
                c.bi = 2;
                c.bp = false;
                c.bl = runOn(this, this.e7);
            }
            c.c = this.l;
            c.bt = this.ah ? this.ep : this.et;
            c.bg = this.r;
            c.bo = this.ah;
            if (!isNaN_(this.e5)) {
                c.bq = this.e5.toString();
            }
        }
        d1(a, b, c) {
            let d = b.b;
            if (d.bo == null || (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m)) {
                NativeUIComponent.aq(this.j.p.v(), 2, this.v(2), (e) => {
                    let f = e;
                    this.e8(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.m);
            }
            else {
                let e = a.bh(2);
                this.e8(d, a, e, b, c);
            }
        }
        ea() {
            if (this.e2 != null) {
                this.e2.c = this.l;
            }
        }
        d4(a, b, c) {
            super.d4(a, b, c);
            switch (a) {
                case "IsDisabled":
                    if (this.e2 != null) {
                        this.e2.bo = this.ah;
                        this.e2.bt = this.ah ? this.ep : this.et;
                    }
                    break;
            }
        }
        dv() {
            if (this.e2 != null && !this.ah) {
                this.e2.aw();
            }
        }
        dp(a) {
            super.dp(a);
            let b = a;
            this.e5 = b.value;
        }
    }
    ToolActionNumberInput.$t = /*@__PURE__*/ markType(ToolActionNumberInput, 'ToolActionNumberInput', ToolAction.$);
    return ToolActionNumberInput;
})();
/**
 * @hidden
 */
export let ToolActionCollection = /*@__PURE__*/ (() => {
    class ToolActionCollection extends ObservableCollection$1 {
        constructor() {
            super(ToolAction.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    ToolActionCollection.$t = /*@__PURE__*/ markType(ToolActionCollection, 'ToolActionCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(ToolAction.$));
    return ToolActionCollection;
})();
/**
 * @hidden
 */
export let ToolActionPerformedEventArgs = /*@__PURE__*/ (() => {
    class ToolActionPerformedEventArgs extends Base {
        constructor() {
            super();
            this.c = false;
            this.a = null;
            this.b = null;
            this.b = new ToolActionEventDetailCollection();
        }
    }
    ToolActionPerformedEventArgs.$t = /*@__PURE__*/ markType(ToolActionPerformedEventArgs, 'ToolActionPerformedEventArgs');
    return ToolActionPerformedEventArgs;
})();
/**
 * @hidden
 */
export let ToolActionEventDetail = /*@__PURE__*/ (() => {
    class ToolActionEventDetail extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = 0;
            this.d = false;
            this.c = false;
            this.f = 0;
            this.e = new Date();
            this.g = null;
        }
    }
    ToolActionEventDetail.$t = /*@__PURE__*/ markType(ToolActionEventDetail, 'ToolActionEventDetail');
    return ToolActionEventDetail;
})();
/**
 * @hidden
 */
export let ToolActionEventDetailCollection = /*@__PURE__*/ (() => {
    class ToolActionEventDetailCollection extends ObservableCollection$1 {
        constructor() {
            super(ToolActionEventDetail.$, 0);
        }
    }
    ToolActionEventDetailCollection.$t = /*@__PURE__*/ markType(ToolActionEventDetailCollection, 'ToolActionEventDetailCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(ToolActionEventDetail.$));
    return ToolActionEventDetailCollection;
})();
/**
 * @hidden
 */
export let ToolPanel = /*@__PURE__*/ (() => {
    class ToolPanel extends Base {
        get x() {
            if (this.w == null) {
                this.w = new SRProvider(this.p.n);
                this.w.cb("Layouts");
            }
            return this.w;
        }
        dh(a) {
            this.d = a;
            let b = this.d;
            b.rowUpdating = delegateCombine(b.rowUpdating, runOn(this, this.c7));
            let c = this.d;
            c.contentRefreshed = delegateCombine(c.contentRefreshed, runOn(this, this.c4));
            this.d.k = this.o;
            this.d.ai = true;
            let d = this.d;
            d.itemHeightRequested = delegateCombine(d.itemHeightRequested, runOn(this, this.c5));
            let e = this.d;
            e.itemWidthRequested = delegateCombine(e.itemWidthRequested, runOn(this, this.c6));
        }
        c4(a, b) {
            if (this.contentRefreshed != null) {
                this.contentRefreshed(this, new ToolPanelContentRefreshedEventArgs());
            }
        }
        c5(a, b) {
            let c = b.c;
            let d = new ToolActionMeasurementContext();
            this.dq(d);
            c.di(this, d);
            if (c.e1 == 0) {
                if (!isNaN_(d.d)) {
                    b.a = d.d;
                }
                else {
                    b.a = this.d.av;
                }
            }
            else {
                b.a = 0;
            }
        }
        c6(a, b) {
            let c = b.c;
            let d = new ToolActionMeasurementContext();
            this.dq(d);
            c.di(this, d);
            if (c.e1 == 0) {
                if (!isNaN_(d.e)) {
                    b.a = d.e;
                }
            }
            else {
                b.a = 0;
            }
        }
        c7(a, b) {
            let c = b.a.o;
            let d = a;
            if (this.o == 1) {
                let e = new ToolActionMeasurementContext();
                this.dq(e);
                c.di(this, e);
                c.dz(d, this, b, e);
            }
            else {
                c.dz(d, this, b, this.i);
            }
        }
        dm(a) {
            this.ar = a.width;
            this.du();
            this.d.notifySizeChanged();
        }
        get actions() {
            return this.g;
        }
        set actions(a) {
            let b = this.g;
            this.g = a;
            if (b != this.g) {
                this.dn("Actions", b, this.g);
            }
        }
        get ac() {
            return this.aa;
        }
        set ac(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.dn("ShowOnHover", b, this.aa);
            }
        }
        constructor() {
            super();
            this.p = null;
            this.v = null;
            this.y = false;
            this.w = null;
            this.i = new ToolActionMeasurementContext();
            this.propertyChanged = null;
            this.g = new ToolActionCollection();
            this.contentRefreshed = null;
            this.aa = true;
            this.z = false;
            this.ae = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
            this.af = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
            this.ad = new Dictionary$2(String_$type, ToolAction.$, 0);
            this.s = null;
            this.a = null;
            this.q = 0;
            this.eh = null;
            this.d4 = null;
            this.eq = null;
            this.ed = null;
            this.ej = null;
            this.d6 = null;
            this.ep = null;
            this.ec = null;
            this.ek = null;
            this.d7 = null;
            this.em = null;
            this.d9 = null;
            this.d = null;
            this.ar = Number.POSITIVE_INFINITY;
            this.er = null;
            this.ee = null;
            this.ei = null;
            this.d5 = null;
            this.el = null;
            this.d8 = null;
            this.et = null;
            this.eg = null;
            this.es = null;
            this.ef = null;
            this.a0 = NaN;
            this.ap = NaN;
            this.a1 = NaN;
            this.aq = NaN;
            this.en = null;
            this.ea = null;
            this.eo = null;
            this.eb = null;
            this.ax = NaN;
            this.am = NaN;
            this.ay = NaN;
            this.an = NaN;
            this.az = NaN;
            this.ao = NaN;
            this.aw = NaN;
            this.al = NaN;
            this.at = NaN;
            this.ai = NaN;
            this.au = NaN;
            this.aj = NaN;
            this.av = NaN;
            this.ak = NaN;
            this.as = NaN;
            this.ah = NaN;
            this.m = ToolPanel.n;
            this.onCommand = null;
            this.e = 0;
            this.drillDownRequested = null;
            this.drillUpRequested = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.c8));
            NativeUIXInputsFactory.j();
            NativeUIInputsFactory.n();
            NativeUILayoutFactory.e();
            let b = new ToolPanelView();
            b.c = this;
            this.p = b;
            this.p.ab();
            this.d3();
        }
        c8(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.di));
                    }
                    c.dd();
                    c.b = null;
                    c.j = null;
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.di));
                    }
                    e.b = this.a;
                    e.j = this;
                }
            }
            this.d2(this.actions);
            this.dl();
        }
        c9(a, b) {
            for (let c = 0; c < this.actions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[c]) !== null) {
                    let d = this.actions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.di));
                }
                this.actions._inner[c].dd();
                this.actions._inner[c].b = null;
                this.actions._inner[c].j = null;
            }
        }
        dl() {
            this.du();
        }
        du() {
            if (this.z) {
                return;
            }
            this.z = true;
            this.a.enqueueAction(runOn(this, this.de));
        }
        dw() {
            this.z = true;
            this.de();
        }
        de() {
            if (!this.z) {
                return;
            }
            this.z = false;
            this.da();
            this.d0();
            for (let a = 0; a < this.g.count; a++) {
                this.j(this.g._inner[a]);
            }
            this.df();
        }
        da() {
            this.ae.clear();
            this.af.clear();
            this.ad.clear();
            for (let a = 0; a < this.g.count; a++) {
                this.g._inner[a].j = this;
                if (this.g._inner[a].cs != null) {
                    this.ad.item(this.g._inner[a].cs, this.g._inner[a]);
                }
            }
            for (let b = 0; b < this.g.count; b++) {
                if (this.g._inner[b].c1 != null) {
                    if (this.ad.containsKey(this.g._inner[b].c1)) {
                        if (!this.ae.containsKey(this.g._inner[b].c1)) {
                            this.ae.item(this.g._inner[b].c1, new List$1(ToolAction.$, 0));
                        }
                        let c = this.ae.item(this.g._inner[b].c1);
                        c.add(this.g._inner[b]);
                    }
                }
            }
            for (let d = 0; d < this.g.count; d++) {
                if (this.g._inner[d].m == 6) {
                    let e = this.g._inner[d].e6;
                    if (!this.af.containsKey(e)) {
                        this.af.item(e, new List$1(ToolAction.$, 0));
                    }
                    this.af.item(e).add(this.g._inner[d]);
                }
            }
        }
        ab(a) {
            if (a.cs == null) {
                return false;
            }
            return this.ae.containsKey(a.cs);
        }
        f(a) {
            if (this.ad.containsKey(a)) {
                return this.ad.item(a);
            }
            return null;
        }
        ag(a) {
            if (a.cs == null) {
                return null;
            }
            if (this.ae.containsKey(a.cs)) {
                return this.ae.item(a.cs);
            }
            return null;
        }
        j(a) {
            let b = new ToolActionMeasurementContext();
            this.dq(b);
            a.di(this, b);
            this.dj(this.i, b);
            return b;
        }
        dq(a) {
            a.a = this.o;
            a.c = this.ar;
        }
        dj(a, b) {
            if (!isNaN_(b.f)) {
                if (isNaN_(a.f)) {
                    a.f = b.f;
                }
                else {
                    a.f = Math.max(a.f, b.f);
                }
            }
            if (!isNaN_(b.h)) {
                if (isNaN_(a.h)) {
                    a.h = b.h;
                }
                else {
                    a.h = Math.max(a.h, b.h);
                }
            }
        }
        d0() {
            this.i = new ToolActionMeasurementContext();
            this.i.a = this.o;
            this.i.c = this.ar;
        }
        fk() {
            let a = 0;
            let b = 0;
            if (this.o == 0) {
                for (let c = 0; c < this.actions.count; c++) {
                    let d = this.j(this.actions._inner[c]);
                    a = Math.max(d.e, a);
                    if (this.actions._inner[c].e1 == 0) {
                        if (!isNaN_(d.d)) {
                            b += d.d;
                        }
                        else {
                            b += this.a2;
                        }
                    }
                }
            }
            return new Size(1, a, b);
        }
        df() {
            if (this.d.itemsSource != this.actions) {
                this.d.itemsSource = this.actions;
            }
        }
        dg() {
            if (this.z) {
                this.de();
            }
            if (this.d != null) {
                this.d.bt();
            }
        }
        dx() {
            if (this.d != null) {
                this.d.cm();
            }
        }
        dv(a) {
            let b = a.e6;
            let c = a.cs;
            if (this.af != null) {
                if (this.af.containsKey(b)) {
                    for (let d = 0; d < this.af.item(b).count; d++) {
                        if (this.af.item(b)._inner[d].cs != c) {
                            this.af.item(b)._inner[d].e8();
                        }
                    }
                }
            }
        }
        di(a, b) {
            this.dl();
        }
        db() {
            for (let a = 0; a < this.actions.count; a++) {
                this.actions._inner[a].dd();
            }
        }
        dr() {
            for (let a = 0; a < this.actions.count; a++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[a]) !== null) {
                    let b = this.actions._inner[a];
                    b.propertyChanged = delegateRemove(b.propertyChanged, runOn(this, this.di));
                }
                this.actions._inner[a].b = null;
            }
        }
        notifySizeChanged() {
            this.p.y();
        }
        destroy() {
            this.provideContainer(null);
            this.db();
        }
        provideContainer(a) {
            this.p.z(a);
        }
        get t() {
            return this.s;
        }
        set t(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.dn("CellTextStyle", b, this.s);
            }
        }
        u() {
            if (this.t == null) {
                return this.p.f();
            }
            return this.t;
        }
        dn(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ds(a, b, c);
        }
        ds(a, b, c) {
            switch (a) {
                case "BaseTheme":
                case "TextColor":
                case "BackgroundColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderTextColor":
                case "GroupHeaderBackgroundColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "SeparatorHorizontalPaddingLeft":
                case "SeparatorHorizontalPaddingRight":
                case "SeparatorHorizontalPaddingTop":
                case "SeparatorHorizontalPaddingBottom":
                case "SeparatorVerticalPaddingLeft":
                case "SeparatorVerticalPaddingRight":
                case "SeparatorVerticalPaddingTop":
                case "SeparatorVerticalPaddingBottom":
                    this.d3();
                    break;
                case "ActualTextColor":
                case "ActualIconFill":
                case "ActualIconStroke":
                case "ActualSubmenuBackgroundColor":
                case "ActualGroupHeaderTextColor":
                case "ActualGroupHeaderBackgroundColor":
                case "ActualSeparatorBackgroundColor":
                case "ActualHoverBackgroundColor":
                case "ActualToolTipTextColor":
                case "ActualToolTipBackgroundColor":
                case "ActualToolTipCornerRadius":
                case "ActualToolTipElevation":
                case "ActualSeparatorHorizontalPaddingLeft":
                case "ActualSeparatorHorizontalPaddingRight":
                case "ActualSeparatorHorizontalPaddingTop":
                case "ActualSeparatorHorizontalPaddingBottom":
                case "ActualSeparatorVerticalPaddingLeft":
                case "ActualSeparatorVerticalPaddingRight":
                case "ActualSeparatorVerticalPaddingTop":
                case "ActualSeparatorVerticalPaddingBottom":
                    this.d2(this.actions);
                    break;
                case "CellTextStyle":
                    this.du();
                    break;
                case "ActualBackgroundColor":
                    this.d1();
                    break;
                case "Orientation":
                    if (this.d != null) {
                        this.d.k = this.o;
                    }
                    break;
                case "Actions":
                    if (b != null) {
                        let d = b;
                        d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.c8));
                        d.collectionResetting = delegateRemove(d.collectionResetting, runOn(this, this.c9));
                        for (let e of fromEnum(d)) {
                            if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                                let f = e;
                                f.propertyChanged = delegateRemove(f.propertyChanged, runOn(this, this.di));
                            }
                            e.b = null;
                            e.j = null;
                        }
                    }
                    if (c != null) {
                        let g = c;
                        g.collectionChanged = delegateCombine(g.collectionChanged, runOn(this, this.c8));
                        g.collectionResetting = delegateCombine(g.collectionResetting, runOn(this, this.c9));
                        for (let h of fromEnum(g)) {
                            if (typeCast(INotifyPropertyChanged_$type, h) !== null) {
                                let i = h;
                                i.propertyChanged = delegateCombine(i.propertyChanged, runOn(this, this.di));
                            }
                            h.b = this.a;
                            h.j = this;
                        }
                    }
                    this.d2(this.actions);
                    this.du();
                    break;
            }
        }
        d3() {
            switch (this.r) {
                case 0:
                case 1:
                case 2:
                case 5:
                case 3:
                    this.e4 = this.fh != null ? this.fh : BrushUtil.g(255, 24, 29, 31);
                    this.ev = this.e8 != null ? this.e8 : BrushUtil.g(102, 0, 0, 0);
                    this.eu = this.e7 != null ? this.e7 : BrushUtil.g(255, 255, 255, 255);
                    this.e3 = this.fg != null ? this.fg : BrushUtil.g(255, 255, 255, 255);
                    this.ew = this.e9 != null ? this.e9 : BrushUtil.g(255, 237, 239, 245);
                    this.ey = this.fb != null ? this.fb : BrushUtil.g(255, 142, 143, 147);
                    this.e2 = this.ff != null ? this.ff : BrushUtil.g(255, 237, 239, 245);
                    this.ex = this.fa != null ? this.fa : BrushUtil.g(25, 0, 0, 0);
                    this.ez = this.fc != null ? this.fc : BrushUtil.g(51, 178, 191, 220);
                    this.e6 = this.fj != null ? this.fj : BrushUtil.g(255, 0, 0, 0);
                    this.e0 = this.fd != null ? this.fd : BrushUtil.g(255, 0, 0, 0);
                    this.e1 = this.fe != null ? this.fe : BrushUtil.g(255, 0, 0, 0);
                    this.e5 = this.fi != null ? this.fi : BrushUtil.g(255, 237, 239, 245);
                    this.bb = !isNaN_(this.bl) ? this.bl : 8;
                    this.bc = !isNaN_(this.bm) ? this.bm : 4;
                    this.a8 = !isNaN_(this.bi) ? this.bi : 0;
                    this.a9 = !isNaN_(this.bj) ? this.bj : 0;
                    this.ba = !isNaN_(this.bk) ? this.bk : 0;
                    this.a7 = !isNaN_(this.bh) ? this.bh : 0;
                    this.a4 = !isNaN_(this.be) ? this.be : 0;
                    this.a5 = !isNaN_(this.bf) ? this.bf : 0;
                    this.a6 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(10);
                    this.a3 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(10);
                    break;
                case 6:
                case 4:
                    this.e4 = this.fh != null ? this.fh : BrushUtil.g(255, 255, 255, 255);
                    this.ev = this.e8 != null ? this.e8 : BrushUtil.g(102, 255, 255, 255);
                    this.eu = this.e7 != null ? this.e7 : BrushUtil.g(255, 55, 63, 86);
                    this.e3 = this.fg != null ? this.fg : BrushUtil.g(255, 55, 63, 86);
                    this.ew = this.e9 != null ? this.e9 : BrushUtil.g(255, 44, 50, 70);
                    this.ey = this.fb != null ? this.fb : BrushUtil.g(255, 255, 255, 255);
                    this.e2 = this.ff != null ? this.ff : BrushUtil.g(255, 44, 50, 70);
                    this.ex = this.fa != null ? this.fa : BrushUtil.g(25, 0, 0, 0);
                    this.ez = this.fc != null ? this.fc : BrushUtil.g(25, 105, 136, 255);
                    this.e6 = this.fj != null ? this.fj : BrushUtil.g(255, 255, 255, 255);
                    this.e0 = this.fd != null ? this.fd : BrushUtil.g(255, 210, 212, 216);
                    this.e1 = this.fe != null ? this.fe : BrushUtil.g(255, 210, 212, 216);
                    this.e5 = this.fi != null ? this.fi : BrushUtil.g(255, 44, 50, 70);
                    this.bb = !isNaN_(this.bl) ? this.bl : 8;
                    this.bc = !isNaN_(this.bm) ? this.bm : 4;
                    this.a8 = !isNaN_(this.bi) ? this.bi : 0;
                    this.a9 = !isNaN_(this.bj) ? this.bj : 0;
                    this.ba = !isNaN_(this.bk) ? this.bk : 0;
                    this.a7 = !isNaN_(this.bh) ? this.bh : 0;
                    this.a4 = !isNaN_(this.be) ? this.be : 0;
                    this.a5 = !isNaN_(this.bf) ? this.bf : 0;
                    this.a6 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(10);
                    this.a3 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(10);
                    break;
            }
        }
        d2(a) {
            for (let b = 0; b < a.count; b++) {
                a._inner[b].d9();
                this.d2(a._inner[b].actions);
            }
        }
        d1() {
            if (this.p.n != null) {
                NativeUI.l(this.p.t, this.eu);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.dn("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get e7() {
            return this.eh;
        }
        set e7(a) {
            let b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.dn("BackgroundColor", b, a);
            }
        }
        get eu() {
            return this.d4;
        }
        set eu(a) {
            let b = this.d4;
            this.d4 = a;
            if (b != this.d4) {
                this.dn("ActualBackgroundColor", b, this.d4);
            }
        }
        get fg() {
            return this.eq;
        }
        set fg(a) {
            let b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.dn("SubmenuBackgroundColor", b, this.eq);
            }
        }
        get e3() {
            return this.ed;
        }
        set e3(a) {
            let b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.dn("ActualSubmenuBackgroundColor", b, this.ed);
            }
        }
        get e9() {
            return this.ej;
        }
        set e9(a) {
            let b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.dn("GroupHeaderBackgroundColor", b, this.ej);
            }
        }
        get ew() {
            return this.d6;
        }
        set ew(a) {
            let b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.dn("ActualGroupHeaderBackgroundColor", b, this.d6);
            }
        }
        get ff() {
            return this.ep;
        }
        set ff(a) {
            let b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.dn("SeparatorBackgroundColor", b, this.ep);
            }
        }
        get e2() {
            return this.ec;
        }
        set e2(a) {
            let b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.dn("ActualSeparatorBackgroundColor", b, this.ec);
            }
        }
        get fa() {
            return this.ek;
        }
        set fa(a) {
            let b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.dn("GroupHeaderSeparatorBackgroundColor", b, this.ek);
            }
        }
        get ex() {
            return this.d7;
        }
        set ex(a) {
            let b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.dn(ToolPanel.bs, b, this.d7);
            }
        }
        get fc() {
            return this.em;
        }
        set fc(a) {
            let b = this.em;
            this.em = a;
            if (b != this.em) {
                this.dn("HoverBackgroundColor", b, this.em);
            }
        }
        get ez() {
            return this.d9;
        }
        set ez(a) {
            let b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.dn("ActualHoverBackgroundColor", b, this.d9);
            }
        }
        get fh() {
            return this.er;
        }
        set fh(a) {
            let b = this.er;
            this.er = a;
            if (b != this.er) {
                this.dn("TextColor", b, this.er);
            }
        }
        get e4() {
            return this.ee;
        }
        set e4(a) {
            let b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.dn("ActualTextColor", b, this.ee);
            }
        }
        get e8() {
            return this.ei;
        }
        set e8(a) {
            let b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.dn("DisabledTextColor", b, this.ei);
            }
        }
        get ev() {
            return this.d5;
        }
        set ev(a) {
            let b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.dn("ActualDisabledTextColor", b, this.d5);
            }
        }
        get fb() {
            return this.el;
        }
        set fb(a) {
            let b = this.el;
            this.el = a;
            if (b != this.el) {
                this.dn("GroupHeaderTextColor", b, this.el);
            }
        }
        get ey() {
            return this.d8;
        }
        set ey(a) {
            let b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.dn("ActualGroupHeaderTextColor", b, this.d8);
            }
        }
        get fj() {
            return this.et;
        }
        set fj(a) {
            let b = this.et;
            this.et = a;
            if (b != this.et) {
                this.dn("ToolTipTextColor", b, this.et);
            }
        }
        get e6() {
            return this.eg;
        }
        set e6(a) {
            let b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.dn("ActualToolTipTextColor", b, this.eg);
            }
        }
        get fi() {
            return this.es;
        }
        set fi(a) {
            let b = this.es;
            this.es = a;
            if (b != this.es) {
                this.dn("ToolTipBackgroundColor", b, this.es);
            }
        }
        get e5() {
            return this.ef;
        }
        set e5(a) {
            let b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.dn("ActualToolTipBackgroundColor", b, this.ef);
            }
        }
        get bl() {
            return this.a0;
        }
        set bl(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.dn("ToolTipCornerRadius", b, this.a0);
            }
        }
        get bb() {
            return this.ap;
        }
        set bb(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.dn("ActualToolTipCornerRadius", b, this.ap);
            }
        }
        get bm() {
            return this.a1;
        }
        set bm(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.dn("ToolTipElevation", b, this.a1);
            }
        }
        get bc() {
            return this.aq;
        }
        set bc(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.dn("ActualToolTipElevation", b, this.aq);
            }
        }
        get fd() {
            return this.en;
        }
        set fd(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.dn("IconFill", b, this.en);
            }
        }
        get e0() {
            return this.ea;
        }
        set e0(a) {
            let b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.dn("ActualIconFill", b, this.ea);
            }
        }
        get fe() {
            return this.eo;
        }
        set fe(a) {
            let b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.dn("IconStroke", b, this.eo);
            }
        }
        get e1() {
            return this.eb;
        }
        set e1(a) {
            let b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.dn("ActualIconStroke", b, this.eb);
            }
        }
        get bi() {
            return this.ax;
        }
        set bi(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.dn("SeparatorVerticalPaddingLeft", b, this.ax);
            }
        }
        get a8() {
            return this.am;
        }
        set a8(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.dn("ActualSeparatorVerticalPaddingLeft", b, this.am);
            }
        }
        get bj() {
            return this.ay;
        }
        set bj(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.dn("SeparatorVerticalPaddingRight", b, this.ay);
            }
        }
        get a9() {
            return this.an;
        }
        set a9(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.dn("ActualSeparatorVerticalPaddingRight", b, this.an);
            }
        }
        get bk() {
            return this.az;
        }
        set bk(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.dn("SeparatorVerticalPaddingTop", b, this.az);
            }
        }
        get ba() {
            return this.ao;
        }
        set ba(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.dn("ActualSeparatorVerticalPaddingTop", b, this.ao);
            }
        }
        get bh() {
            return this.aw;
        }
        set bh(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.dn("SeparatorVerticalPaddingBottom", b, this.aw);
            }
        }
        get a7() {
            return this.al;
        }
        set a7(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.dn("ActualSeparatorVerticalPaddingBottom", b, this.al);
            }
        }
        get be() {
            return this.at;
        }
        set be(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.dn("SeparatorHorizontalPaddingLeft", b, this.at);
            }
        }
        get a4() {
            return this.ai;
        }
        set a4(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.dn("ActualSeparatorHorizontalPaddingLeft", b, this.ai);
            }
        }
        get bf() {
            return this.au;
        }
        set bf(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.dn("SeparatorHorizontalPaddingRight", b, this.au);
            }
        }
        get a5() {
            return this.aj;
        }
        set a5(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.dn("ActualSeparatorHorizontalPaddingRight", b, this.aj);
            }
        }
        get bg() {
            return this.av;
        }
        set bg(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.dn("SeparatorHorizontalPaddingTop", b, this.av);
            }
        }
        get a6() {
            return this.ak;
        }
        set a6(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.dn("ActualSeparatorHorizontalPaddingTop", b, this.ak);
            }
        }
        get bd() {
            return this.as;
        }
        set bd(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.dn("SeparatorHorizontalPaddingBottom", b, this.as);
            }
        }
        get a3() {
            return this.ah;
        }
        set a3(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.dn("ActualSeparatorHorizontalPaddingBottom", b, this.ah);
            }
        }
        get o() {
            return this.m;
        }
        set o(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.dn("Orientation", enumGetBox(ToolPanelOrientation_$type, b), enumGetBox(ToolPanelOrientation_$type, a));
            }
        }
        dp(a, b) {
            if (this.onCommand != null) {
                this.onCommand(this, ((() => {
                    let $ret = new ToolCommandEventArgs();
                    $ret.a = b;
                    return $ret;
                })()));
            }
            if (a.m == 6) {
                this.dv(a);
            }
        }
        get bn() {
            return this.d.a7;
        }
        set bn(a) {
            this.d.a7 = a;
        }
        get a2() {
            return this.d.av;
        }
        dy(a) {
            if (this.drillDownRequested != null) {
                this.drillDownRequested(this, ((() => {
                    let $ret = new DrillDownRequestedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        dz(a) {
            if (this.drillUpRequested != null) {
                this.drillUpRequested(this, ((() => {
                    let $ret = new DrillDownRequestedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        dc() {
            for (let a = 0; a < this.actions.count; a++) {
                this.actions._inner[a].df();
            }
        }
    }
    ToolPanel.$t = /*@__PURE__*/ markType(ToolPanel, 'ToolPanel', Base.$, [INotifyPropertyChanged_$type]);
    ToolPanel.bs = "ActualGroupHeaderSeparatorBackgroundColor";
    ToolPanel.n = 0;
    return ToolPanel;
})();
/**
 * @hidden
 */
export let DrillDownRequestedEventArgs = /*@__PURE__*/ (() => {
    class DrillDownRequestedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    DrillDownRequestedEventArgs.$t = /*@__PURE__*/ markType(DrillDownRequestedEventArgs, 'DrillDownRequestedEventArgs');
    return DrillDownRequestedEventArgs;
})();
/**
 * @hidden
 */
export let ToolPanelsPresenter = /*@__PURE__*/ (() => {
    class ToolPanelsPresenter extends Base {
        get a0() {
            return this.ay;
        }
        set a0(a) {
            this.d.d = this.ay = a;
        }
        get a1() {
            return this.az;
        }
        set a1(a) {
            this.g.d = this.az = a;
        }
        get v() {
            return this.u;
        }
        get n() {
            return this.m;
        }
        set n(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.as("Theme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.m));
            }
        }
        get z() {
            return this.x;
        }
        set z(a) {
            this.x = a;
        }
        constructor(a, b) {
            super();
            this.ab = null;
            this.i = null;
            this.j = null;
            this.y = 0;
            this.o = null;
            this.a = null;
            this.d = null;
            this.g = null;
            this.ay = null;
            this.az = null;
            this.p = null;
            this.b = null;
            this.e = null;
            this.h = null;
            this.c = null;
            this.f = null;
            this.w = new Queue$1(PanelAnimationRequest.$);
            this.r = null;
            this.q = null;
            this.u = new List$1(PanelInfo.$, 0);
            this.m = 1;
            this.x = 200;
            this.s = null;
            this.aa = 0;
            this.t = false;
            this.containerReady = null;
            this.sizeChanged = null;
            this.propertyChanged = null;
            this.ab = a;
            this.i = b;
        }
        ai(a) {
            NativeUIComponent.at(this.ab, [7, 9], (b) => {
                this.r = b[0];
                this.q = b[1];
                this.r.bj(this.q);
                this.q.a9 = new MatrixTransform();
                if (a != null) {
                    a();
                }
            });
        }
        ae(a, b = null) {
            for (let c = 0; c < this.v.count; c++) {
                if (this.v._inner[c].b == a) {
                    if (b != null) {
                        b(this.v._inner[c].a);
                    }
                    return;
                }
            }
            NativeUIComponent.ar(this.ab, 13, (d) => {
                let e = d;
                e.c = this.n;
                e.b1 = a.j.fh;
                e.bw = a.j.e8;
                e.bv = a.j.fg;
                e.b0 = a.j.fg;
                e.bx = a.j.e9;
                e.by = a.j.fb;
                e.bz = a.j.ff;
                e.bp = a.actions;
                e.bi = runOn(this, this.aq);
                e.bj = runOn(this, this.ar);
                e.bo = runOn(this, this.ao);
                this.q.bj(e);
                this.y = 0;
                for (let f = 0; f < this.v.count; f++) {
                    let g = this.v._inner[f].f();
                    this.y += g.width;
                    this.v._inner[f].a.ad = g.width;
                }
                this.q.bq(e, this.y);
                this.q.br(e, 0);
                this.v.add(new PanelInfo(a, e, this.y));
                this.av();
                if (b != null) {
                    b(e);
                }
            });
        }
        aj(a) {
            for (let b = 0; b < this.v.count; b++) {
                if (this.v._inner[b].a == a) {
                    this.al(b);
                }
            }
        }
        al(a) {
            this.ak(this.v._inner[a]);
        }
        ak(a, b = null) {
            this.af(a, -Math.floor(a.c), b);
            this.j = a;
        }
        aq(a, b) {
            this.aa++;
            if (this.v.count > 1 && this.aa < this.v.count) {
                for (let c = this.v.count - 1; c > this.aa; c--) {
                    this.v._inner[c].a.bi = null;
                    this.v._inner[c].a.bj = null;
                    this.q.bl(this.v._inner[c].a);
                    this.y -= this.v._inner[c].a.ad;
                    this.v.removeAt(c);
                }
                if (this.v._inner[this.aa].b == b.a) {
                    this.aj(this.v._inner[this.aa].a);
                    return;
                }
                else {
                    this.v._inner[this.aa].a.bi = null;
                    this.v._inner[this.aa].a.bj = null;
                    this.q.bl(this.v._inner[this.aa].a);
                    this.y -= this.v._inner[this.aa].a.ad;
                    this.v.removeAt(this.aa);
                }
            }
            this.ae(b.a, (d) => this.i.executeDelayed(() => this.aj(d), 0));
        }
        ar(a, b) {
            this.aa--;
            this.ak(this.v._inner[this.v.count - 2], () => {
            });
        }
        ao(a, b) {
            if (this.s != null) {
                this.s(b);
            }
        }
        af(a, b, c = null) {
            this.ah();
            if (this.q.a9 == null) {
                let d = a.f();
                this.r.ad = Math.floor(d.width);
                this.r.x = Math.floor(d.height);
                return;
            }
            if (this.o.playState == 1) {
                if ((this.o.playbackRate > 0 && this.a0.j == b) || (this.o.playbackRate < 0 && this.a1.j == b)) {
                    this.o.reverse();
                    this.p.reverse();
                }
                else {
                    this.w.g(((() => {
                        let $ret = new PanelAnimationRequest();
                        $ret.a = a;
                        $ret.c = b;
                        $ret.b = c;
                        return $ret;
                    })()));
                }
            }
            else {
                this.a0 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = this.a1.j;
                    return $ret;
                })());
                this.a1 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = b;
                    return $ret;
                })());
                let e = a.f();
                this.e.d = this.r.ad;
                this.c.d = this.r.x;
                this.h.d = Math.floor(e.width);
                this.f.d = Math.floor(e.height);
                this.o.updatePlaybackRate(1);
                this.o.play();
                this.o.finished.f((f) => this.an(c));
                this.p.updatePlaybackRate(1);
                this.p.play();
                this.p.finished.f((f) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                });
            }
        }
        ah() {
            if (this.o == null) {
                let a = new AnimationKeyFrameEffectTiming();
                a.g = this.z;
                a.b = 0;
                this.a = new AnimationKeyFrameEffect(0, this.q.al, 0, null, a);
                this.ay = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = 0;
                    return $ret;
                })());
                this.az = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = 0;
                    return $ret;
                })());
                this.d = new AnimationKeyFrameProperty(14, this.ay);
                this.g = new AnimationKeyFrameProperty(14, this.az);
                this.o = KeyFrameAnimationFactory.f.c(this.a.m(this.d).m(this.g));
                this.b = new AnimationKeyFrameEffect(0, this.r.al, 0, null, a);
                this.e = new AnimationKeyFrameProperty(9, 0);
                this.c = new AnimationKeyFrameProperty(10, 0);
                this.h = new AnimationKeyFrameProperty(9, 0);
                this.f = new AnimationKeyFrameProperty(10, 0);
                this.p = KeyFrameAnimationFactory.f.c(this.b.m(this.e, this.c).m(this.h, this.f));
            }
        }
        an(a) {
            if (this.o != null) {
                this.o.commitStyles();
            }
            if (a != null) {
                a();
            }
            if (this.o.playbackRate < 0) {
                let b = this.a1.j;
                this.a1 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = this.a0.j;
                    return $ret;
                })());
                this.a0 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = b;
                    return $ret;
                })());
            }
            if (this.w.count > 0) {
                let c = this.w.b();
                this.ak(c.a, c.b);
            }
        }
        av() {
            if (this.t) {
                return;
            }
            this.t = true;
            this.i.enqueueAction(runOn(this, this.ag));
        }
        ag() {
            if (!this.t) {
                return;
            }
            this.t = false;
            for (let a = 0; a < this.v.count; a++) {
                this.v._inner[a].e();
                let b = this.v._inner[a].f();
                this.v._inner[a].a.ad = b.width;
                this.v._inner[a].a.x = b.height;
                this.v._inner[a].a.bt(b);
            }
        }
        aw() {
            this.aa = 0;
            this.q.a9 = new MatrixTransform();
            let a = this.v._inner[0].f();
            this.r.ad = Math.floor(a.width);
            this.r.x = Math.floor(a.height);
            this.ay = ((() => {
                let $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
            this.az = ((() => {
                let $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
        }
        ax(a, b) {
            this.m = a;
            for (let c = 0; c < this.v.count; c++) {
                let d = this.v._inner[c].a;
                d.c = a;
                d.b1 = b.fh;
                d.bw = b.e8;
                d.bv = b.fg;
                d.b0 = b.fg;
                d.bx = b.e9;
                d.by = b.fb;
                d.bz = b.ff;
            }
        }
        am() {
            let a = this.v._inner[0].f();
            this.v._inner[0].d(a);
        }
        ap() {
            if (this.containerReady != null) {
                this.containerReady(this);
            }
        }
        at() {
            if (this.sizeChanged != null) {
                this.sizeChanged(this);
            }
        }
        as(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.au(a, b, c);
        }
        au(a, b, c) {
            switch (a) {
                case "Theme":
                    for (let d = 0; d < this.v.count; d++) {
                        this.v._inner[d].a.c = this.n;
                    }
                    break;
            }
        }
    }
    ToolPanelsPresenter.$t = /*@__PURE__*/ markType(ToolPanelsPresenter, 'ToolPanelsPresenter', Base.$, [INotifyPropertyChanged_$type]);
    return ToolPanelsPresenter;
})();
/**
 * @hidden
 */
export let PanelInfo = /*@__PURE__*/ (() => {
    class PanelInfo extends Base {
        constructor(a, b, c) {
            super();
            this.c = 0;
            this.a = null;
            this.b = null;
            this.b = a;
            this.a = b;
            this.c = c;
        }
        f() {
            return this.a.bb(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        e() {
            this.a.bu();
        }
        d(a) {
            this.a.bt(a);
        }
    }
    PanelInfo.$t = /*@__PURE__*/ markType(PanelInfo, 'PanelInfo');
    return PanelInfo;
})();
/**
 * @hidden
 */
export let PanelAnimationRequest = /*@__PURE__*/ (() => {
    class PanelAnimationRequest extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = 0;
            this.b = null;
        }
    }
    PanelAnimationRequest.$t = /*@__PURE__*/ markType(PanelAnimationRequest, 'PanelAnimationRequest');
    return PanelAnimationRequest;
})();
