/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, delegateCombine, enumGetBox, typeCast, delegateRemove, fromEn, EnumUtil } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ToolPanel } from "./ToolPanel";
import { DOMExecutionContext } from "igniteui-webcomponents-core";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { ICommandStateChangedListener_$type } from "igniteui-webcomponents-core";
import { SRProvider } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { ToolActionCollection } from "./ToolActionCollection";
import { ToolbarOrientation_$type } from "./ToolbarOrientation";
import { ToolAction } from "./ToolAction";
import { NativeUIInputsFactory } from "igniteui-webcomponents-core";
import { NativeUIXInputsFactory } from "igniteui-webcomponents-inputs";
import { Visibility_$type } from "igniteui-webcomponents-core";
import { SvgIconRegistry } from "igniteui-webcomponents-core";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let ToolbarView = /*@__PURE__*/ (() => {
    class ToolbarView extends Base {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.a = null;
            this.i = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.n = "Verdana";
                $ret.d = 13;
                $ret.q = "Normal";
                $ret.s = "Normal";
                $ret.o = "Normal";
                return $ret;
            })());
            this.aa = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.j = null;
        }
        p() {
            return this.i;
        }
        v() {
        }
        t(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.a.b = new DOMExecutionContext(a);
            this.i = a;
            this.l = this.i.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
            this.k = this.i.createElement("div");
            this.y();
            let b = new ToolPanel();
            let c = this.i.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.i.append(c);
            let d = this.i.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.i.getExternal(b, this.i.rootWrapper, this.i.getExternal(this.a, null, null));
            this.a.b6(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.i.rootWrapper.setStyleProperty("position", "relative");
        }
        y() {
        }
        x() {
            if (this.i != null) {
            }
        }
        s() {
            if (this.i == null) {
                return;
            }
            let a = this.i.rootWrapper.width();
            let b = this.i.rootWrapper.height();
            this.aa = new Size(1, a, b);
            this.a.b9(this.aa);
        }
        z() {
            let a = this.i;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.p(b, this.a.c5);
                NativeUI.l(b, this.a.cw);
            }
        }
        d() {
            return this.b;
        }
        u() {
        }
        w() {
        }
        r() {
        }
        g() {
            return this.aa.width;
        }
        h(a) {
            this.c = this.a.t();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        q(a, b) {
            if (this.j == null) {
                this.j = this.i.createElement("div");
            }
            b(this.j.getNativeElement());
        }
    }
    ToolbarView.$t = /*@__PURE__*/ markType(ToolbarView, 'ToolbarView');
    return ToolbarView;
})();
/**
 * @hidden
 */
export let Toolbar = /*@__PURE__*/ (() => {
    class Toolbar extends Base {
        constructor() {
            super();
            this.l = null;
            this.w = false;
            this.u = null;
            this.n = null;
            this.o = 0;
            this.e = new ToolActionCollection();
            this.c = new ToolActionCollection();
            this.d = new ToolActionCollection();
            this.i = Toolbar.j;
            this.q = null;
            this.ax = Toolbar.ay;
            this.ck = null;
            this.cs = null;
            this.cm = null;
            this.cr = null;
            this.co = null;
            this.ct = null;
            this.cl = null;
            this.cn = null;
            this.cv = null;
            this.cu = null;
            this.al = NaN;
            this.am = NaN;
            this.cp = null;
            this.cq = null;
            this.r = null;
            this.ai = NaN;
            this.aj = NaN;
            this.ak = NaN;
            this.ah = NaN;
            this.ae = NaN;
            this.af = NaN;
            this.ag = NaN;
            this.ad = NaN;
            this.z = true;
            this.y = false;
            this.x = false;
            this.propertyChanged = null;
            this.a = null;
            this.onCommand = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.by));
            let b = this.actualActions;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.b0));
            let c = this.actualActions;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.b1));
            NativeUIInputsFactory.n();
            NativeUIXInputsFactory.j();
            let d = new ToolbarView();
            d.a = this;
            this.l = d;
            this.l.v();
        }
        get v() {
            if (this.u == null) {
                this.u = new SRProvider(this.l.i);
                this.u.cb("Layouts");
            }
            return this.u;
        }
        b6(a) {
            this.n = a;
            this.n.r = this.o == 0 ? 1 : this.o;
            let b = this.n;
            b.onCommand = delegateCombine(b.onCommand, runOn(this, this.bx));
            this.n.o = this.k;
            this.n.ac = this.ac;
            this.n.fh = this.c5;
            this.n.e8 = this.cx;
            this.n.e7 = this.cw;
            this.n.fg = this.c4;
            this.n.e9 = this.cy;
            this.n.fb = this.cz;
            this.n.ff = this.c3;
            this.n.fc = this.c0;
            this.n.fj = this.c7;
            this.n.fi = this.c6;
            this.n.bl = this.av;
            this.n.bm = this.aw;
            this.n.fd = this.c1;
            this.n.fe = this.c2;
            this.n.be = this.ao;
            this.n.bf = this.ap;
            this.n.bg = this.aq;
            this.n.bd = this.an;
            this.n.bi = this.as;
            this.n.bj = this.at;
            this.n.bk = this.au;
            this.n.bh = this.ar;
        }
        bx(a, b) {
            if (this.onCommand != null) {
                this.onCommand(this, b);
            }
            if (this.q != null) {
                this.q.onToolCommandExecuting(b.a);
            }
        }
        b9(a) {
            this.n.notifySizeChanged();
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ca("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get autoGeneratedActions() {
            return this.e;
        }
        set autoGeneratedActions(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ca("AutoGeneratedActions", b, this.e);
            }
        }
        get actions() {
            return this.c;
        }
        set actions(a) {
            let b = this.c;
            this.c = a;
            if (b != this.c) {
                this.ca("Actions", b, this.c);
            }
        }
        get actualActions() {
            return this.d;
        }
        set actualActions(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.ca("ActualActions", b, this.d);
            }
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.ca("Orientation", enumGetBox(ToolbarOrientation_$type, b), enumGetBox(ToolbarOrientation_$type, a));
            }
        }
        get target() {
            return this.ax;
        }
        set target(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.ca("Target", b, a);
            }
        }
        get cw() {
            return this.ck;
        }
        set cw(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.ca("BackgroundColor", b, a);
            }
        }
        get c4() {
            return this.cs;
        }
        set c4(a) {
            let b = this.cs;
            this.cs = a;
            if (b != this.cs) {
                this.ca("SubmenuBackgroundColor", b, this.cs);
            }
        }
        get cy() {
            return this.cm;
        }
        set cy(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.ca("GroupHeaderBackgroundColorPropertyName", b, this.cm);
            }
        }
        get c3() {
            return this.cr;
        }
        set c3(a) {
            let b = this.cr;
            this.cr = a;
            if (b != this.cr) {
                this.ca("SeparatorBackgroundColor", b, this.cr);
            }
        }
        get c0() {
            return this.co;
        }
        set c0(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.ca("HoverBackgroundColor", b, this.co);
            }
        }
        get c5() {
            return this.ct;
        }
        set c5(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.ca("TextColor", b, this.ct);
            }
        }
        get cx() {
            return this.cl;
        }
        set cx(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.ca("DisabledTextColor", b, this.cl);
            }
        }
        get cz() {
            return this.cn;
        }
        set cz(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.ca("GroupHeaderTextColor", b, this.cn);
            }
        }
        get c7() {
            return this.cv;
        }
        set c7(a) {
            let b = this.cv;
            this.cv = a;
            if (b != this.cv) {
                this.ca("ToolTipTextColor", b, this.cv);
            }
        }
        get c6() {
            return this.cu;
        }
        set c6(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.ca("ToolTipBackgroundColor", b, this.cu);
            }
        }
        get av() {
            return this.al;
        }
        set av(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.ca("ToolTipCornerRadius", b, this.al);
            }
        }
        get aw() {
            return this.am;
        }
        set aw(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.ca("ToolTipElevation", b, this.am);
            }
        }
        get c1() {
            return this.cp;
        }
        set c1(a) {
            let b = this.cp;
            this.cp = a;
            if (b != this.cp) {
                this.ca("IconFill", b, this.cp);
            }
        }
        get c2() {
            return this.cq;
        }
        set c2(a) {
            let b = this.cq;
            this.cq = a;
            if (b != this.cq) {
                this.ca("IconStroke", b, this.cq);
            }
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ca("CellTextStyle", b, this.r);
            }
        }
        t() {
            if (this.s == null) {
                return this.l.d();
            }
            return this.s;
        }
        get as() {
            return this.ai;
        }
        set as(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.ca("SeparatorVerticalPaddingLeft", b, this.ai);
            }
        }
        get at() {
            return this.aj;
        }
        set at(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.ca("SeparatorVerticalPaddingRight", b, this.aj);
            }
        }
        get au() {
            return this.ak;
        }
        set au(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.ca("SeparatorVerticalPaddingTop", b, this.ak);
            }
        }
        get ar() {
            return this.ah;
        }
        set ar(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.ca("SeparatorVerticalPaddingBottom", b, this.ah);
            }
        }
        get ao() {
            return this.ae;
        }
        set ao(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.ca("SeparatorHorizontalPaddingLeft", b, this.ae);
            }
        }
        get ap() {
            return this.af;
        }
        set ap(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.ca("SeparatorHorizontalPaddingRight", b, this.af);
            }
        }
        get aq() {
            return this.ag;
        }
        set aq(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.ca("SeparatorHorizontalPaddingTop", b, this.ag);
            }
        }
        get an() {
            return this.ad;
        }
        set an(a) {
            let b = this.ad;
            this.ad = a;
            if (b != this.ad) {
                this.ca("SeparatorHorizontalPaddingBottom", b, this.ad);
            }
        }
        get ac() {
            return this.z;
        }
        set ac(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.ca("ShowOnHover", b, this.z);
            }
        }
        by(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bz));
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.bz));
                    }
                }
            }
            this.b8();
        }
        b0(a, b) {
            this.cj();
        }
        b1(a, b) {
            for (let c = 0; c < this.actualActions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actualActions._inner[c]) !== null) {
                    let d = this.actualActions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.bz));
                }
                this.actualActions._inner[c].b = null;
            }
        }
        cj() {
            let a = this.p == 0 ? 1 : this.p;
            if (this.n != null) {
                this.n.r = a;
            }
            for (let b = 0; b < this.actualActions.count; b++) {
                this.actualActions._inner[b].l = a;
            }
        }
        bz(a, b) {
        }
        b8() {
            this.ce();
        }
        ce() {
            if (this.x) {
                return;
            }
            if (this.b != null) {
                this.x = true;
                this.b.enqueueAction(runOn(this, this.b4));
            }
            else {
                this.y = true;
            }
        }
        b4() {
            if (!this.x) {
                return;
            }
            this.x = false;
            this.cf();
            if (this.n.actions != this.actualActions) {
                this.n.actions = this.actualActions;
            }
        }
        cf() {
            this.actualActions.clear();
            for (let a = 0; a < this.autoGeneratedActions.count; a++) {
                this.actualActions.add(this.autoGeneratedActions._inner[a]);
            }
            let b = null;
            let c = null;
            let d = false;
            let e = false;
            let f = -1;
            let g = 0;
            for (let h = 0; h < this.actions.count; h++) {
                let i = this.actions._inner[h];
                if (!stringIsNullOrEmpty(i.cw)) {
                    if (((() => { let j = this.aa(i.cw, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        b._inner[f].d3(i);
                    }
                }
                else {
                    if (!stringIsNullOrEmpty(i.b9)) {
                        if (i.d != null) {
                            i.d.actions.remove(i);
                        }
                        if (((() => { let j = this.aa(i.b9, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.b9;
                            d = true;
                            e = false;
                        }
                    }
                    else if (!stringIsNullOrEmpty(i.b6)) {
                        if (i.d != null) {
                            i.d.actions.remove(i);
                        }
                        if (((() => { let j = this.aa(i.b6, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.b6;
                            d = false;
                            e = true;
                            g = 0;
                        }
                    }
                    if (!stringIsNullOrEmpty(c)) {
                        if (d) {
                            b.insert(f, i);
                            f++;
                        }
                        else if (e) {
                            b.insert(f + 1 + g, i);
                            g++;
                        }
                    }
                    else {
                        this.actualActions.add(i);
                    }
                }
            }
        }
        aa(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.cu != null && f.cu == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.aa(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        ab(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.cd == null) {
                    if (f.cu != null && f.cu == a) {
                        c = b;
                        d = e;
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
                else if (f.cd != null && f.cd == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.aa(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        b5() {
            if (this.x) {
                this.b4();
            }
        }
        notifySizeChanged() {
            this.l.s();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.l.t(a);
        }
        ca(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.cc(a, b, c);
        }
        cc(a, b, c) {
            switch (a) {
                case "CellTextStyle":
                    this.ce();
                    break;
                case "BackgroundColor":
                case "TextColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderBackgroundColorPropertyName":
                case "GroupHeaderTextColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "Orientation":
                case "ShowOnHover":
                    this.ci();
                    break;
                case "Target":
                    let d = c;
                    let e = b;
                    this.cb(e, d);
                    break;
                case "BaseTheme":
                    this.cj();
                    break;
                case "ExecutionContext":
                    if (this.b != null && this.y) {
                        this.ce();
                        this.y = false;
                    }
                    break;
            }
        }
        ci() {
            if (this.n != null) {
                this.n.ac = this.ac;
                this.n.e7 = this.cw;
                this.n.fh = this.c5;
                this.n.e8 = this.cx;
                this.n.fg = this.c4;
                this.n.e9 = this.cy;
                this.n.fb = this.cz;
                this.n.ff = this.c3;
                this.n.fc = this.c0;
                this.n.o = this.k;
                this.n.fj = this.c7;
                this.n.fi = this.c6;
                this.n.bl = this.av;
                this.n.bm = this.aw;
                this.n.fd = this.c1;
                this.n.fe = this.c2;
                this.n.be = this.ao;
                this.n.bf = this.ap;
                this.n.bg = this.aq;
                this.n.bd = this.an;
                this.n.bi = this.as;
                this.n.bj = this.at;
                this.n.bk = this.au;
                this.n.bh = this.ar;
            }
        }
        cb(a, b) {
            this.q = b;
            if (a != null) {
                this.autoGeneratedActions.clear();
                a.removeCommandStateChangedListener(this);
                this.ce();
            }
            if (b != null) {
                this.autoGeneratedActions.clear();
                let c = b.getDesiredToolbarActions();
                if (c != null) {
                    for (let d = 0; d < c.length; d++) {
                        let e = ToolAction.c(c[d]);
                        this.autoGeneratedActions.add(e);
                    }
                }
                b.addCommandStateChangedListener(this);
                this.ce();
            }
        }
        get b() {
            return this.a;
        }
        set b(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ca("ExecutionContext", b, this.a);
            }
        }
        b2() {
            if (this.n != null) {
                this.n.dc();
            }
        }
        onCommandStateChanged(a, b, c) {
            let d = null;
            let e = -1;
            if (((() => { let f = this.ab(a, this.actualActions, d, e); d = f.p2; e = f.p3; return f.ret; })())) {
                let f = d._inner[e];
                switch (b) {
                    case 2:
                        switch (f.m) {
                            case 2:
                                f.e4 = c;
                                break;
                            case 5:
                                f.e5 = c;
                                break;
                            case 6:
                                f.e4 = c;
                                break;
                        }
                        break;
                    case 0:
                        f.e1 = EnumUtil.getEnumValue(Visibility_$type, c);
                        break;
                    case 1:
                        f.ah = c;
                        break;
                }
            }
        }
        cg(a, b) {
            for (let c = 0; c < a.count; c++) {
                let d = a._inner[c];
                if (d.cl == b) {
                    d.cl = null;
                    d.cl = b;
                }
                if (d.actions != null && d.actions.count > 0) {
                    this.cg(d.actions, b);
                }
            }
        }
        ch(a, b, c) {
            SvgIconRegistry.instance.addSvgPathString(a, b, c);
            this.cg(this.actualActions, b);
        }
        a9(a, b) {
            return SvgIconRegistry.instance.getSvgPathString(a, b);
        }
    }
    Toolbar.$t = /*@__PURE__*/ markType(Toolbar, 'Toolbar', Base.$, [INotifyPropertyChanged_$type, ICommandStateChangedListener_$type]);
    Toolbar.j = 1;
    Toolbar.ay = null;
    return Toolbar;
})();
