import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { PropertyEditorPropertyDescription as PropertyEditorPropertyDescription_internal } from './PropertyEditorPropertyDescription';
import { IgcPropertyEditorPropertyDescriptionComponent as IgcPropertyEditorPropertyDescriptionComponent } from './igc-property-editor-property-description-component';
export class IgcPropertyEditorPropertyDescriptionCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgcPropertyEditorPropertyDescriptionComponent.$type) {
            IgcPropertyEditorPropertyDescriptionComponent.$type = markType(IgcPropertyEditorPropertyDescriptionComponent, "IgcPropertyEditorPropertyDescriptionComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgcPropertyEditorPropertyDescriptionComponent.$type) {
            IgcPropertyEditorPropertyDescriptionComponent.$type = markType(IgcPropertyEditorPropertyDescriptionComponent, "IgcPropertyEditorPropertyDescriptionComponent");
        }
        let coll = new SyncableObservableCollection$2(IgcPropertyEditorPropertyDescriptionComponent.$type, PropertyEditorPropertyDescription_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgcPropertyEditorPropertyDescriptionComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}
