import { IgcToolActionIconButtonComponent } from "./igc-tool-action-icon-button-component";
import { ToolActionIconMenu } from "./ToolActionIconMenu";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionIconMenuComponent = /*@__PURE__*/ (() => {
    class IgcToolActionIconMenuComponent extends IgcToolActionIconButtonComponent {
        createImplementation() {
            return new ToolActionIconMenu();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionIconMenuComponent._observedAttributesIgcToolActionIconMenuComponent == null) {
                let names = getAllPropertyNames(IgcToolActionIconMenuComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionIconMenuComponent._observedAttributesIgcToolActionIconMenuComponent = names;
            }
            return IgcToolActionIconMenuComponent._observedAttributesIgcToolActionIconMenuComponent;
        }
        static register() {
            if (!IgcToolActionIconMenuComponent._isElementRegistered) {
                IgcToolActionIconMenuComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionIconMenuComponent.htmlTagName, IgcToolActionIconMenuComponent);
            }
        }
    }
    IgcToolActionIconMenuComponent._observedAttributesIgcToolActionIconMenuComponent = null;
    IgcToolActionIconMenuComponent.htmlTagName = "igc-tool-action-icon-menu";
    IgcToolActionIconMenuComponent._isElementRegistered = false;
    return IgcToolActionIconMenuComponent;
})();
