import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionNumberInput } from "./ToolActionNumberInput";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionNumberInputComponent = /*@__PURE__*/ (() => {
    class IgcToolActionNumberInputComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionNumberInput();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent == null) {
                let names = getAllPropertyNames(IgcToolActionNumberInputComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent = names;
            }
            return IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent;
        }
        static register() {
            if (!IgcToolActionNumberInputComponent._isElementRegistered) {
                IgcToolActionNumberInputComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionNumberInputComponent.htmlTagName, IgcToolActionNumberInputComponent);
            }
        }
        /**
         * Gets or sets the value for the input.
        */
        get value() {
            return this.i.e5;
        }
        set value(v) {
            this.i.e5 = +v;
            this._a("value", this.i.e5);
        }
        fromInfo(info) {
            this.i.dp(info);
        }
    }
    IgcToolActionNumberInputComponent._observedAttributesIgcToolActionNumberInputComponent = null;
    IgcToolActionNumberInputComponent.htmlTagName = "igc-tool-action-number-input";
    IgcToolActionNumberInputComponent._isElementRegistered = false;
    return IgcToolActionNumberInputComponent;
})();
