/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgcListPanelModule } from './igc-list-panel-module';
import { IgcToolActionLabelModule } from './igc-tool-action-label-module';
import { IgcToolActionCheckboxModule } from './igc-tool-action-checkbox-module';
import { IgcToolActionGroupHeaderModule } from './igc-tool-action-group-header-module';
import { IgcToolActionNumberInputModule } from './igc-tool-action-number-input-module';
import { IgcToolActionIconButtonModule } from './igc-tool-action-icon-button-module';
import { IgcToolActionIconMenuModule } from './igc-tool-action-icon-menu-module';
import { IgcXInputGroupModule } from "igniteui-webcomponents-inputs";
import { IgcXCheckboxModule } from "igniteui-webcomponents-inputs";
import { IgcXButtonModule } from "igniteui-webcomponents-inputs";
import { IgcXIconModule } from "igniteui-webcomponents-inputs";
import { IgcToolPanelComponent } from './igc-tool-panel-component';
import { ToolPanel } from './ToolPanel';
import { TypeRegistrar } from "igniteui-webcomponents-core";
export class IgcToolPanelModule {
    static register() {
        IgcListPanelModule.register();
        IgcToolActionLabelModule.register();
        IgcToolActionCheckboxModule.register();
        IgcToolActionGroupHeaderModule.register();
        IgcToolActionNumberInputModule.register();
        IgcToolActionIconButtonModule.register();
        IgcToolActionIconMenuModule.register();
        IgcXInputGroupModule.register();
        IgcXCheckboxModule.register();
        IgcXButtonModule.register();
        IgcXIconModule.register();
        IgcToolPanelComponent.register();
        TypeRegistrar.registerCons('IgcToolPanelComponent', IgcToolPanelComponent);
        TypeRegistrar.registerCons('IgcToolPanelComponent', IgcToolPanelComponent);
        TypeRegistrar.register('ToolPanel', ToolPanel.$type);
    }
}
