/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, markType, runOn, delegateCombine, delegateRemove, EnumUtil, typeGetValue, enumGetBox, INotifyPropertyChanged_$type, PropertyChangedEventArgs, fromEn, fromEnum, typeCast, String_$type } from "igniteui-webcomponents-core";
import { INativeUIElementFactory_$type } from "igniteui-webcomponents-core";
import { NativeUIComponent } from "igniteui-webcomponents-core";
import { XComponentBridge } from "igniteui-webcomponents-inputs";
import { INativeUIToolPanelBridge_$type } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-webcomponents-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolPanelOrientation_$type } from "./ToolPanelOrientation";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ListPanel } from "./ListPanel";
import { DOMExecutionContext } from "igniteui-webcomponents-core";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { Popup } from "igniteui-webcomponents-core";
import { Rect } from "igniteui-webcomponents-core";
import { Visibility_$type } from "igniteui-webcomponents-core";
import { ToolActionType_$type } from "igniteui-webcomponents-core";
import { BrushUtil } from "igniteui-webcomponents-core";
import { ObservableCollection$1 } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { ToolCommandArgument } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolCommand } from "igniteui-webcomponents-core";
import { CSSColorUtil } from "igniteui-webcomponents-core";
import { Thickness } from "igniteui-webcomponents-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { isNaN_, isPositiveInfinity, truncate, tryParseNumber } from "igniteui-webcomponents-core";
import { SvgIconRegistry } from "igniteui-webcomponents-core";
import { TooltipTextPresenter } from "./TooltipTextPresenter";
import { DelayManager } from "igniteui-webcomponents-core";
import { NativeUIWindow } from "igniteui-webcomponents-core";
import { NativeUIIconButton } from "igniteui-webcomponents-core";
import { BrushUtilCore } from "igniteui-webcomponents-core";
import { CornerRadius } from "igniteui-webcomponents-core";
import { SRProvider } from "igniteui-webcomponents-core";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { NativeUIXInputsFactory } from "igniteui-webcomponents-inputs";
import { NativeUIInputsFactory } from "igniteui-webcomponents-core";
import { TranslateTransform } from "igniteui-webcomponents-core";
import { AnimationKeyFrameProperty } from "igniteui-webcomponents-core";
import { Queue$1 } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffect } from "igniteui-webcomponents-core";
import { KeyFrameAnimationFactory } from "igniteui-webcomponents-core";
import { MatrixTransform } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var NativeUILayoutFactory = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NativeUILayoutFactory, _super);
    function NativeUILayoutFactory() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 2;
        return _this;
    }
    Object.defineProperty(NativeUILayoutFactory, "b", {
        get: function () {
            if (NativeUILayoutFactory.a == null) {
                NativeUILayoutFactory.a = new NativeUILayoutFactory();
            }
            return NativeUILayoutFactory.a;
        },
        enumerable: false,
        configurable: true
    });
    NativeUILayoutFactory.e = function () {
        NativeUIComponent.ap(NativeUILayoutFactory.b);
    };
    Object.defineProperty(NativeUILayoutFactory.prototype, "flavor", {
        get: function () {
            return this.c;
        },
        enumerable: false,
        configurable: true
    });
    NativeUILayoutFactory.prototype.createComponent = function (a, b, c) {
        switch (b) {
            case 13:
                this.d(a, c);
                break;
        }
    };
    NativeUILayoutFactory.prototype.createComponentSync = function (a, b, c) {
        this.createComponent(a, b, c);
    };
    NativeUILayoutFactory.prototype.supportsComponent = function (a) {
        switch (a) {
            case 13: return true;
        }
        return false;
    };
    NativeUILayoutFactory.prototype.d = function (a, b) {
        var c = a;
        var d = c.createElement("div");
        var e = c.getSubRenderer(d);
        var f = new ToolPanel();
        f.provideContainer(e);
        var g = new XToolPanelBridge(f);
        var h = new NativeUIToolPanel();
        h.al = d;
        h.d = g;
        b(h);
    };
    NativeUILayoutFactory.$t = markType(NativeUILayoutFactory, 'NativeUILayoutFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUILayoutFactory.a = null;
    return NativeUILayoutFactory;
}(Base));
export { NativeUILayoutFactory };
/**
 * @hidden
 */
var XToolPanelBridge = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XToolPanelBridge, _super);
    function XToolPanelBridge(a) {
        var _this = _super.call(this, a) || this;
        _this.u = null;
        _this.x = null;
        _this.v = null;
        _this.y = null;
        _this.w = null;
        _this.z = null;
        return _this;
    }
    XToolPanelBridge.prototype.getDesiredSize = function (a, b) {
        return this.t.fk();
    };
    XToolPanelBridge.prototype.addHandler = function (a, b, c, d) {
        var e = a;
        switch (c) {
            case 10:
                e.drillDownRequested = delegateCombine(e.drillDownRequested, runOn(this, this.ab));
                this.u = d;
                this.x = b;
                break;
            case 11:
                e.drillUpRequested = delegateCombine(e.drillUpRequested, runOn(this, this.ac));
                this.v = d;
                this.y = b;
                break;
            case 16:
                e.onCommand = delegateCombine(e.onCommand, runOn(this, this.aa));
                this.w = d;
                this.z = b;
                break;
        }
    };
    XToolPanelBridge.prototype.removeHandler = function (a, b, c, d) {
        var e = a;
        switch (c) {
            case 10:
                e.drillDownRequested = delegateRemove(e.drillDownRequested, runOn(this, this.ab));
                this.u = null;
                this.x = null;
                break;
            case 11:
                e.drillUpRequested = delegateRemove(e.drillUpRequested, runOn(this, this.ac));
                this.v = null;
                this.y = null;
                break;
            case 16:
                e.onCommand = delegateRemove(e.onCommand, runOn(this, this.aa));
                this.w = null;
                this.z = null;
                break;
        }
    };
    XToolPanelBridge.prototype.ab = function (a, b) {
        if (this.u != null) {
            this.u(this.x, b);
        }
    };
    XToolPanelBridge.prototype.ac = function (a, b) {
        if (this.v != null) {
            this.v(this.y, b);
        }
    };
    XToolPanelBridge.prototype.aa = function (a, b) {
        if (this.w != null) {
            this.w(this.z, b);
        }
    };
    XToolPanelBridge.prototype.setValue = function (a, b, c) {
        var d = a;
        switch (b) {
            case 27:
                d.actions = c;
                break;
            case 30:
                d.o = EnumUtil.getEnumValue(ToolPanelOrientation_$type, c);
                break;
            case 28:
                d.bn = typeGetValue(c);
                break;
            case 18:
                d.r = EnumUtil.getEnumValue(BaseControlTheme_$type, c);
                break;
        }
    };
    XToolPanelBridge.prototype.getValue = function (a, b) {
        var c = a;
        switch (b) {
            case 27: return c.actions;
            case 30: return enumGetBox(ToolPanelOrientation_$type, c.o);
            case 28: return c.bn;
            case 29: return c.a2;
            case 18: return enumGetBox(BaseControlTheme_$type, c.r);
        }
        return null;
    };
    XToolPanelBridge.prototype.refresh = function (a) {
        a.dw();
    };
    XToolPanelBridge.prototype.notifySizeChanged = function (a, b) {
        a.notifySizeChanged();
    };
    XToolPanelBridge.$t = markType(XToolPanelBridge, 'XToolPanelBridge', XComponentBridge.$, [INativeUIToolPanelBridge_$type]);
    return XToolPanelBridge;
}(XComponentBridge));
export { XToolPanelBridge };
/**
 * @hidden
 */
var ToolPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolPanelView, _super);
    function ToolPanelView() {
        var _this = _super.call(this) || this;
        _this.s = null;
        _this.r = null;
        _this.c = null;
        _this.n = null;
        _this.q = null;
        _this.g = null;
        _this.p = null;
        _this.d = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 13;
            $ret.q = "Normal";
            $ret.s = "Normal";
            $ret.o = "Normal";
            return $ret;
        })());
        _this.ag = new Size();
        _this.e = null;
        _this._gridExternal = null;
        _this.h = false;
        _this.o = null;
        return _this;
    }
    ToolPanelView.prototype.v = function () {
        return this.n;
    };
    ToolPanelView.prototype.ab = function () {
    };
    Object.defineProperty(ToolPanelView.prototype, "t", {
        get: function () {
            return this.n.rootWrapper;
        },
        enumerable: false,
        configurable: true
    });
    ToolPanelView.prototype.z = function (a) {
        if (a == null) {
            this.n = null;
            return;
        }
        this.c.a = new DOMExecutionContext(a);
        this.n = a;
        this.q = this.n.createElement("canvas");
        this.g = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
        this.p = this.n.createElement("div");
        this.ad();
        var b = new ListPanel();
        var c = this.n.createElement("div");
        c.setStyleProperty("width", "100%");
        c.setStyleProperty("height", "100%");
        this.n.append(c);
        var d = this.n.getSubRenderer(c);
        b.provideContainer(d);
        var e = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
        b.externalListPanel = e;
        this.c.dh(b);
        var f = Math.round(a.rootWrapper.width());
        var g = Math.round(a.rootWrapper.height());
        this.n.rootWrapper.setStyleProperty("position", "relative");
        this.n.rootWrapper.setStyleProperty("width", "100%");
    };
    ToolPanelView.prototype.ad = function () {
    };
    ToolPanelView.prototype.y = function () {
        if (this.n == null) {
            return;
        }
        var a = this.n.rootWrapper.width();
        var b = this.n.rootWrapper.height();
        this.ag = new Size(1, a, b);
        this.c.dm(this.ag);
        if (this.c.v != null) {
        }
    };
    ToolPanelView.prototype.k = function () {
        var a = this.n.rootWrapper.getNativeElement();
        return a.offsetWidth;
    };
    ToolPanelView.prototype.j = function () {
        var a = this.n.rootWrapper.getNativeElement();
        return a.offsetHeight;
    };
    ToolPanelView.prototype.ae = function () {
        var a = this.n;
        if (null == a) {
            return;
        }
        var b = a.rootWrapper;
        if (null != b) {
            NativeUI.p(b, this.c.fh);
            NativeUI.l(b, this.c.e7);
        }
    };
    ToolPanelView.prototype.f = function () {
        return this.d;
    };
    ToolPanelView.prototype.aa = function () {
    };
    ToolPanelView.prototype.ac = function () {
    };
    ToolPanelView.prototype.x = function () {
    };
    ToolPanelView.prototype.i = function () {
        return this.ag.width;
    };
    ToolPanelView.prototype.l = function (a) {
        this.e = this.c.u();
        return FontUtil.measureStringWidth(a, this.e, this.g);
    };
    ToolPanelView.prototype.m = function (a, b) {
        return FontUtil.measureStringWidth(a, b, this.g);
    };
    ToolPanelView.prototype.w = function (a, b) {
        if (this.o == null) {
            this.o = this.n.createElement("div");
        }
        b(this.o.getNativeElement());
    };
    ToolPanelView.prototype.a = function () {
        var a = new Popup();
        var b = this.n.getExternal(a, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
        return a;
    };
    ToolPanelView.prototype.b = function (a) {
        var b = new ToolPanel();
        var c = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
        var d = a.al;
        d.appendChild(b.p.n.rootWrapper.getNativeElement());
        return b;
    };
    ToolPanelView.prototype.af = function (a) {
        var ele_ = a;
        var bounds_ = (ele_.getBoundingClientRect());
        var b = bounds_["left"];
        var c = bounds_["top"];
        var d = bounds_["width"];
        var e = bounds_["height"];
        return new Rect(0, b, c, d, e);
    };
    ToolPanelView.$t = markType(ToolPanelView, 'ToolPanelView');
    return ToolPanelView;
}(Base));
export { ToolPanelView };
/**
 * @hidden
 */
var NativeUIToolPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NativeUIToolPanel, _super);
    function NativeUIToolPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.bl = null;
        _this.bg = null;
        _this.bh = null;
        _this.bn = null;
        return _this;
    }
    Object.defineProperty(NativeUIToolPanel.prototype, "bk", {
        get: function () {
            return this.d;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bp", {
        get: function () {
            return this.ae(27);
        },
        set: function (a) {
            this.a0(27, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bs", {
        get: function () {
            return this.ae(28);
        },
        set: function (a) {
            this.a0(28, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "br", {
        get: function () {
            return this.ae(29);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bq", {
        get: function () {
            return EnumUtil.getEnumValue(ToolPanelOrientation_$type, this.ae(30));
        },
        set: function (a) {
            this.a0(30, enumGetBox(ToolPanelOrientation_$type, a));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "b1", {
        get: function () {
            return this.ae(33);
        },
        set: function (a) {
            this.a0(33, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bw", {
        get: function () {
            return this.ae(34);
        },
        set: function (a) {
            this.a0(34, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bv", {
        get: function () {
            return this.ae(23);
        },
        set: function (a) {
            this.a0(23, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "b0", {
        get: function () {
            return this.ae(50);
        },
        set: function (a) {
            this.a0(50, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bx", {
        get: function () {
            return this.ae(51);
        },
        set: function (a) {
            this.a0(51, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "by", {
        get: function () {
            return this.ae(52);
        },
        set: function (a) {
            this.a0(52, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bz", {
        get: function () {
            return this.ae(53);
        },
        set: function (a) {
            this.a0(53, a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bm", {
        get: function () {
            return this.bl;
        },
        set: function (a) {
            var b = this.bl;
            this.bl = a;
            if (this.bl != null) {
                this.an(9, this.bl);
            }
            else {
                this.ay(9, b);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bi", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (this.bg != null) {
                this.an(10, this.bg);
            }
            else {
                this.ay(10, b);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bj", {
        get: function () {
            return this.bh;
        },
        set: function (a) {
            var b = this.bh;
            this.bh = a;
            if (this.bh != null) {
                this.an(11, this.bh);
            }
            else {
                this.ay(11, b);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NativeUIToolPanel.prototype, "bo", {
        get: function () {
            return this.bn;
        },
        set: function (a) {
            var b = this.bn;
            this.bn = a;
            if (this.bn != null) {
                this.an(16, this.bn);
            }
            else {
                this.ay(16, b);
            }
        },
        enumerable: false,
        configurable: true
    });
    NativeUIToolPanel.prototype.bu = function () {
        this.bk.refresh(this.ak);
    };
    NativeUIToolPanel.prototype.bt = function (a) {
        this.bk.notifySizeChanged(this.ak, a);
    };
    NativeUIToolPanel.$t = markType(NativeUIToolPanel, 'NativeUIToolPanel', NativeUIComponent.$);
    return NativeUIToolPanel;
}(NativeUIComponent));
export { NativeUIToolPanel };
/**
 * @hidden
 */
var ToolAction = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolAction, _super);
    function ToolAction() {
        var _this = _super.call(this) || this;
        _this.j = null;
        _this.a = null;
        _this.d = null;
        _this.e = new ToolActionCollection();
        _this.a0 = NaN;
        _this.bs = null;
        _this.b9 = null;
        _this.b6 = null;
        _this.cw = null;
        _this.bo = null;
        _this.bn = null;
        _this.bj = null;
        _this.k = 0;
        _this.aw = NaN;
        _this.ao = NaN;
        _this.ax = NaN;
        _this.ap = NaN;
        _this.av = NaN;
        _this.an = NaN;
        _this.ay = NaN;
        _this.aq = NaN;
        _this.ed = null;
        _this.ek = null;
        _this.ei = BrushUtil.g(0, 0, 0, 0);
        _this.eb = null;
        _this.eh = null;
        _this.eg = null;
        _this.en = null;
        _this.ec = null;
        _this.ej = null;
        _this.o = null;
        _this.q = null;
        _this.ab = false;
        _this.br = null;
        _this.bu = null;
        _this.bt = null;
        _this.az = 30;
        _this.bq = null;
        _this.bp = null;
        _this.as = NaN;
        _this.at = NaN;
        _this.au = NaN;
        _this.ar = NaN;
        _this.el = null;
        _this.ee = null;
        _this.em = null;
        _this.ef = null;
        _this.e0 = 0;
        _this.propertyChanged = null;
        _this.p = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 13;
            $ret.q = "Normal";
            $ret.s = "Normal";
            $ret.o = "Normal";
            return $ret;
        })());
        _this.onCommand = null;
        _this.performed = null;
        _this.x = null;
        _this.w = null;
        _this.u = null;
        _this.z = null;
        _this.aa = null;
        var a = _this.actions;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.dq));
        var b = _this.actions;
        b.collectionResetting = delegateCombine(b.collectionResetting, runOn(_this, _this.dr));
        return _this;
    }
    Object.defineProperty(ToolAction.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.dx("ExecutionContext", b, this.a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "cs", {
        get: function () {
            if (this.cu != null) {
                return this.cu;
            }
            if (this.da != null) {
                return this.c5(this.da);
            }
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "actions", {
        get: function () {
            return this.e;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bi", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            this.a0 = a;
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.dd = function () {
    };
    ToolAction.prototype.dq = function (a, b) {
        var e_1, _a, e_2, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    c.dd();
                    c.d = null;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    d.d = this;
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
    };
    ToolAction.prototype.dr = function (a, b) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(this.actions)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.dd();
                c.d = null;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    ToolAction.prototype.c5 = function (a) {
        return stringReplace(a, " ", "_");
    };
    ToolAction.prototype.g = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new ToolActionEventDetail();
            $ret.a = _this;
            $ret.d = a;
            return $ret;
        })());
    };
    ToolAction.prototype.n = function () {
        var _this = this;
        return ((function () {
            var $ret = new ToolCommandArgument();
            $ret.argumentName = _this.c3();
            $ret.value = _this.bl();
            return $ret;
        })());
    };
    ToolAction.prototype.c3 = function () {
        if (this.ca != null) {
            return this.ca;
        }
        return this.cs != null ? this.cs : "Unknown";
    };
    ToolAction.prototype.bl = function () {
        if (this.bk != null) {
            return this.bk;
        }
        return this.bm();
    };
    ToolAction.prototype.bm = function () {
        return null;
    };
    Object.defineProperty(ToolAction.prototype, "c1", {
        get: function () {
            return this.bs;
        },
        set: function (a) {
            var b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.dx("ParentId", b, this.bs);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.c4 = function () {
        if (this.cd != null) {
            return this.cd;
        }
        return this.cs;
    };
    Object.defineProperty(ToolAction.prototype, "cd", {
        get: function () {
            return this.bo;
        },
        set: function (a) {
            var b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.dx("CommandId", b, this.bo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ca", {
        get: function () {
            return this.bn;
        },
        set: function (a) {
            var b = this.bn;
            this.bn = a;
            if (b != this.bn) {
                this.dx("CommandArgument", b, this.bn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bk", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.dx("CommandArgumentValue", b, this.bj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.dx("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "be", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.dx("PaddingLeft", b, this.aw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "a2", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.dx("ActualPaddingLeft", b, this.ao);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bf", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.dx("PaddingRight", b, this.ax);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "a3", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.dx("ActualPaddingRight", b, this.ap);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bd", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (b != this.av) {
                this.dx("PaddingBottom", b, this.av);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "a1", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.dx("ActualPaddingBottom", b, this.an);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bg", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.dx("PaddingTop", b, this.ay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "a4", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.dx("ActualPaddingTop", b, this.aq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "eq", {
        get: function () {
            return this.ed;
        },
        set: function (a) {
            var b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.dx("ActualHoverBackground", b, this.ed);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ew", {
        get: function () {
            return this.ek;
        },
        set: function (a) {
            var b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.dx("HoverBackground", b, this.ek);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "eo", {
        get: function () {
            return this.eb;
        },
        set: function (a) {
            var b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.dx("ActualBackground", b, this.eb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "eu", {
        get: function () {
            return this.eh;
        },
        set: function (a) {
            var b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.dx("Background", b, this.eh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "et", {
        get: function () {
            return this.eg;
        },
        set: function (a) {
            var b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.dx("ActualTextColor", b, this.eg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ez", {
        get: function () {
            return this.en;
        },
        set: function (a) {
            var b = this.en;
            this.en = a;
            if (b != this.en) {
                this.dx("TextColor", b, this.en);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ep", {
        get: function () {
            return this.ec;
        },
        set: function (a) {
            var b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.dx("ActualDisabledTextColor", b, this.ec);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ev", {
        get: function () {
            return this.ej;
        },
        set: function (a) {
            var b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.dx("DisabledTextColor", b, this.ej);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "r", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.dx("ActualTextStyle", b, this.o);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "t", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.dx("TextStyle", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ah", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.dx("IsDisabled", b, this.ab);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ag", {
        get: function () {
            return this.c1 != null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "cu", {
        get: function () {
            return this.br;
        },
        set: function (a) {
            var b = this.br;
            this.br = a;
            if (b != this.br) {
                this.dx("Name", b, this.br);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "da", {
        get: function () {
            return this.bu;
        },
        set: function (a) {
            var b = this.bu;
            this.bu = a;
            if (b != this.bu) {
                this.dx("Title", b, this.bu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "c6", {
        get: function () {
            return this.bt;
        },
        set: function (a) {
            var b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.dx("Subtitle", b, this.bt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bh", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            this.az = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "cl", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.dx("IconName", b, this.bq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ci", {
        get: function () {
            return this.bp;
        },
        set: function (a) {
            var b = this.bp;
            this.bp = a;
            if (b != this.bp) {
                this.dx("IconCollectionName", b, this.bp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ba", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.dx("IconViewBoxLeft", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bb", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.dx("IconViewBoxTop", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "bc", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.dx("IconViewBoxWidth", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "a9", {
        get: function () {
            return this.ar;
        },
        set: function (a) {
            var b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.dx("IconViewBoxHeight", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ex", {
        get: function () {
            return this.el;
        },
        set: function (a) {
            var b = this.el;
            this.el = a;
            if (b != this.el) {
                this.dx("IconFill", b, this.el);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "er", {
        get: function () {
            return this.ee;
        },
        set: function (a) {
            var b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.dx("ActualIconFill", b, this.ee);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "ey", {
        get: function () {
            return this.em;
        },
        set: function (a) {
            var b = this.em;
            this.em = a;
            if (b != this.em) {
                this.dx("IconStroke", b, this.em);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "es", {
        get: function () {
            return this.ef;
        },
        set: function (a) {
            var b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.dx("ActualIconStroke", b, this.ef);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolAction.prototype, "e1", {
        get: function () {
            return this.e0;
        },
        set: function (a) {
            var b = this.e0;
            this.e0 = a;
            if (b != this.e0) {
                this.dx("Visibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.e0));
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.get_ad = function () {
        return true;
    };
    Object.defineProperty(ToolAction.prototype, "ad", {
        get: function () {
            return this.get_ad();
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.get_ae = function () {
        return true;
    };
    Object.defineProperty(ToolAction.prototype, "ae", {
        get: function () {
            return this.get_ae();
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.get_ai = function () {
        return true;
    };
    Object.defineProperty(ToolAction.prototype, "ai", {
        get: function () {
            return this.get_ai();
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.get_ak = function () {
        return true;
    };
    Object.defineProperty(ToolAction.prototype, "ak", {
        get: function () {
            return this.get_ak();
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.get_ac = function () {
        return true;
    };
    Object.defineProperty(ToolAction.prototype, "ac", {
        get: function () {
            return this.get_ac();
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.dx = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.d4(a, b, c);
    };
    ToolAction.prototype.get_m = function () {
        return 0;
    };
    Object.defineProperty(ToolAction.prototype, "m", {
        get: function () {
            return this.get_m();
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.d4 = function (a, b, c) {
        switch (a) {
            case "Background":
            case "TextColor":
            case "TextStyle":
                this.d9();
                break;
            case "ActualBackground":
                if (this.y != null) {
                    this.y.a4 = this.eo;
                }
                break;
            case "ActualTextColor":
                if (this.aa != null) {
                    this.aa.a6 = this.et;
                }
                break;
            case "ActualTextStyle":
                if (this.aa != null) {
                    this.aa.bg = this.r;
                }
                break;
            case "IsDisabled":
                if (this.aa != null) {
                    this.aa.a6 = this.ah ? this.ep : this.et;
                }
                break;
            case "ActualIconFill":
            case "ActualIconStroke":
                if (this.z != null) {
                    this.z.a7 = this.er;
                    this.z.a8 = this.es;
                }
                break;
            case "Visibility":
                if (this.j != null) {
                    this.j.dx();
                }
                break;
            case "IconName":
            case "IconCollectionName":
                this.dw();
                break;
        }
    };
    ToolAction.prototype.d9 = function () {
        if (this.j == null) {
            return;
        }
        this.l = this.j.r;
        this.eo = this.eu != null ? this.eu : this.ei;
        this.et = this.ez != null ? this.ez : this.j.e4;
        this.ep = this.ev != null ? this.ev : this.j.ev;
        this.eq = this.ew != null ? this.ew : this.j.ez;
        this.er = this.ex != null ? this.ex : this.j.e0;
        this.es = this.ey != null ? this.ey : this.j.e1;
        this.r = this.t != null ? this.t : this.p;
        this.a2 = !isNaN_(this.be) ? this.be : DeviceUtils.g(12);
        this.a3 = !isNaN_(this.bf) ? this.bf : DeviceUtils.g(12);
        this.a4 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(2);
        this.a1 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(2);
        this.ea();
    };
    ToolAction.prototype.ea = function () {
    };
    ToolAction.prototype.dw = function () {
        if (this.z != null) {
            this.z.bl = this.cl;
            this.z.bk = this.ci;
        }
    };
    ToolAction.prototype.dz = function (a, b, c, d) {
        var _this = this;
        this.dn(c.b, c, d, function (e) {
            _this.de(c.b);
            _this.x = e;
            _this.dm(c.b, _this.x, d, function () {
                c.b.bo = _this.x;
                _this.d7(_this.w, _this.z, _this.aa);
                _this.d1(_this.w == null ? _this.x : _this.w, c, d);
            });
        });
    };
    ToolAction.prototype.d1 = function (a, b, c) {
    };
    ToolAction.prototype.d0 = function (a, b, c, d) {
    };
    ToolAction.prototype.di = function (a, b) {
        this.dj(a, b);
    };
    ToolAction.prototype.dj = function (a, b) {
        b.f = this.a6(a, b);
        b.h = this.a8(a, b);
        b.g = this.a7(a, b);
        b.b = this.a5(a, b);
        if (b.a == 1) {
            var c = 0;
            if (!isNaN_(b.f)) {
                c += b.f;
            }
            if (!isNaN_(b.h)) {
                c += b.h;
            }
            if (!isNaN_(b.g)) {
                c += b.g;
            }
            if (!isNaN_(b.b)) {
                c += b.b;
            }
            c += (this.a2 + this.a3);
            b.e = c;
        }
        else {
            if (!isNaN_(this.bi)) {
                b.e = this.bi;
            }
            else {
                var d = 0;
                if (!isNaN_(b.f)) {
                    d += b.f;
                }
                if (!isNaN_(b.h)) {
                    d += b.h;
                }
                if (!isNaN_(b.g)) {
                    d += b.g;
                }
                if (!isNaN_(b.b)) {
                    d += b.b;
                }
                d += (this.a2 + this.a3);
                if (isNaN_(b.c) || isPositiveInfinity(b.c) || d > b.c) {
                    b.e = d;
                }
                else {
                    b.e = b.c;
                }
            }
        }
    };
    ToolAction.prototype.a7 = function (a, b) {
        return NaN;
    };
    ToolAction.prototype.a8 = function (a, b) {
        if (this.da == null) {
            return NaN;
        }
        var c = this.s(a);
        var d = a.p.m(this.da, c);
        return d + this.bh;
    };
    ToolAction.prototype.a6 = function (a, b) {
        if (!stringIsNullOrEmpty(this.cl)) {
            return DeviceUtils.g(36);
        }
        return NaN;
    };
    ToolAction.prototype.s = function (a) {
        return a.u();
    };
    ToolAction.prototype.a5 = function (a, b) {
        return NaN;
    };
    ToolAction.prototype.dy = function (a, b) {
        this.d5();
        if (this.ag) {
            var c = this.j.f(this.c1);
            if (c != null) {
                c.dt(this);
            }
        }
        else {
            if (this.j.ab(this)) {
                if (this.performed != null) {
                    var d_1 = new ToolActionEventDetailCollection();
                    this.dh(this, d_1, b);
                    this.performed(this, ((function () {
                        var $ret = new ToolActionPerformedEventArgs();
                        $ret.c = true;
                        $ret.b = d_1;
                        return $ret;
                    })()));
                }
            }
            else {
                if (this.performed != null) {
                    this.performed(this, ((function () {
                        var $ret = new ToolActionPerformedEventArgs();
                        $ret.c = false;
                        $ret.a = a;
                        return $ret;
                    })()));
                }
            }
        }
    };
    ToolAction.prototype.d5 = function () {
        var a = this.c4();
        if (a == null) {
            return;
        }
        var b = new ToolCommand();
        b.commandId = a;
        var c = new List$1(ToolCommandArgument.$, 0);
        this.dg(this, c);
        b.argumentsList = c.toArray();
        if (this.onCommand != null) {
            this.onCommand(this, ((function () {
                var $ret = new ToolCommandEventArgs();
                $ret.a = b;
                return $ret;
            })()));
        }
        if (this.j != null) {
            this.j.dp(this, b);
        }
    };
    ToolAction.prototype.d6 = function (a) {
        if (this.onCommand != null) {
            this.onCommand(this, ((function () {
                var $ret = new ToolCommandEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
        if (this.j != null) {
            this.j.dp(this, a);
        }
    };
    ToolAction.prototype.al = function () {
        return this.onCommand != null;
    };
    ToolAction.prototype.dg = function (a, b) {
        var c = a.n();
        if (c != null) {
            b.add(c);
        }
        var d = this.j.ag(a);
        if (d != null) {
            for (var e = 0; e < d.count; e++) {
                if (d._inner[e].af()) {
                    this.dg(d._inner[e], b);
                }
            }
        }
    };
    ToolAction.prototype.af = function () {
        return true;
    };
    ToolAction.prototype.dt = function (a) {
        if (this.ag) {
            var b = this.j.f(this.c1);
            if (b != null) {
                b.dt(a);
            }
        }
        else {
            this.dy(this.g(false), a);
        }
    };
    ToolAction.prototype.dh = function (a, b, c) {
        var d = a.g(a == c);
        b.add(d);
        var e = this.j.ag(a);
        if (e != null) {
            for (var f = 0; f < e.count; f++) {
                this.dh(e._inner[f], b, c);
            }
        }
    };
    ToolAction.c = function (a) {
        var b = null;
        switch (a.b) {
            case 2:
                b = new ToolActionCheckbox();
                break;
            case 1:
                b = new ToolActionGroupHeader();
                break;
            case 3:
                b = new ToolActionIconButton();
                break;
            case 4:
                b = new ToolActionLabel();
                break;
            case 5:
                b = new ToolActionNumberInput();
                break;
            case 6:
                b = new ToolActionRadio();
                break;
            case 7:
                b = new ToolActionSeparator();
                break;
            case 8:
                b = new ToolActionIconMenu();
                break;
            case 9:
                b = new ToolActionButton();
                break;
            case 0: return null;
        }
        b.dp(a);
        return b;
    };
    ToolAction.prototype.dp = function (a) {
        this.cu = a.name;
        this.da = a.title;
        this.ca = a.commandArgument;
        this.bk = a.commandArgumentValue;
        this.cd = a.commandId;
        this.cl = a.iconName;
        this.ci = a.iconCollectionName;
        this.ba = a.iconViewBoxLeft;
        this.bb = a.iconViewBoxTop;
        this.bc = a.iconViewBoxWidth;
        this.a9 = a.iconViewBoxHeight;
        this.be = a.paddingLeft;
        this.bf = a.paddingRight;
        this.bg = a.paddingTop;
        this.bd = a.paddingBottom;
        this.c1 = a.parentId;
        this.ah = a.isDisabled;
        if (!stringIsNullOrEmpty(a.textColor)) {
            this.ez = CSSColorUtil.a(a.textColor);
        }
        if (!stringIsNullOrEmpty(a.disabledTextColor)) {
            this.ev = CSSColorUtil.a(a.disabledTextColor);
        }
        if (a.actions != null && a.actions.length > 0) {
            for (var b = 0; b < a.actions.length; b++) {
                this.actions.add(ToolAction.c(a.actions[b]));
            }
        }
    };
    ToolAction.prototype.aj = function () {
        return this.d != null && this.d.d != null && this.d.actions._inner[0] == this;
    };
    ToolAction.prototype.am = function () {
        return true;
    };
    ToolAction.prototype.v = function (a) {
        switch (a) {
            case 1:
            case 6:
            case 11:
            case 10:
            case 2:
            case 12:
            case 13: return this.am() ? 2 : 0;
            default: return 0;
        }
    };
    Object.defineProperty(ToolAction.prototype, "y", {
        get: function () {
            return this.x;
        },
        enumerable: false,
        configurable: true
    });
    ToolAction.prototype.dn = function (a, b, c, d) {
        var _this = this;
        if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            NativeUIComponent.ar(this.j.p.v(), 7, function (e) {
                var f = e;
                _this.dl(f, c);
                _this.d8(f, b, c);
                if (d != null) {
                    d(f);
                }
            });
        }
        else {
            var e = a.bo;
            this.d8(e, b, c);
            if (d != null) {
                d(e);
            }
        }
    };
    ToolAction.prototype.dm = function (a, b, c, d) {
        var _this = this;
        if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            var e = [1, 7, 11, 3];
            var f = [this.v(1), this.v(7), this.v(11), this.v(3)];
            NativeUIComponent.as(this.j.p.v(), e, f, function (g) {
                var h = g[0];
                var i = g[1];
                var j = g[2];
                var k = g[3];
                _this.dk(h, i, j, k, c);
                if (d != null) {
                    d();
                }
            });
        }
        else {
            this.d7(this.w, this.z, this.aa);
            if (d != null) {
                d();
            }
        }
    };
    ToolAction.prototype.dl = function (a, b) {
        a.f = b.a == 1 ? 0 : 3;
        a.bo = 0;
    };
    ToolAction.prototype.d8 = function (a, b, c) {
        a.x = b.a.k;
        a.a4 = this.eo;
        a.bf = this.e1;
    };
    ToolAction.prototype.dk = function (a, b, c, d, e) {
        if (this.x.bi == 0) {
            this.x.bw(0, 2, 1);
            this.x.by(0, 2, 1);
            this.x.bj(a);
            this.x.b3(a, 0);
            this.x.b4(a, 0);
            a.bj = b;
            b.bo = 0;
            var f = this.a6(this.j, e);
            f = isNaN_(f) ? 0 : f;
            var g = this.a8(this.j, e);
            g = isNaN_(g) ? 0 : g - this.bh;
            b.by(0, 2, 1);
            b.bw(0, 1, f);
            b.bw(1, 1, g);
            b.bx(2, 2, 1, this.bh);
            b.bj(c);
            b.bj(d);
            b.b4(d, 0);
            b.b3(c, 0);
            b.b3(d, 1);
        }
        a.c = this.l;
        a.bk = 1;
        a.bi = 1;
        a.bu = new Thickness(1, 0, 0, 0, 0);
        a.g = 3;
        a.i = 3;
        a.bt = this.eq;
        a.bq = true;
        a.bo = !this.ad;
        a.bl = this.ac;
        a.bn = !this.ae;
        a.bp = true;
        a.bm = true;
        a.bh = runOn(this, this.ds);
        c.h = 1;
        c.f = 1;
        d.bh = false;
        d.h = 1;
        d.f = 0;
        this.w = b;
        this.u = a;
        this.z = c;
        this.aa = d;
    };
    ToolAction.prototype.ds = function (a, b) {
        this.dv();
    };
    ToolAction.prototype.d7 = function (a, b, c) {
        if (a != null) {
            a.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
        }
        if (b != null) {
            b.bd = new Thickness(1, 0, 0, 9, 0);
            b.bh = this.ba;
            b.bi = this.bb;
            b.bj = this.bc;
            b.bg = this.a9;
            b.bl = this.cl;
            b.bk = this.ci;
            b.a7 = this.er;
            b.a8 = this.es;
            b.ad = 28;
            b.x = 28;
        }
        if (c != null) {
            c.bi = this.da;
            c.bg = this.r;
            c.a6 = this.ah ? this.ep : this.et;
        }
    };
    ToolAction.prototype.de = function (a) {
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            if (this.x != null) {
                this.x.bq = null;
            }
        }
    };
    ToolAction.prototype.dv = function () {
    };
    ToolAction.prototype.du = function (a, b) {
    };
    ToolAction.prototype.d2 = function () {
    };
    ToolAction.prototype.df = function () {
    };
    ToolAction.prototype.d3 = function (a) {
        if (!stringIsNullOrEmpty(a.da)) {
            this.da = a.da;
        }
        if (!stringIsNullOrEmpty(a.c6)) {
            this.c6 = a.c6;
        }
        if (!stringIsNullOrEmpty(a.cl)) {
            this.cl = a.cl;
        }
        if (!stringIsNullOrEmpty(a.ci)) {
            this.ci = a.ci;
        }
        if (!stringIsNullOrEmpty(a.cd)) {
            this.cd = a.cd;
        }
        if (!stringIsNullOrEmpty(a.ca)) {
            this.ca = a.ca;
        }
        if (a.bk != null) {
            this.bk = a.bk;
        }
        if (a.eu != null) {
            this.eu = a.eu;
        }
        if (a.ew != null) {
            this.ew = a.ew;
        }
        if (a.ez != null) {
            this.ez = a.ez;
        }
        if (a.t != null) {
            this.t = a.t;
        }
        if (a.ev != null) {
            this.ev = a.ev;
        }
        if (a.ex != null) {
            this.ex = a.ex;
        }
        if (a.ey != null) {
            this.ey = a.ey;
        }
        if (!isNaN_(a.be)) {
            this.be = a.be;
        }
        if (!isNaN_(a.bg)) {
            this.bg = a.bg;
        }
        if (!isNaN_(a.bf)) {
            this.bf = a.bf;
        }
        if (!isNaN_(a.bd)) {
            this.bd = a.bd;
        }
        if (!isNaN_(a.bi)) {
            this.bi = a.bi;
        }
        if (this.e1 != a.e1) {
            this.e1 = a.e1;
        }
        if (a.actions != null && a.actions.count > 0) {
            this.actions.clear();
            for (var b = 0; b < a.actions.count; b++) {
                this.actions.add(a.actions._inner[b]);
            }
        }
    };
    ToolAction.$t = markType(ToolAction, 'ToolAction', Base.$, [INotifyPropertyChanged_$type]);
    return ToolAction;
}(Base));
export { ToolAction };
/**
 * @hidden
 */
var ToolActionButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionButton, _super);
    function ToolActionButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e2 = null;
        return _this;
    }
    ToolActionButton.prototype.get_m = function () {
        return 9;
    };
    ToolActionButton.prototype.n = function () {
        return null;
    };
    ToolActionButton.prototype.g = function (a) {
        var b = new ToolActionEventDetail();
        b.a = this;
        b.b = this.m;
        b.d = a;
        return b;
    };
    ToolActionButton.prototype.a8 = function (a, b) {
        return NaN;
    };
    ToolActionButton.prototype.a7 = function (a, b) {
        return 88;
    };
    ToolActionButton.prototype.e4 = function (a, b, c, d, e, f, g) {
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            a.bo = b;
            if (g.a == 1) {
                b.f = 0;
            }
            else {
                b.f = 3;
            }
            b.by(0, 2, 1);
            b.bw(0, 0, 1);
            b.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
            if (b.bi == 0) {
                b.bj(c);
            }
            b.b4(c, 0);
            b.b3(c, 0);
            this.e2 = c;
            this.e2.bk = 2;
            this.e2.bh = runOn(this, this.e3);
        }
        c.bs = this.da;
        b.x = f.a.k;
    };
    ToolActionButton.prototype.e3 = function (a, b) {
        this.dy(this.g(true), this);
    };
    ToolActionButton.prototype.d0 = function (a, b, c, d) {
        var _this = this;
        _super.prototype.d0.call(this, a, b, c, d);
        var e = c.b;
        if (e.bo == null || (e.am == null || EnumUtil.getEnumValue(ToolActionType_$type, e.am) != this.m)) {
            var f = [7, 1];
            var g = [0, 0];
            if (this.l >= 3 && this.l <= 6) {
                g = [0, 2];
            }
            NativeUIComponent.as(b.p.v(), f, g, function (h) {
                var i = h[0];
                var j = h[1];
                e.bo = i;
                _this.e4(e, i, j, a, b, c, d);
            });
            e.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            var h = e.bo;
            var i = h.bh(0);
            this.e4(e, h, i, a, b, c, d);
        }
    };
    ToolActionButton.$t = markType(ToolActionButton, 'ToolActionButton', ToolAction.$);
    return ToolActionButton;
}(ToolAction));
export { ToolActionButton };
/**
 * @hidden
 */
var ToolActionLabel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionLabel, _super);
    function ToolActionLabel() {
        var _this = _super.call(this) || this;
        _this.e2 = null;
        if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarDrillDownIcon") == null) {
            SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarDrillDownIcon", ToolActionLabel.e3);
        }
        return _this;
    }
    ToolActionLabel.prototype.get_ad = function () {
        return this.al() || this.actions.count > 0;
    };
    ToolActionLabel.prototype.get_m = function () {
        return 4;
    };
    ToolActionLabel.prototype.a7 = function (a, b) {
        return this.actions.count > 0 ? DeviceUtils.g(32) : _super.prototype.a7.call(this, a, b);
    };
    ToolActionLabel.prototype.e4 = function (a, b, c, d) {
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            if (b.bi == 2) {
                var e = this.a7(this.j, d);
                b.bw(3, 1, isNaN_(e) ? 0 : e);
                b.bj(c);
                b.b3(c, 3);
                b.b4(c, 0);
                c.bl = "ToolbarDrillDownIcon";
                c.bk = "IG_Default";
                c.f = 1;
                c.h = 1;
            }
        }
        c.a7 = this.et;
    };
    ToolActionLabel.prototype.dv = function () {
        if (this.actions.count > 0) {
            this.j.dy(this);
        }
        else {
            this.dy(this.g(false), this);
        }
    };
    ToolActionLabel.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
            if (this.actions.count > 0) {
                NativeUIComponent.aq(this.j.p.v(), 11, this.am() ? 2 : 0, function (e) {
                    _this.e2 = e;
                    _this.e4(d, a, _this.e2, c);
                });
            }
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            if (this.actions.count > 0) {
                this.e2 = a.bh(2);
                this.e4(d, a, this.e2, c);
            }
        }
    };
    ToolActionLabel.prototype.d4 = function (a, b, c) {
        _super.prototype.d4.call(this, a, b, c);
        switch (a) {
            case "ActualTextColor":
                if (this.e2 != null) {
                    this.e2.a6 = this.et;
                }
                break;
        }
    };
    ToolActionLabel.$t = markType(ToolActionLabel, 'ToolActionLabel', ToolAction.$);
    ToolActionLabel.e3 = "M 7.42 8.58 L 12 13.17 L 7.42 17.76 L 8.83 19.17 l 6 -6 l -6 -6 z";
    return ToolActionLabel;
}(ToolAction));
export { ToolActionLabel };
/**
 * @hidden
 */
var ToolActionRadio = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionRadio, _super);
    function ToolActionRadio() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e2 = null;
        _this.e5 = "channel_1";
        _this.e3 = false;
        return _this;
    }
    ToolActionRadio.prototype.get_m = function () {
        return 6;
    };
    Object.defineProperty(ToolActionRadio.prototype, "e6", {
        get: function () {
            return this.e5;
        },
        set: function (a) {
            this.e5 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolActionRadio.prototype, "e4", {
        get: function () {
            return this.e3;
        },
        set: function (a) {
            var b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.dx("IsChecked", b, this.e3);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolActionRadio.prototype.g = function (a) {
        var b = new ToolActionEventDetail();
        b.a = this;
        b.b = this.m;
        b.d = a;
        if (this.e2 != null) {
            b.c = this.e2.bj;
        }
        return b;
    };
    ToolActionRadio.prototype.bm = function () {
        return this.e2.bj;
    };
    ToolActionRadio.prototype.e8 = function () {
        if (this.e2 != null) {
            this.e2.bj = false;
            this.e3 = this.e2.bj;
        }
    };
    ToolActionRadio.prototype.a7 = function (a, b) {
        return 30;
    };
    ToolActionRadio.prototype.ea = function () {
        if (this.e2 != null) {
            this.e2.c = this.l;
        }
    };
    ToolActionRadio.prototype.dv = function () {
        this.e2.bj = true;
        this.e3 = this.e2.bj;
        this.dy(this.g(true), this);
    };
    ToolActionRadio.prototype.e9 = function (a, b) {
        if (this.e3) {
            this.e2.bj = true;
            return;
        }
        this.e3 = this.e2.bj;
        this.dy(this.g(true), this);
    };
    ToolActionRadio.prototype.fa = function (a, b, c, d, e) {
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            b.bw(3, 1, this.a7(this.j, e));
            if (b.bi == 2) {
                b.bj(c);
            }
            b.b4(c, 0);
            b.b3(c, 3);
            this.e2 = c;
            c.bi = true;
            c.f = 1;
            c.h = 1;
            c.bk = DeviceUtils.g(10);
            c.ad = DeviceUtils.g(20);
            c.x = DeviceUtils.g(20);
            c.bh = runOn(this, this.e9);
            a.am = enumGetBox(ToolActionType_$type, this.m);
        }
        this.e2.bj = this.e3;
        this.e2.c = this.l;
    };
    ToolActionRadio.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
            NativeUIComponent.aq(this.j.p.v(), 6, this.v(6), function (e) {
                var f = e;
                _this.fa(d, a, f, b, c);
            });
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            var e = a.bh(2);
            this.fa(d, a, e, b, c);
        }
    };
    ToolActionRadio.prototype.d4 = function (a, b, c) {
        _super.prototype.d4.call(this, a, b, c);
        switch (a) {
            case "IsChecked":
                if (this.e2 != null) {
                    this.e2.bj = this.e4;
                }
                break;
        }
    };
    ToolActionRadio.prototype.dp = function (a) {
        _super.prototype.dp.call(this, a);
        var b = a;
        this.e4 = b.isChecked;
        this.e6 = b.channel;
    };
    ToolActionRadio.$t = markType(ToolActionRadio, 'ToolActionRadio', ToolAction.$);
    return ToolActionRadio;
}(ToolAction));
export { ToolActionRadio };
/**
 * @hidden
 */
var ToolActionSeparator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionSeparator, _super);
    function ToolActionSeparator() {
        var _this = _super.call(this) || this;
        _this.e4 = DeviceUtils.g(2);
        _this.e2 = false;
        return _this;
    }
    Object.defineProperty(ToolActionSeparator.prototype, "e5", {
        get: function () {
            return this.e4;
        },
        set: function (a) {
            var b = this.e4;
            this.e4 = a;
            if (b != this.e4) {
                this.dx("Size", b, this.e4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolActionSeparator.prototype, "e3", {
        get: function () {
            return this.e2;
        },
        set: function (a) {
            var b = this.e2;
            this.e2 = a;
            if (b != this.e2) {
                this.dx("IsGroupHeaderSeparator", b, this.e2);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolActionSeparator.prototype.get_m = function () {
        return 7;
    };
    ToolActionSeparator.prototype.dj = function (a, b) {
        _super.prototype.dj.call(this, a, b);
        if (b.a == 1) {
            b.e = this.a2 + this.e5 + this.a3;
        }
        else {
            b.d = this.a4 + this.e5 + this.a1;
        }
    };
    ToolActionSeparator.prototype.dm = function (a, b, c, d) {
        if (d != null) {
            d();
        }
    };
    ToolActionSeparator.prototype.dl = function (a, b) {
        if (b.a == 1) {
            a.f = 0;
            a.h = 3;
        }
        else {
            a.f = 3;
        }
    };
    ToolActionSeparator.prototype.d8 = function (a, b, c) {
        if (c.a == 1) {
            a.ad = this.e5;
        }
        else {
            a.x = this.e5;
        }
        a.bd = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
        a.a4 = this.eo;
        a.bf = this.e1;
    };
    ToolActionSeparator.prototype.ea = function () {
        _super.prototype.ea.call(this);
        this.eo = this.eu != null ? this.eu : !this.e3 ? this.j.e2 : this.j.ex;
        if (this.j.o == 1) {
            this.a2 = !isNaN_(this.be) ? this.be : this.j.a4;
            this.a3 = !isNaN_(this.bf) ? this.bf : this.j.a5;
            this.a4 = !isNaN_(this.bg) ? this.bg : this.j.a6;
            this.a1 = !isNaN_(this.bd) ? this.bd : this.j.a3;
        }
        else {
            this.a2 = !isNaN_(this.be) ? this.be : this.j.a8;
            this.a3 = !isNaN_(this.bf) ? this.bf : this.j.a9;
            this.a4 = !isNaN_(this.bg) ? this.bg : this.j.ba;
            this.a1 = !isNaN_(this.bd) ? this.bd : this.j.a7;
        }
    };
    ToolActionSeparator.prototype.d4 = function (a, b, c) {
        _super.prototype.d4.call(this, a, b, c);
        switch (a) {
            case "Size":
                if (this.j != null) {
                    this.j.dx();
                }
                break;
            case "IsGroupHeaderSeparator":
                this.d9();
                break;
        }
    };
    ToolActionSeparator.prototype.dp = function (a) {
        _super.prototype.dp.call(this, a);
        var b = a;
        this.e5 = b.size;
        this.e3 = b.isGroupHeaderSeparator;
    };
    ToolActionSeparator.$t = markType(ToolActionSeparator, 'ToolActionSeparator', ToolAction.$);
    return ToolActionSeparator;
}(ToolAction));
export { ToolActionSeparator };
/**
 * @hidden
 */
var ToolActionIconButton = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionIconButton, _super);
    function ToolActionIconButton() {
        var _this = _super.call(this) || this;
        _this.e7 = null;
        _this.e3 = null;
        _this.e2 = null;
        _this.fh = -1;
        _this.fi = -1;
        _this.fd = false;
        _this.fa = false;
        _this.e9 = false;
        _this.fc = false;
        _this.fj = 500;
        _this.fe = false;
        _this.e4 = null;
        _this.e6 = null;
        _this.e5 = null;
        _this.fb = false;
        if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "igDropDownArrow") == null) {
            SvgIconRegistry.instance.addSvgPathString("IG_Default", "igDropDownArrow", "M0,0L3,3L6,0");
        }
        _this.e2 = new DelayManager(0);
        return _this;
    }
    ToolActionIconButton.prototype.get_m = function () {
        return 3;
    };
    ToolActionIconButton.prototype.get_ak = function () {
        return false;
    };
    Object.defineProperty(ToolActionIconButton.prototype, "e8", {
        get: function () {
            return this.e7;
        },
        enumerable: false,
        configurable: true
    });
    ToolActionIconButton.prototype.get_fg = function () {
        return this.e3 != null;
    };
    Object.defineProperty(ToolActionIconButton.prototype, "fg", {
        get: function () {
            return this.get_fg();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolActionIconButton.prototype, "ff", {
        get: function () {
            return this.fc;
        },
        set: function (a) {
            this.fc = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolActionIconButton.prototype, "fk", {
        get: function () {
            return this.fj;
        },
        set: function (a) {
            this.fj = a;
        },
        enumerable: false,
        configurable: true
    });
    ToolActionIconButton.prototype.dd = function () {
        _super.prototype.dd.call(this);
        NativeUIWindow.d(14, runOn(this, this.f0));
        this.e9 = false;
    };
    ToolActionIconButton.prototype.n = function () {
        return null;
    };
    ToolActionIconButton.prototype.g = function (a) {
        var b = new ToolActionEventDetail();
        b.a = this;
        b.b = this.m;
        b.d = a;
        return b;
    };
    ToolActionIconButton.prototype.a6 = function (a, b) {
        return DeviceUtils.g(36);
    };
    ToolActionIconButton.prototype.a8 = function (a, b) {
        return NaN;
    };
    ToolActionIconButton.prototype.dm = function (a, b, c, d) {
        if (d != null) {
            d();
        }
    };
    ToolActionIconButton.prototype.de = function (a) {
        _super.prototype.de.call(this, a);
    };
    ToolActionIconButton.prototype.f2 = function (a, b, c, d, e) {
        var f = c.bj;
        if (e) {
            b.b1(2);
            b.b1(1);
            if (b.bi == 0) {
                b.bj(c);
            }
            b.b4(c, 0);
            b.b3(c, 0);
            c.c = this.l;
            c.bk = 2;
            c.bi = 4;
            c.bp = true;
            f.ad = DeviceUtils.g(28);
            f.x = DeviceUtils.g(28);
        }
        b.br = false;
        b.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
        f.bl = this.cl;
        f.bk = this.ci;
        f.bh = this.ba;
        f.bi = this.bb;
        f.bj = this.bc;
        f.bg = this.a9;
        f.a7 = this.et;
        f.a8 = this.et;
        if (this.e4 != c) {
            c.bh = runOn(this, this.fr);
            c.q = runOn(this, this.ft);
            c.s = runOn(this, this.fu);
            c.o = runOn(this, this.fs);
            this.e4 = c;
        }
        if (this.e6 != f) {
            this.e6 = f;
        }
    };
    ToolActionIconButton.prototype.f3 = function (a, b) {
        if (this.e7 != b) {
            this.e7 = b;
            this.e7.bz = this.j.bb;
            this.e7.b6 = BrushUtil.g(255, 255, 255, 255);
            this.e7.bo = 1;
            this.e7.bw = true;
            this.e7.b0 = 100;
            this.e7.bv = true;
            this.e7.b1 = truncate(this.j.bc);
            this.e7.bx = true;
            this.e7.bt = 0;
            if (a.bi != 2) {
                a.bj(this.e7);
            }
            this.fm();
            this.e7.q = runOn(this, this.fy);
            this.e7.s = runOn(this, this.fz);
            this.e7.n = runOn(this, this.fw);
            this.e7.o = runOn(this, this.fx);
            if (!this.e9) {
                NativeUIWindow.c(14, runOn(this, this.f0));
                this.e9 = true;
            }
        }
        if (this.actions.count > 0) {
            this.e7.u = true;
        }
        else {
            this.e7.u = false;
        }
    };
    ToolActionIconButton.prototype.fm = function () {
        var _this = this;
        if (this.e7.bi == 0) {
            this.e3 = new TooltipTextPresenter(this.j.p.v());
            this.e3.s(function () { return _this.e7.bj(_this.e3.e); });
        }
        else {
            this.e3 = this.e7.bh(0).am;
        }
        this.e3.x = this.j.e5;
        this.e3.y = this.j.e6;
        this.e3.o = this.da;
        this.e7.b7 = this.e3.x;
    };
    ToolActionIconButton.prototype.fo = function () {
    };
    ToolActionIconButton.prototype.fn = function () {
    };
    ToolActionIconButton.prototype.fp = function () {
        if (this.e3 != null) {
            this.e7.b7 = this.j.e5;
            this.e3.x = this.j.e5;
            this.e3.y = this.j.e6;
            this.e7.bz = this.j.bb;
            this.e7.b1 = truncate(this.j.bc);
        }
    };
    ToolActionIconButton.prototype.f0 = function () {
        if (this.e4 != null) {
            var a = this.e4.ba();
            this.e7.b4(a);
        }
    };
    ToolActionIconButton.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
            NativeUIComponent.as(this.j.p.v(), [10, 12], [this.v(10), this.v(12)], function (e) {
                _this.f2(d, a, e[0], c, true);
                _this.f3(a, e[1]);
            });
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            var e = a.bh(0);
            var f = a.bh(1);
            this.f2(d, a, e, c, false);
            this.f3(a, f);
        }
    };
    ToolActionIconButton.prototype.ea = function () {
        _super.prototype.ea.call(this);
        this.a2 = !isNaN_(this.be) ? this.be : DeviceUtils.g(4);
        this.a3 = !isNaN_(this.bf) ? this.bf : DeviceUtils.g(4);
        if (this.e4 != null) {
            this.e4.c = this.l;
            if (typeCast(NativeUIIconButton.$, this.e4) !== null) {
                this.e4.a7 = this.et;
                this.e4.a8 = this.et;
            }
        }
        if (this.e6 != null) {
            this.e6.a7 = this.et;
            this.e6.a8 = this.et;
        }
        if (this.e5 != null) {
            this.e5.a8 = this.et;
        }
        this.fp();
    };
    ToolActionIconButton.prototype.dw = function () {
        if (this.e6 != null) {
            this.e6.bl = this.cl;
            this.e6.bk = this.ci;
        }
    };
    ToolActionIconButton.prototype.d2 = function () {
        if (this.actions.count > 0) {
            if (this.e7 == null || !this.fg) {
                this.fc = true;
            }
            else {
                this.f1();
                this.fd = true;
            }
        }
    };
    ToolActionIconButton.prototype.df = function () {
        if (this.actions.count > 0) {
            if (this.e7 == null || !this.fg) {
                this.fc = false;
            }
            else {
                this.fl();
            }
        }
    };
    ToolActionIconButton.prototype.f1 = function (a) {
        if (a === void 0) {
            a = false;
        }
        if (!this.fe) {
            this.j.dc();
            if (this.actions.count == 0 && stringIsNullOrEmpty(this.da)) {
                return;
            }
            var b = this.e4.ba();
            this.e7.b5(b, 1, 3);
            this.fe = true;
            this.fo();
        }
        this.fd = a;
        this.fc = false;
    };
    ToolActionIconButton.prototype.fl = function () {
        var _this = this;
        if (this.fe) {
            this.e7.b2();
            this.fe = false;
            this.e2.f(function () { return _this.fn(); }, 100);
            this.fd = false;
        }
    };
    ToolActionIconButton.prototype.fv = function () {
        this.f1();
        this.fi = -1;
    };
    ToolActionIconButton.prototype.fq = function () {
        this.fl();
        this.fh = -1;
    };
    ToolActionIconButton.prototype.ft = function (a, b) {
        this.fa = true;
        if (this.fh != -1) {
            this.e2.g(this.fh);
            this.fh = -1;
        }
        if (!this.fe) {
            if (this.actions.count > 0 && !this.j.ac) {
                return;
            }
            this.fi = this.e2.f(runOn(this, this.fv), this.fk);
        }
    };
    ToolActionIconButton.prototype.fu = function (a, b) {
        if (this.fi != -1) {
            this.e2.g(this.fi);
            this.fi = -1;
        }
        if (this.fe && !this.fd) {
            this.fh = this.e2.f(runOn(this, this.fq), 50);
        }
        this.fa = false;
    };
    ToolActionIconButton.prototype.fr = function (a, b) {
        if (this.actions.count > 0) {
            if (!this.fe) {
                if (this.fi != -1) {
                    this.e2.g(this.fi);
                    this.fi = -1;
                }
                this.f1();
                this.fd = true;
            }
            else {
                this.fl();
            }
        }
        else {
            this.dy(this.g(true), this);
        }
    };
    ToolActionIconButton.prototype.fy = function (a, b) {
        this.fb = true;
        if (this.fh != -1) {
            this.e2.g(this.fh);
            this.fh = -1;
        }
    };
    ToolActionIconButton.prototype.fz = function (a, b) {
        if (!this.fd) {
            this.fh = this.e2.f(runOn(this, this.fq), 50);
        }
        this.fb = false;
    };
    ToolActionIconButton.prototype.fw = function (a, b) {
        this.fd = true;
    };
    ToolActionIconButton.prototype.fx = function (a, b) {
        if (!this.e7.t(b.a) && !this.e4.t(b.a)) {
            this.fl();
        }
    };
    ToolActionIconButton.prototype.fs = function (a, b) {
        if (this.fe) {
            if (!this.e7.t(b.a) && !this.e4.t(b.a)) {
                this.fl();
            }
        }
    };
    ToolActionIconButton.prototype.d4 = function (a, b, c) {
        _super.prototype.d4.call(this, a, b, c);
        switch (a) {
            case "ExecutionContext":
                this.e2.b = this.b;
                break;
            case "Title":
                if (this.e3 != null) {
                    this.e3.o = this.da;
                }
                break;
        }
    };
    ToolActionIconButton.prototype.dp = function (a) {
        _super.prototype.dp.call(this, a);
        var b = a;
        this.fk = b.tooltipDelay;
        if (b.isMenuOpenOnStart) {
            this.d2();
        }
    };
    ToolActionIconButton.$t = markType(ToolActionIconButton, 'ToolActionIconButton', ToolAction.$);
    return ToolActionIconButton;
}(ToolAction));
export { ToolActionIconButton };
/**
 * @hidden
 */
var ToolActionGroupHeader = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionGroupHeader, _super);
    function ToolActionGroupHeader() {
        var _this = _super.call(this) || this;
        _this.e2 = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 13;
            $ret.q = "Normal";
            $ret.s = "Bold";
            $ret.o = "Normal";
            return $ret;
        })());
        _this.e3 = null;
        _this.e9 = null;
        _this.fa = null;
        if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarBackButton") == null) {
            SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarBackButton", ToolActionGroupHeader.e5);
        }
        return _this;
    }
    ToolActionGroupHeader.prototype.get_m = function () {
        return 1;
    };
    ToolActionGroupHeader.prototype.get_ad = function () {
        return false;
    };
    ToolActionGroupHeader.prototype.get_ae = function () {
        return false;
    };
    ToolActionGroupHeader.prototype.get_ai = function () {
        return false;
    };
    Object.defineProperty(ToolActionGroupHeader.prototype, "fb", {
        get: function () {
            return this.e9;
        },
        set: function (a) {
            var b = this.e9;
            this.e9 = a;
            if (b != this.e9) {
                this.dx("ActualBackIconColor", b, this.e9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolActionGroupHeader.prototype, "fc", {
        get: function () {
            return this.fa;
        },
        set: function (a) {
            var b = this.fa;
            this.fa = a;
            if (b != this.fa) {
                this.dx("BackIconColor", b, this.fa);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolActionGroupHeader.prototype.s = function (a) {
        return this.e2;
    };
    ToolActionGroupHeader.prototype.a5 = function (a, b) {
        return this.aj() ? DeviceUtils.g(36) : NaN;
    };
    ToolActionGroupHeader.prototype.e8 = function (a, b, c, d) {
        var e = c.bj;
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            if (b.bi == 2) {
                b.bj(c);
                b.bz(0, 1, this.a5(this.j, d));
                b.b3(b.bh(0), 1);
                b.b3(b.bh(1), 2);
                b.b3(c, 0);
                b.b4(c, 0);
                c.c = this.l;
                c.h = 1;
                c.f = 1;
                c.bd = new Thickness(1, -9, 0, 9, 0);
                c.bh = runOn(this, this.e7);
                this.e3 = c;
                e.bl = "ToolbarBackButton";
                e.bk = "IG_Default";
            }
        }
        e.a7 = this.fb;
    };
    ToolActionGroupHeader.prototype.e7 = function (a, b) {
        this.j.dz(this);
    };
    ToolActionGroupHeader.prototype.de = function (a) {
        _super.prototype.de.call(this, a);
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            if (this.aj() && this.e3 != null) {
                this.e3.bh = null;
            }
        }
    };
    ToolActionGroupHeader.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
            if (this.aj()) {
                NativeUIComponent.aq(this.j.p.v(), 10, this.am() ? 2 : 0, function (e) { return _this.e8(d, a, e, c); });
            }
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            if (this.aj()) {
                var e = a.bh(2);
                this.e8(d, a, e, c);
            }
        }
    };
    ToolActionGroupHeader.prototype.ea = function () {
        _super.prototype.ea.call(this);
        if (this.e3 != null) {
            this.e3.c = this.l;
        }
        this.eo = this.eu != null ? this.eu : this.j.ew;
        this.et = this.ez != null ? this.ez : this.j.ey;
        this.fb = this.fc != null ? this.fc : this.et;
        this.r = this.t != null ? this.t : this.e2;
    };
    ToolActionGroupHeader.$t = markType(ToolActionGroupHeader, 'ToolActionGroupHeader', ToolAction.$);
    ToolActionGroupHeader.e5 = "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z";
    return ToolActionGroupHeader;
}(ToolAction));
export { ToolActionGroupHeader };
/**
 * @hidden
 */
var ToolActionIconMenu = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionIconMenu, _super);
    function ToolActionIconMenu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f4 = null;
        return _this;
    }
    ToolActionIconMenu.prototype.get_m = function () {
        return 8;
    };
    ToolActionIconMenu.prototype.get_fg = function () {
        return this.f4 != null;
    };
    ToolActionIconMenu.prototype.fm = function () {
        var _this = this;
        if (this.e8.bi > 0) {
            while (this.e8.bi > 0) {
                this.e8.bm(0);
            }
        }
        if (this.f4 != null) {
            this.f4.s = null;
        }
        this.f4 = new ToolPanelsPresenter(this.j.p.v(), this.b);
        this.f4.n = this.l;
        this.f4.ai(function () {
            _this.f4.ae(_this, function (a) {
                _this.f4.aj(a);
                if (_this.actions._inner[0].eo != null && !BrushUtilCore.a(_this.actions._inner[0].eo)) {
                    _this.e8.b7 = _this.actions._inner[0].eo;
                }
                else {
                    _this.e8.b7 = _this.j.e3;
                }
                if (_this.ff) {
                    _this.b.executeDelayed(function () { return _this.f1(true); }, 100);
                }
            });
            _this.f4.r.a3 = new CornerRadius(0, 8);
            _this.f4.r.a4 = _this.j.e3;
            _this.e8.bj(_this.f4.r);
        });
        this.f4.s = runOn(this, this.f5);
    };
    ToolActionIconMenu.prototype.fo = function () {
        if (this.f4 != null) {
            this.f4.am();
        }
    };
    ToolActionIconMenu.prototype.fn = function () {
        if (this.f4 != null) {
            this.f4.aw();
            this.e8.b3();
        }
    };
    ToolActionIconMenu.prototype.fp = function () {
        if (this.f4 != null) {
            this.f4.ax(this.l, this.j);
            if (this.actions._inner[0].eo != null && !BrushUtilCore.a(this.actions._inner[0].eo)) {
                this.e8.b7 = this.actions._inner[0].eo;
            }
            else {
                this.e8.b7 = this.j.e3;
            }
            this.e8.bz = 8;
            this.e8.b1 = 4;
        }
    };
    ToolActionIconMenu.prototype.f6 = function (a, b, c, d, e, f, g) {
        if (g) {
            a.b1(2);
            a.b1(1);
            if (a.bi == 0) {
                c.bw(0, 1, DeviceUtils.g(28));
                c.bw(1, 1, DeviceUtils.g(6));
                c.bj(d);
                c.bj(e);
                c.b3(d, 0);
                c.b3(e, 1);
                b.bj = c;
                a.bj(b);
            }
            a.b4(b, 0);
            a.b3(b, 0);
            b.c = this.l;
            b.bk = 2;
            b.bi = 4;
            b.bp = true;
            d.ad = DeviceUtils.g(28);
            d.x = DeviceUtils.g(28);
            d.h = 1;
            e.ad = DeviceUtils.g(6);
            e.x = DeviceUtils.g(3);
            e.h = 1;
            e.bd = new Thickness(1, -4, 0, 0, 0);
            e.bl = "igDropDownArrow";
            e.bk = "IG_Default";
            e.bh = 0;
            e.bi = 0;
            e.bj = 6;
            e.bg = 3;
            e.a7 = BrushUtil.g(0, 0, 0, 0);
            e.ab = DeviceUtils.g(1);
        }
        a.br = false;
        a.be = new Thickness(1, this.a2, this.a4, this.a3, this.a1);
        d.bl = this.cl;
        d.bk = this.ci;
        d.bh = this.ba;
        d.bi = this.bb;
        d.bj = this.bc;
        d.bg = this.a9;
        d.a7 = this.et;
        d.a8 = this.et;
        e.a8 = this.et;
        if (this.e4 != b) {
            b.bh = runOn(this, this.fr);
            b.q = runOn(this, this.ft);
            b.s = runOn(this, this.fu);
            b.o = runOn(this, this.fs);
            this.e4 = b;
        }
        if (this.e6 != d) {
            this.e6 = d;
        }
        if (this.e5 != e) {
            this.e5 = e;
        }
    };
    ToolActionIconMenu.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
            var e = [1, 7, 11, 11, 12];
            var f = [this.v(1), this.v(7), this.v(11), this.v(11), this.v(12)];
            NativeUIComponent.as(this.j.p.v(), e, f, function (g) {
                _this.f6(a, g[0], g[1], g[2], g[3], c, true);
                _this.f3(a, g[4]);
            });
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            var g = a.bh(0);
            var h = g.bj;
            var i = h.bh(0);
            var j = h.bh(1);
            var k = a.bh(1);
            this.f6(a, g, h, i, j, c, false);
            this.f3(a, k);
        }
    };
    ToolActionIconMenu.prototype.f5 = function (a) {
        this.d6(a.a);
    };
    ToolActionIconMenu.$t = markType(ToolActionIconMenu, 'ToolActionIconMenu', ToolActionIconButton.$);
    return ToolActionIconMenu;
}(ToolActionIconButton));
export { ToolActionIconMenu };
/**
 * @hidden
 */
var ToolActionCheckbox = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionCheckbox, _super);
    function ToolActionCheckbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e2 = null;
        _this.e3 = false;
        return _this;
    }
    ToolActionCheckbox.prototype.get_m = function () {
        return 2;
    };
    ToolActionCheckbox.prototype.get_ac = function () {
        return false;
    };
    Object.defineProperty(ToolActionCheckbox.prototype, "e4", {
        get: function () {
            return this.e3;
        },
        set: function (a) {
            var b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.dx("IsChecked", b, this.e3);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolActionCheckbox.prototype.g = function (a) {
        var b = new ToolActionEventDetail();
        b.a = this;
        b.b = this.m;
        b.d = a;
        if (this.e2 != null) {
            b.c = this.e2.bj;
        }
        return b;
    };
    ToolActionCheckbox.prototype.bm = function () {
        return this.e2.bj;
    };
    ToolActionCheckbox.prototype.a7 = function (a, b) {
        return DeviceUtils.g(32);
    };
    ToolActionCheckbox.prototype.de = function (a) {
        _super.prototype.de.call(this, a);
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            if (this.e2 != null) {
                this.e2.bh = null;
            }
        }
    };
    ToolActionCheckbox.prototype.dv = function () {
        this.e2.bj = !this.e2.bj;
        this.e3 = this.e2.bj;
        this.dy(this.g(true), this);
    };
    ToolActionCheckbox.prototype.e7 = function (a, b, c, d, e) {
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            b.bw(3, 1, this.a7(this.j, e));
            if (b.bi == 2) {
                b.bj(c);
            }
            b.b4(c, 0);
            b.b3(c, 3);
            this.e2 = c;
            c.bi = true;
            c.f = 1;
            c.h = 1;
            c.ad = DeviceUtils.g(20);
            c.x = DeviceUtils.g(20);
            c.bh = runOn(this, this.e6);
        }
        this.e2.bj = this.e3;
        this.e2.c = this.l;
    };
    ToolActionCheckbox.prototype.e6 = function (a, b) {
        this.e3 = this.e2.bj;
        this.dy(this.g(true), this);
    };
    ToolActionCheckbox.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m) {
            NativeUIComponent.aq(this.j.p.v(), 6, this.v(6), function (e) {
                var f = e;
                _this.e7(d, a, f, b, c);
            });
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            var e = a.bh(2);
            this.e7(d, a, e, b, c);
        }
    };
    ToolActionCheckbox.prototype.ea = function () {
        if (this.e2 != null) {
            this.e2.c = this.l;
        }
    };
    ToolActionCheckbox.prototype.d4 = function (a, b, c) {
        _super.prototype.d4.call(this, a, b, c);
        switch (a) {
            case "IsChecked":
                if (this.e2 != null) {
                    this.e2.bj = this.e3;
                }
                break;
        }
    };
    ToolActionCheckbox.prototype.dp = function (a) {
        _super.prototype.dp.call(this, a);
        var b = a;
        this.e4 = b.isChecked;
    };
    ToolActionCheckbox.$t = markType(ToolActionCheckbox, 'ToolActionCheckbox', ToolAction.$);
    return ToolActionCheckbox;
}(ToolAction));
export { ToolActionCheckbox };
/**
 * @hidden
 */
var ToolActionNumberInput = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionNumberInput, _super);
    function ToolActionNumberInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e2 = null;
        _this.e3 = 0;
        return _this;
    }
    ToolActionNumberInput.prototype.get_m = function () {
        return 5;
    };
    Object.defineProperty(ToolActionNumberInput.prototype, "e5", {
        get: function () {
            return this.e3;
        },
        set: function (a) {
            var b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.dx("Value", b, this.e3);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolActionNumberInput.prototype.bm = function () {
        return this.e4();
    };
    ToolActionNumberInput.prototype.a7 = function (a, b) {
        return DeviceUtils.g(70);
    };
    ToolActionNumberInput.prototype.e4 = function () {
        var _this = this;
        var a;
        a = NaN;
        if (this.e2 != null && ((function () { var b = tryParseNumber(_this.e2.bq, a); a = b.p1; return b.ret; })())) {
        }
        return a;
    };
    ToolActionNumberInput.prototype.g = function (a) {
        var b = new ToolActionEventDetail();
        b.a = this;
        b.d = a;
        b.b = this.m;
        var c;
        b.f = this.e4();
        return b;
    };
    ToolActionNumberInput.prototype.e7 = function (a, b) {
        this.e5 = this.e4();
        var c = this.g(true);
        this.dy(c, this);
    };
    ToolActionNumberInput.prototype.e8 = function (a, b, c, d, e) {
        if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.m) {
            var f = this.a7(this.j, e);
            b.bw(3, 1, f);
            if (b.bi == 2) {
                b.bj(c);
            }
            b.b4(c, 0);
            b.b3(c, 3);
            this.e2 = c;
            c.ad = f;
            c.bj = 2;
            c.bm = 1;
            c.f = 2;
            c.h = 1;
            c.bn = 1;
            c.bi = 2;
            c.bp = false;
            c.bl = runOn(this, this.e7);
        }
        c.c = this.l;
        c.bt = this.ah ? this.ep : this.et;
        c.bg = this.r;
        c.bo = this.ah;
        if (!isNaN_(this.e5)) {
            c.bq = this.e5.toString();
        }
    };
    ToolActionNumberInput.prototype.d1 = function (a, b, c) {
        var _this = this;
        var d = b.b;
        if (d.bo == null || (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.m)) {
            NativeUIComponent.aq(this.j.p.v(), 2, this.v(2), function (e) {
                var f = e;
                _this.e8(d, a, f, b, c);
            });
            d.am = enumGetBox(ToolActionType_$type, this.m);
        }
        else {
            var e = a.bh(2);
            this.e8(d, a, e, b, c);
        }
    };
    ToolActionNumberInput.prototype.ea = function () {
        if (this.e2 != null) {
            this.e2.c = this.l;
        }
    };
    ToolActionNumberInput.prototype.d4 = function (a, b, c) {
        _super.prototype.d4.call(this, a, b, c);
        switch (a) {
            case "IsDisabled":
                if (this.e2 != null) {
                    this.e2.bo = this.ah;
                    this.e2.bt = this.ah ? this.ep : this.et;
                }
                break;
        }
    };
    ToolActionNumberInput.prototype.dv = function () {
        if (this.e2 != null && !this.ah) {
            this.e2.aw();
        }
    };
    ToolActionNumberInput.prototype.dp = function (a) {
        _super.prototype.dp.call(this, a);
        var b = a;
        this.e5 = b.value;
    };
    ToolActionNumberInput.$t = markType(ToolActionNumberInput, 'ToolActionNumberInput', ToolAction.$);
    return ToolActionNumberInput;
}(ToolAction));
export { ToolActionNumberInput };
/**
 * @hidden
 */
var ToolActionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionCollection, _super);
    function ToolActionCollection() {
        var _this = _super.call(this, ToolAction.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    ToolActionCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    ToolActionCollection.$t = markType(ToolActionCollection, 'ToolActionCollection', ObservableCollection$1.$.specialize(ToolAction.$));
    return ToolActionCollection;
}(ObservableCollection$1));
export { ToolActionCollection };
/**
 * @hidden
 */
var ToolActionPerformedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionPerformedEventArgs, _super);
    function ToolActionPerformedEventArgs() {
        var _this = _super.call(this) || this;
        _this.c = false;
        _this.a = null;
        _this.b = null;
        _this.b = new ToolActionEventDetailCollection();
        return _this;
    }
    ToolActionPerformedEventArgs.$t = markType(ToolActionPerformedEventArgs, 'ToolActionPerformedEventArgs');
    return ToolActionPerformedEventArgs;
}(Base));
export { ToolActionPerformedEventArgs };
/**
 * @hidden
 */
var ToolActionEventDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionEventDetail, _super);
    function ToolActionEventDetail() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = 0;
        _this.d = false;
        _this.c = false;
        _this.f = 0;
        _this.e = new Date();
        _this.g = null;
        return _this;
    }
    ToolActionEventDetail.$t = markType(ToolActionEventDetail, 'ToolActionEventDetail');
    return ToolActionEventDetail;
}(Base));
export { ToolActionEventDetail };
/**
 * @hidden
 */
var ToolActionEventDetailCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolActionEventDetailCollection, _super);
    function ToolActionEventDetailCollection() {
        return _super.call(this, ToolActionEventDetail.$, 0) || this;
    }
    ToolActionEventDetailCollection.$t = markType(ToolActionEventDetailCollection, 'ToolActionEventDetailCollection', ObservableCollection$1.$.specialize(ToolActionEventDetail.$));
    return ToolActionEventDetailCollection;
}(ObservableCollection$1));
export { ToolActionEventDetailCollection };
/**
 * @hidden
 */
var ToolPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolPanel, _super);
    function ToolPanel() {
        var _this = _super.call(this) || this;
        _this.p = null;
        _this.v = null;
        _this.y = false;
        _this.w = null;
        _this.i = new ToolActionMeasurementContext();
        _this.propertyChanged = null;
        _this.g = new ToolActionCollection();
        _this.contentRefreshed = null;
        _this.aa = true;
        _this.z = false;
        _this.ae = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
        _this.af = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
        _this.ad = new Dictionary$2(String_$type, ToolAction.$, 0);
        _this.s = null;
        _this.a = null;
        _this.q = 0;
        _this.eh = null;
        _this.d4 = null;
        _this.eq = null;
        _this.ed = null;
        _this.ej = null;
        _this.d6 = null;
        _this.ep = null;
        _this.ec = null;
        _this.ek = null;
        _this.d7 = null;
        _this.em = null;
        _this.d9 = null;
        _this.d = null;
        _this.ar = Number.POSITIVE_INFINITY;
        _this.er = null;
        _this.ee = null;
        _this.ei = null;
        _this.d5 = null;
        _this.el = null;
        _this.d8 = null;
        _this.et = null;
        _this.eg = null;
        _this.es = null;
        _this.ef = null;
        _this.a0 = NaN;
        _this.ap = NaN;
        _this.a1 = NaN;
        _this.aq = NaN;
        _this.en = null;
        _this.ea = null;
        _this.eo = null;
        _this.eb = null;
        _this.ax = NaN;
        _this.am = NaN;
        _this.ay = NaN;
        _this.an = NaN;
        _this.az = NaN;
        _this.ao = NaN;
        _this.aw = NaN;
        _this.al = NaN;
        _this.at = NaN;
        _this.ai = NaN;
        _this.au = NaN;
        _this.aj = NaN;
        _this.av = NaN;
        _this.ak = NaN;
        _this.as = NaN;
        _this.ah = NaN;
        _this.m = ToolPanel.n;
        _this.onCommand = null;
        _this.e = 0;
        _this.drillDownRequested = null;
        _this.drillUpRequested = null;
        var a = _this.actions;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.c8));
        NativeUIXInputsFactory.j();
        NativeUIInputsFactory.n();
        NativeUILayoutFactory.e();
        var b = new ToolPanelView();
        b.c = _this;
        _this.p = b;
        _this.p.ab();
        _this.d3();
        return _this;
    }
    Object.defineProperty(ToolPanel.prototype, "x", {
        get: function () {
            if (this.w == null) {
                this.w = new SRProvider(this.p.n);
                this.w.cb("Layouts");
            }
            return this.w;
        },
        enumerable: false,
        configurable: true
    });
    ToolPanel.prototype.dh = function (a) {
        this.d = a;
        var b = this.d;
        b.rowUpdating = delegateCombine(b.rowUpdating, runOn(this, this.c7));
        var c = this.d;
        c.contentRefreshed = delegateCombine(c.contentRefreshed, runOn(this, this.c4));
        this.d.k = this.o;
        this.d.ai = true;
        var d = this.d;
        d.itemHeightRequested = delegateCombine(d.itemHeightRequested, runOn(this, this.c5));
        var e = this.d;
        e.itemWidthRequested = delegateCombine(e.itemWidthRequested, runOn(this, this.c6));
    };
    ToolPanel.prototype.c4 = function (a, b) {
        if (this.contentRefreshed != null) {
            this.contentRefreshed(this, new ToolPanelContentRefreshedEventArgs());
        }
    };
    ToolPanel.prototype.c5 = function (a, b) {
        var c = b.c;
        var d = new ToolActionMeasurementContext();
        this.dq(d);
        c.di(this, d);
        if (c.e1 == 0) {
            if (!isNaN_(d.d)) {
                b.a = d.d;
            }
            else {
                b.a = this.d.av;
            }
        }
        else {
            b.a = 0;
        }
    };
    ToolPanel.prototype.c6 = function (a, b) {
        var c = b.c;
        var d = new ToolActionMeasurementContext();
        this.dq(d);
        c.di(this, d);
        if (c.e1 == 0) {
            if (!isNaN_(d.e)) {
                b.a = d.e;
            }
        }
        else {
            b.a = 0;
        }
    };
    ToolPanel.prototype.c7 = function (a, b) {
        var c = b.a.o;
        var d = a;
        if (this.o == 1) {
            var e = new ToolActionMeasurementContext();
            this.dq(e);
            c.di(this, e);
            c.dz(d, this, b, e);
        }
        else {
            c.dz(d, this, b, this.i);
        }
    };
    ToolPanel.prototype.dm = function (a) {
        this.ar = a.width;
        this.du();
        this.d.notifySizeChanged();
    };
    Object.defineProperty(ToolPanel.prototype, "actions", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (b != this.g) {
                this.dn("Actions", b, this.g);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ac", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.dn("ShowOnHover", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolPanel.prototype.c8 = function (a, b) {
        var e_4, _a, e_5, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        var d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.di));
                    }
                    c.dd();
                    c.b = null;
                    c.j = null;
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        var f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.di));
                    }
                    e.b = this.a;
                    e.j = this;
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        this.d2(this.actions);
        this.dl();
    };
    ToolPanel.prototype.c9 = function (a, b) {
        for (var c = 0; c < this.actions.count; c++) {
            if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[c]) !== null) {
                var d = this.actions._inner[c];
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.di));
            }
            this.actions._inner[c].dd();
            this.actions._inner[c].b = null;
            this.actions._inner[c].j = null;
        }
    };
    ToolPanel.prototype.dl = function () {
        this.du();
    };
    ToolPanel.prototype.du = function () {
        if (this.z) {
            return;
        }
        this.z = true;
        this.a.enqueueAction(runOn(this, this.de));
    };
    ToolPanel.prototype.dw = function () {
        this.z = true;
        this.de();
    };
    ToolPanel.prototype.de = function () {
        if (!this.z) {
            return;
        }
        this.z = false;
        this.da();
        this.d0();
        for (var a = 0; a < this.g.count; a++) {
            this.j(this.g._inner[a]);
        }
        this.df();
    };
    ToolPanel.prototype.da = function () {
        this.ae.clear();
        this.af.clear();
        this.ad.clear();
        for (var a = 0; a < this.g.count; a++) {
            this.g._inner[a].j = this;
            if (this.g._inner[a].cs != null) {
                this.ad.item(this.g._inner[a].cs, this.g._inner[a]);
            }
        }
        for (var b = 0; b < this.g.count; b++) {
            if (this.g._inner[b].c1 != null) {
                if (this.ad.containsKey(this.g._inner[b].c1)) {
                    if (!this.ae.containsKey(this.g._inner[b].c1)) {
                        this.ae.item(this.g._inner[b].c1, new List$1(ToolAction.$, 0));
                    }
                    var c = this.ae.item(this.g._inner[b].c1);
                    c.add(this.g._inner[b]);
                }
            }
        }
        for (var d = 0; d < this.g.count; d++) {
            if (this.g._inner[d].m == 6) {
                var e = this.g._inner[d].e6;
                if (!this.af.containsKey(e)) {
                    this.af.item(e, new List$1(ToolAction.$, 0));
                }
                this.af.item(e).add(this.g._inner[d]);
            }
        }
    };
    ToolPanel.prototype.ab = function (a) {
        if (a.cs == null) {
            return false;
        }
        return this.ae.containsKey(a.cs);
    };
    ToolPanel.prototype.f = function (a) {
        if (this.ad.containsKey(a)) {
            return this.ad.item(a);
        }
        return null;
    };
    ToolPanel.prototype.ag = function (a) {
        if (a.cs == null) {
            return null;
        }
        if (this.ae.containsKey(a.cs)) {
            return this.ae.item(a.cs);
        }
        return null;
    };
    ToolPanel.prototype.j = function (a) {
        var b = new ToolActionMeasurementContext();
        this.dq(b);
        a.di(this, b);
        this.dj(this.i, b);
        return b;
    };
    ToolPanel.prototype.dq = function (a) {
        a.a = this.o;
        a.c = this.ar;
    };
    ToolPanel.prototype.dj = function (a, b) {
        if (!isNaN_(b.f)) {
            if (isNaN_(a.f)) {
                a.f = b.f;
            }
            else {
                a.f = Math.max(a.f, b.f);
            }
        }
        if (!isNaN_(b.h)) {
            if (isNaN_(a.h)) {
                a.h = b.h;
            }
            else {
                a.h = Math.max(a.h, b.h);
            }
        }
    };
    ToolPanel.prototype.d0 = function () {
        this.i = new ToolActionMeasurementContext();
        this.i.a = this.o;
        this.i.c = this.ar;
    };
    ToolPanel.prototype.fk = function () {
        var a = 0;
        var b = 0;
        if (this.o == 0) {
            for (var c = 0; c < this.actions.count; c++) {
                var d = this.j(this.actions._inner[c]);
                a = Math.max(d.e, a);
                if (this.actions._inner[c].e1 == 0) {
                    if (!isNaN_(d.d)) {
                        b += d.d;
                    }
                    else {
                        b += this.a2;
                    }
                }
            }
        }
        return new Size(1, a, b);
    };
    ToolPanel.prototype.df = function () {
        if (this.d.itemsSource != this.actions) {
            this.d.itemsSource = this.actions;
        }
    };
    ToolPanel.prototype.dg = function () {
        if (this.z) {
            this.de();
        }
        if (this.d != null) {
            this.d.bt();
        }
    };
    ToolPanel.prototype.dx = function () {
        if (this.d != null) {
            this.d.cm();
        }
    };
    ToolPanel.prototype.dv = function (a) {
        var b = a.e6;
        var c = a.cs;
        if (this.af != null) {
            if (this.af.containsKey(b)) {
                for (var d = 0; d < this.af.item(b).count; d++) {
                    if (this.af.item(b)._inner[d].cs != c) {
                        this.af.item(b)._inner[d].e8();
                    }
                }
            }
        }
    };
    ToolPanel.prototype.di = function (a, b) {
        this.dl();
    };
    ToolPanel.prototype.db = function () {
        for (var a = 0; a < this.actions.count; a++) {
            this.actions._inner[a].dd();
        }
    };
    ToolPanel.prototype.dr = function () {
        for (var a = 0; a < this.actions.count; a++) {
            if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[a]) !== null) {
                var b = this.actions._inner[a];
                b.propertyChanged = delegateRemove(b.propertyChanged, runOn(this, this.di));
            }
            this.actions._inner[a].b = null;
        }
    };
    ToolPanel.prototype.notifySizeChanged = function () {
        this.p.y();
    };
    ToolPanel.prototype.destroy = function () {
        this.provideContainer(null);
        this.db();
    };
    ToolPanel.prototype.provideContainer = function (a) {
        this.p.z(a);
    };
    Object.defineProperty(ToolPanel.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.s;
            this.s = a;
            if (b != this.s) {
                this.dn("CellTextStyle", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolPanel.prototype.u = function () {
        if (this.t == null) {
            return this.p.f();
        }
        return this.t;
    };
    ToolPanel.prototype.dn = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.ds(a, b, c);
    };
    ToolPanel.prototype.ds = function (a, b, c) {
        var e_6, _a, e_7, _b;
        switch (a) {
            case "BaseTheme":
            case "TextColor":
            case "BackgroundColor":
            case "SubmenuBackgroundColor":
            case "GroupHeaderTextColor":
            case "GroupHeaderBackgroundColor":
            case "SeparatorBackgroundColor":
            case "HoverBackgroundColor":
            case "IconFill":
            case "IconStroke":
            case "ToolTipTextColor":
            case "ToolTipBackgroundColor":
            case "ToolTipCornerRadius":
            case "ToolTipElevation":
            case "SeparatorHorizontalPaddingLeft":
            case "SeparatorHorizontalPaddingRight":
            case "SeparatorHorizontalPaddingTop":
            case "SeparatorHorizontalPaddingBottom":
            case "SeparatorVerticalPaddingLeft":
            case "SeparatorVerticalPaddingRight":
            case "SeparatorVerticalPaddingTop":
            case "SeparatorVerticalPaddingBottom":
                this.d3();
                break;
            case "ActualTextColor":
            case "ActualIconFill":
            case "ActualIconStroke":
            case "ActualSubmenuBackgroundColor":
            case "ActualGroupHeaderTextColor":
            case "ActualGroupHeaderBackgroundColor":
            case "ActualSeparatorBackgroundColor":
            case "ActualHoverBackgroundColor":
            case "ActualToolTipTextColor":
            case "ActualToolTipBackgroundColor":
            case "ActualToolTipCornerRadius":
            case "ActualToolTipElevation":
            case "ActualSeparatorHorizontalPaddingLeft":
            case "ActualSeparatorHorizontalPaddingRight":
            case "ActualSeparatorHorizontalPaddingTop":
            case "ActualSeparatorHorizontalPaddingBottom":
            case "ActualSeparatorVerticalPaddingLeft":
            case "ActualSeparatorVerticalPaddingRight":
            case "ActualSeparatorVerticalPaddingTop":
            case "ActualSeparatorVerticalPaddingBottom":
                this.d2(this.actions);
                break;
            case "CellTextStyle":
                this.du();
                break;
            case "ActualBackgroundColor":
                this.d1();
                break;
            case "Orientation":
                if (this.d != null) {
                    this.d.k = this.o;
                }
                break;
            case "Actions":
                if (b != null) {
                    var d = b;
                    d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.c8));
                    d.collectionResetting = delegateRemove(d.collectionResetting, runOn(this, this.c9));
                    try {
                        for (var _c = __values(fromEnum(d)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var e = _d.value;
                            if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                                var f = e;
                                f.propertyChanged = delegateRemove(f.propertyChanged, runOn(this, this.di));
                            }
                            e.b = null;
                            e.j = null;
                        }
                    }
                    catch (e_6_1) {
                        e_6 = { error: e_6_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_6)
                                throw e_6.error;
                        }
                    }
                }
                if (c != null) {
                    var g = c;
                    g.collectionChanged = delegateCombine(g.collectionChanged, runOn(this, this.c8));
                    g.collectionResetting = delegateCombine(g.collectionResetting, runOn(this, this.c9));
                    try {
                        for (var _e = __values(fromEnum(g)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var h = _f.value;
                            if (typeCast(INotifyPropertyChanged_$type, h) !== null) {
                                var i = h;
                                i.propertyChanged = delegateCombine(i.propertyChanged, runOn(this, this.di));
                            }
                            h.b = this.a;
                            h.j = this;
                        }
                    }
                    catch (e_7_1) {
                        e_7 = { error: e_7_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_7)
                                throw e_7.error;
                        }
                    }
                }
                this.d2(this.actions);
                this.du();
                break;
        }
    };
    ToolPanel.prototype.d3 = function () {
        switch (this.r) {
            case 0:
            case 1:
            case 2:
            case 5:
            case 3:
                this.e4 = this.fh != null ? this.fh : BrushUtil.g(255, 24, 29, 31);
                this.ev = this.e8 != null ? this.e8 : BrushUtil.g(102, 0, 0, 0);
                this.eu = this.e7 != null ? this.e7 : BrushUtil.g(255, 255, 255, 255);
                this.e3 = this.fg != null ? this.fg : BrushUtil.g(255, 255, 255, 255);
                this.ew = this.e9 != null ? this.e9 : BrushUtil.g(255, 237, 239, 245);
                this.ey = this.fb != null ? this.fb : BrushUtil.g(255, 142, 143, 147);
                this.e2 = this.ff != null ? this.ff : BrushUtil.g(255, 237, 239, 245);
                this.ex = this.fa != null ? this.fa : BrushUtil.g(25, 0, 0, 0);
                this.ez = this.fc != null ? this.fc : BrushUtil.g(51, 178, 191, 220);
                this.e6 = this.fj != null ? this.fj : BrushUtil.g(255, 0, 0, 0);
                this.e0 = this.fd != null ? this.fd : BrushUtil.g(255, 0, 0, 0);
                this.e1 = this.fe != null ? this.fe : BrushUtil.g(255, 0, 0, 0);
                this.e5 = this.fi != null ? this.fi : BrushUtil.g(255, 237, 239, 245);
                this.bb = !isNaN_(this.bl) ? this.bl : 8;
                this.bc = !isNaN_(this.bm) ? this.bm : 4;
                this.a8 = !isNaN_(this.bi) ? this.bi : 0;
                this.a9 = !isNaN_(this.bj) ? this.bj : 0;
                this.ba = !isNaN_(this.bk) ? this.bk : 0;
                this.a7 = !isNaN_(this.bh) ? this.bh : 0;
                this.a4 = !isNaN_(this.be) ? this.be : 0;
                this.a5 = !isNaN_(this.bf) ? this.bf : 0;
                this.a6 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(10);
                this.a3 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(10);
                break;
            case 6:
            case 4:
                this.e4 = this.fh != null ? this.fh : BrushUtil.g(255, 255, 255, 255);
                this.ev = this.e8 != null ? this.e8 : BrushUtil.g(102, 255, 255, 255);
                this.eu = this.e7 != null ? this.e7 : BrushUtil.g(255, 55, 63, 86);
                this.e3 = this.fg != null ? this.fg : BrushUtil.g(255, 55, 63, 86);
                this.ew = this.e9 != null ? this.e9 : BrushUtil.g(255, 44, 50, 70);
                this.ey = this.fb != null ? this.fb : BrushUtil.g(255, 255, 255, 255);
                this.e2 = this.ff != null ? this.ff : BrushUtil.g(255, 44, 50, 70);
                this.ex = this.fa != null ? this.fa : BrushUtil.g(25, 0, 0, 0);
                this.ez = this.fc != null ? this.fc : BrushUtil.g(25, 105, 136, 255);
                this.e6 = this.fj != null ? this.fj : BrushUtil.g(255, 255, 255, 255);
                this.e0 = this.fd != null ? this.fd : BrushUtil.g(255, 210, 212, 216);
                this.e1 = this.fe != null ? this.fe : BrushUtil.g(255, 210, 212, 216);
                this.e5 = this.fi != null ? this.fi : BrushUtil.g(255, 44, 50, 70);
                this.bb = !isNaN_(this.bl) ? this.bl : 8;
                this.bc = !isNaN_(this.bm) ? this.bm : 4;
                this.a8 = !isNaN_(this.bi) ? this.bi : 0;
                this.a9 = !isNaN_(this.bj) ? this.bj : 0;
                this.ba = !isNaN_(this.bk) ? this.bk : 0;
                this.a7 = !isNaN_(this.bh) ? this.bh : 0;
                this.a4 = !isNaN_(this.be) ? this.be : 0;
                this.a5 = !isNaN_(this.bf) ? this.bf : 0;
                this.a6 = !isNaN_(this.bg) ? this.bg : DeviceUtils.g(10);
                this.a3 = !isNaN_(this.bd) ? this.bd : DeviceUtils.g(10);
                break;
        }
    };
    ToolPanel.prototype.d2 = function (a) {
        for (var b = 0; b < a.count; b++) {
            a._inner[b].d9();
            this.d2(a._inner[b].actions);
        }
    };
    ToolPanel.prototype.d1 = function () {
        if (this.p.n != null) {
            NativeUI.l(this.p.t, this.eu);
        }
    };
    Object.defineProperty(ToolPanel.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            if (b != this.q) {
                this.dn("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e7", {
        get: function () {
            return this.eh;
        },
        set: function (a) {
            var b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.dn("BackgroundColor", b, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "eu", {
        get: function () {
            return this.d4;
        },
        set: function (a) {
            var b = this.d4;
            this.d4 = a;
            if (b != this.d4) {
                this.dn("ActualBackgroundColor", b, this.d4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fg", {
        get: function () {
            return this.eq;
        },
        set: function (a) {
            var b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.dn("SubmenuBackgroundColor", b, this.eq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e3", {
        get: function () {
            return this.ed;
        },
        set: function (a) {
            var b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.dn("ActualSubmenuBackgroundColor", b, this.ed);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e9", {
        get: function () {
            return this.ej;
        },
        set: function (a) {
            var b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.dn("GroupHeaderBackgroundColor", b, this.ej);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ew", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.dn("ActualGroupHeaderBackgroundColor", b, this.d6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ff", {
        get: function () {
            return this.ep;
        },
        set: function (a) {
            var b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.dn("SeparatorBackgroundColor", b, this.ep);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e2", {
        get: function () {
            return this.ec;
        },
        set: function (a) {
            var b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.dn("ActualSeparatorBackgroundColor", b, this.ec);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fa", {
        get: function () {
            return this.ek;
        },
        set: function (a) {
            var b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.dn("GroupHeaderSeparatorBackgroundColor", b, this.ek);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ex", {
        get: function () {
            return this.d7;
        },
        set: function (a) {
            var b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.dn(ToolPanel.bs, b, this.d7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fc", {
        get: function () {
            return this.em;
        },
        set: function (a) {
            var b = this.em;
            this.em = a;
            if (b != this.em) {
                this.dn("HoverBackgroundColor", b, this.em);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ez", {
        get: function () {
            return this.d9;
        },
        set: function (a) {
            var b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.dn("ActualHoverBackgroundColor", b, this.d9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fh", {
        get: function () {
            return this.er;
        },
        set: function (a) {
            var b = this.er;
            this.er = a;
            if (b != this.er) {
                this.dn("TextColor", b, this.er);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e4", {
        get: function () {
            return this.ee;
        },
        set: function (a) {
            var b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.dn("ActualTextColor", b, this.ee);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e8", {
        get: function () {
            return this.ei;
        },
        set: function (a) {
            var b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.dn("DisabledTextColor", b, this.ei);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ev", {
        get: function () {
            return this.d5;
        },
        set: function (a) {
            var b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.dn("ActualDisabledTextColor", b, this.d5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fb", {
        get: function () {
            return this.el;
        },
        set: function (a) {
            var b = this.el;
            this.el = a;
            if (b != this.el) {
                this.dn("GroupHeaderTextColor", b, this.el);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ey", {
        get: function () {
            return this.d8;
        },
        set: function (a) {
            var b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.dn("ActualGroupHeaderTextColor", b, this.d8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fj", {
        get: function () {
            return this.et;
        },
        set: function (a) {
            var b = this.et;
            this.et = a;
            if (b != this.et) {
                this.dn("ToolTipTextColor", b, this.et);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e6", {
        get: function () {
            return this.eg;
        },
        set: function (a) {
            var b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.dn("ActualToolTipTextColor", b, this.eg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fi", {
        get: function () {
            return this.es;
        },
        set: function (a) {
            var b = this.es;
            this.es = a;
            if (b != this.es) {
                this.dn("ToolTipBackgroundColor", b, this.es);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e5", {
        get: function () {
            return this.ef;
        },
        set: function (a) {
            var b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.dn("ActualToolTipBackgroundColor", b, this.ef);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bl", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.dn("ToolTipCornerRadius", b, this.a0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bb", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.dn("ActualToolTipCornerRadius", b, this.ap);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bm", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            var b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.dn("ToolTipElevation", b, this.a1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bc", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.dn("ActualToolTipElevation", b, this.aq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fd", {
        get: function () {
            return this.en;
        },
        set: function (a) {
            var b = this.en;
            this.en = a;
            if (b != this.en) {
                this.dn("IconFill", b, this.en);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e0", {
        get: function () {
            return this.ea;
        },
        set: function (a) {
            var b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.dn("ActualIconFill", b, this.ea);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "fe", {
        get: function () {
            return this.eo;
        },
        set: function (a) {
            var b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.dn("IconStroke", b, this.eo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "e1", {
        get: function () {
            return this.eb;
        },
        set: function (a) {
            var b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.dn("ActualIconStroke", b, this.eb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bi", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.dn("SeparatorVerticalPaddingLeft", b, this.ax);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a8", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.dn("ActualSeparatorVerticalPaddingLeft", b, this.am);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bj", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.dn("SeparatorVerticalPaddingRight", b, this.ay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a9", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.dn("ActualSeparatorVerticalPaddingRight", b, this.an);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bk", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.dn("SeparatorVerticalPaddingTop", b, this.az);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "ba", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.dn("ActualSeparatorVerticalPaddingTop", b, this.ao);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bh", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.dn("SeparatorVerticalPaddingBottom", b, this.aw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a7", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.dn("ActualSeparatorVerticalPaddingBottom", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "be", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.dn("SeparatorHorizontalPaddingLeft", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a4", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.dn("ActualSeparatorHorizontalPaddingLeft", b, this.ai);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bf", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.dn("SeparatorHorizontalPaddingRight", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a5", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.dn("ActualSeparatorHorizontalPaddingRight", b, this.aj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bg", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (b != this.av) {
                this.dn("SeparatorHorizontalPaddingTop", b, this.av);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a6", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.dn("ActualSeparatorHorizontalPaddingTop", b, this.ak);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "bd", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.dn("SeparatorHorizontalPaddingBottom", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a3", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.dn("ActualSeparatorHorizontalPaddingBottom", b, this.ah);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "o", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.dn("Orientation", enumGetBox(ToolPanelOrientation_$type, b), enumGetBox(ToolPanelOrientation_$type, a));
            }
        },
        enumerable: false,
        configurable: true
    });
    ToolPanel.prototype.dp = function (a, b) {
        if (this.onCommand != null) {
            this.onCommand(this, ((function () {
                var $ret = new ToolCommandEventArgs();
                $ret.a = b;
                return $ret;
            })()));
        }
        if (a.m == 6) {
            this.dv(a);
        }
    };
    Object.defineProperty(ToolPanel.prototype, "bn", {
        get: function () {
            return this.d.a7;
        },
        set: function (a) {
            this.d.a7 = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanel.prototype, "a2", {
        get: function () {
            return this.d.av;
        },
        enumerable: false,
        configurable: true
    });
    ToolPanel.prototype.dy = function (a) {
        if (this.drillDownRequested != null) {
            this.drillDownRequested(this, ((function () {
                var $ret = new DrillDownRequestedEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
    };
    ToolPanel.prototype.dz = function (a) {
        if (this.drillUpRequested != null) {
            this.drillUpRequested(this, ((function () {
                var $ret = new DrillDownRequestedEventArgs();
                $ret.a = a;
                return $ret;
            })()));
        }
    };
    ToolPanel.prototype.dc = function () {
        for (var a = 0; a < this.actions.count; a++) {
            this.actions._inner[a].df();
        }
    };
    ToolPanel.$t = markType(ToolPanel, 'ToolPanel', Base.$, [INotifyPropertyChanged_$type]);
    ToolPanel.bs = "ActualGroupHeaderSeparatorBackgroundColor";
    ToolPanel.n = 0;
    return ToolPanel;
}(Base));
export { ToolPanel };
/**
 * @hidden
 */
var DrillDownRequestedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DrillDownRequestedEventArgs, _super);
    function DrillDownRequestedEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    DrillDownRequestedEventArgs.$t = markType(DrillDownRequestedEventArgs, 'DrillDownRequestedEventArgs');
    return DrillDownRequestedEventArgs;
}(Base));
export { DrillDownRequestedEventArgs };
/**
 * @hidden
 */
var ToolPanelsPresenter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToolPanelsPresenter, _super);
    function ToolPanelsPresenter(a, b) {
        var _this = _super.call(this) || this;
        _this.ab = null;
        _this.i = null;
        _this.j = null;
        _this.y = 0;
        _this.o = null;
        _this.a = null;
        _this.d = null;
        _this.g = null;
        _this.ay = null;
        _this.az = null;
        _this.p = null;
        _this.b = null;
        _this.e = null;
        _this.h = null;
        _this.c = null;
        _this.f = null;
        _this.w = new Queue$1(PanelAnimationRequest.$);
        _this.r = null;
        _this.q = null;
        _this.u = new List$1(PanelInfo.$, 0);
        _this.m = 1;
        _this.x = 200;
        _this.s = null;
        _this.aa = 0;
        _this.t = false;
        _this.containerReady = null;
        _this.sizeChanged = null;
        _this.propertyChanged = null;
        _this.ab = a;
        _this.i = b;
        return _this;
    }
    Object.defineProperty(ToolPanelsPresenter.prototype, "a0", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            this.d.d = this.ay = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanelsPresenter.prototype, "a1", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            this.g.d = this.az = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanelsPresenter.prototype, "v", {
        get: function () {
            return this.u;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanelsPresenter.prototype, "n", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.as("Theme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.m));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ToolPanelsPresenter.prototype, "z", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            this.x = a;
        },
        enumerable: false,
        configurable: true
    });
    ToolPanelsPresenter.prototype.ai = function (a) {
        var _this = this;
        NativeUIComponent.at(this.ab, [7, 9], function (b) {
            _this.r = b[0];
            _this.q = b[1];
            _this.r.bj(_this.q);
            _this.q.a9 = new MatrixTransform();
            if (a != null) {
                a();
            }
        });
    };
    ToolPanelsPresenter.prototype.ae = function (a, b) {
        var _this = this;
        if (b === void 0) {
            b = null;
        }
        for (var c = 0; c < this.v.count; c++) {
            if (this.v._inner[c].b == a) {
                if (b != null) {
                    b(this.v._inner[c].a);
                }
                return;
            }
        }
        NativeUIComponent.ar(this.ab, 13, function (d) {
            var e = d;
            e.c = _this.n;
            e.b1 = a.j.fh;
            e.bw = a.j.e8;
            e.bv = a.j.fg;
            e.b0 = a.j.fg;
            e.bx = a.j.e9;
            e.by = a.j.fb;
            e.bz = a.j.ff;
            e.bp = a.actions;
            e.bi = runOn(_this, _this.aq);
            e.bj = runOn(_this, _this.ar);
            e.bo = runOn(_this, _this.ao);
            _this.q.bj(e);
            _this.y = 0;
            for (var f = 0; f < _this.v.count; f++) {
                var g = _this.v._inner[f].f();
                _this.y += g.width;
                _this.v._inner[f].a.ad = g.width;
            }
            _this.q.bq(e, _this.y);
            _this.q.br(e, 0);
            _this.v.add(new PanelInfo(a, e, _this.y));
            _this.av();
            if (b != null) {
                b(e);
            }
        });
    };
    ToolPanelsPresenter.prototype.aj = function (a) {
        for (var b = 0; b < this.v.count; b++) {
            if (this.v._inner[b].a == a) {
                this.al(b);
            }
        }
    };
    ToolPanelsPresenter.prototype.al = function (a) {
        this.ak(this.v._inner[a]);
    };
    ToolPanelsPresenter.prototype.ak = function (a, b) {
        if (b === void 0) {
            b = null;
        }
        this.af(a, -Math.floor(a.c), b);
        this.j = a;
    };
    ToolPanelsPresenter.prototype.aq = function (a, b) {
        var _this = this;
        this.aa++;
        if (this.v.count > 1 && this.aa < this.v.count) {
            for (var c = this.v.count - 1; c > this.aa; c--) {
                this.v._inner[c].a.bi = null;
                this.v._inner[c].a.bj = null;
                this.q.bl(this.v._inner[c].a);
                this.y -= this.v._inner[c].a.ad;
                this.v.removeAt(c);
            }
            if (this.v._inner[this.aa].b == b.a) {
                this.aj(this.v._inner[this.aa].a);
                return;
            }
            else {
                this.v._inner[this.aa].a.bi = null;
                this.v._inner[this.aa].a.bj = null;
                this.q.bl(this.v._inner[this.aa].a);
                this.y -= this.v._inner[this.aa].a.ad;
                this.v.removeAt(this.aa);
            }
        }
        this.ae(b.a, function (d) { return _this.i.executeDelayed(function () { return _this.aj(d); }, 0); });
    };
    ToolPanelsPresenter.prototype.ar = function (a, b) {
        this.aa--;
        this.ak(this.v._inner[this.v.count - 2], function () {
        });
    };
    ToolPanelsPresenter.prototype.ao = function (a, b) {
        if (this.s != null) {
            this.s(b);
        }
    };
    ToolPanelsPresenter.prototype.af = function (a, b, c) {
        var _this = this;
        if (c === void 0) {
            c = null;
        }
        this.ah();
        if (this.q.a9 == null) {
            var d = a.f();
            this.r.ad = Math.floor(d.width);
            this.r.x = Math.floor(d.height);
            return;
        }
        if (this.o.playState == 1) {
            if ((this.o.playbackRate > 0 && this.a0.j == b) || (this.o.playbackRate < 0 && this.a1.j == b)) {
                this.o.reverse();
                this.p.reverse();
            }
            else {
                this.w.g(((function () {
                    var $ret = new PanelAnimationRequest();
                    $ret.a = a;
                    $ret.c = b;
                    $ret.b = c;
                    return $ret;
                })()));
            }
        }
        else {
            this.a0 = ((function () {
                var $ret = new TranslateTransform();
                $ret.j = _this.a1.j;
                return $ret;
            })());
            this.a1 = ((function () {
                var $ret = new TranslateTransform();
                $ret.j = b;
                return $ret;
            })());
            var e = a.f();
            this.e.d = this.r.ad;
            this.c.d = this.r.x;
            this.h.d = Math.floor(e.width);
            this.f.d = Math.floor(e.height);
            this.o.updatePlaybackRate(1);
            this.o.play();
            this.o.finished.f(function (f) { return _this.an(c); });
            this.p.updatePlaybackRate(1);
            this.p.play();
            this.p.finished.f(function (f) {
                if (_this.p != null) {
                    _this.p.commitStyles();
                }
            });
        }
    };
    ToolPanelsPresenter.prototype.ah = function () {
        if (this.o == null) {
            var a = new AnimationKeyFrameEffectTiming();
            a.g = this.z;
            a.b = 0;
            this.a = new AnimationKeyFrameEffect(0, this.q.al, 0, null, a);
            this.ay = ((function () {
                var $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
            this.az = ((function () {
                var $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
            this.d = new AnimationKeyFrameProperty(14, this.ay);
            this.g = new AnimationKeyFrameProperty(14, this.az);
            this.o = KeyFrameAnimationFactory.f.c(this.a.m(this.d).m(this.g));
            this.b = new AnimationKeyFrameEffect(0, this.r.al, 0, null, a);
            this.e = new AnimationKeyFrameProperty(9, 0);
            this.c = new AnimationKeyFrameProperty(10, 0);
            this.h = new AnimationKeyFrameProperty(9, 0);
            this.f = new AnimationKeyFrameProperty(10, 0);
            this.p = KeyFrameAnimationFactory.f.c(this.b.m(this.e, this.c).m(this.h, this.f));
        }
    };
    ToolPanelsPresenter.prototype.an = function (a) {
        var _this = this;
        if (this.o != null) {
            this.o.commitStyles();
        }
        if (a != null) {
            a();
        }
        if (this.o.playbackRate < 0) {
            var b_1 = this.a1.j;
            this.a1 = ((function () {
                var $ret = new TranslateTransform();
                $ret.j = _this.a0.j;
                return $ret;
            })());
            this.a0 = ((function () {
                var $ret = new TranslateTransform();
                $ret.j = b_1;
                return $ret;
            })());
        }
        if (this.w.count > 0) {
            var c = this.w.b();
            this.ak(c.a, c.b);
        }
    };
    ToolPanelsPresenter.prototype.av = function () {
        if (this.t) {
            return;
        }
        this.t = true;
        this.i.enqueueAction(runOn(this, this.ag));
    };
    ToolPanelsPresenter.prototype.ag = function () {
        if (!this.t) {
            return;
        }
        this.t = false;
        for (var a = 0; a < this.v.count; a++) {
            this.v._inner[a].e();
            var b = this.v._inner[a].f();
            this.v._inner[a].a.ad = b.width;
            this.v._inner[a].a.x = b.height;
            this.v._inner[a].a.bt(b);
        }
    };
    ToolPanelsPresenter.prototype.aw = function () {
        this.aa = 0;
        this.q.a9 = new MatrixTransform();
        var a = this.v._inner[0].f();
        this.r.ad = Math.floor(a.width);
        this.r.x = Math.floor(a.height);
        this.ay = ((function () {
            var $ret = new TranslateTransform();
            $ret.j = 0;
            return $ret;
        })());
        this.az = ((function () {
            var $ret = new TranslateTransform();
            $ret.j = 0;
            return $ret;
        })());
    };
    ToolPanelsPresenter.prototype.ax = function (a, b) {
        this.m = a;
        for (var c = 0; c < this.v.count; c++) {
            var d = this.v._inner[c].a;
            d.c = a;
            d.b1 = b.fh;
            d.bw = b.e8;
            d.bv = b.fg;
            d.b0 = b.fg;
            d.bx = b.e9;
            d.by = b.fb;
            d.bz = b.ff;
        }
    };
    ToolPanelsPresenter.prototype.am = function () {
        var a = this.v._inner[0].f();
        this.v._inner[0].d(a);
    };
    ToolPanelsPresenter.prototype.ap = function () {
        if (this.containerReady != null) {
            this.containerReady(this);
        }
    };
    ToolPanelsPresenter.prototype.at = function () {
        if (this.sizeChanged != null) {
            this.sizeChanged(this);
        }
    };
    ToolPanelsPresenter.prototype.as = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.au(a, b, c);
    };
    ToolPanelsPresenter.prototype.au = function (a, b, c) {
        switch (a) {
            case "Theme":
                for (var d = 0; d < this.v.count; d++) {
                    this.v._inner[d].a.c = this.n;
                }
                break;
        }
    };
    ToolPanelsPresenter.$t = markType(ToolPanelsPresenter, 'ToolPanelsPresenter', Base.$, [INotifyPropertyChanged_$type]);
    return ToolPanelsPresenter;
}(Base));
export { ToolPanelsPresenter };
/**
 * @hidden
 */
var PanelInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PanelInfo, _super);
    function PanelInfo(a, b, c) {
        var _this = _super.call(this) || this;
        _this.c = 0;
        _this.a = null;
        _this.b = null;
        _this.b = a;
        _this.a = b;
        _this.c = c;
        return _this;
    }
    PanelInfo.prototype.f = function () {
        return this.a.bb(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
    };
    PanelInfo.prototype.e = function () {
        this.a.bu();
    };
    PanelInfo.prototype.d = function (a) {
        this.a.bt(a);
    };
    PanelInfo.$t = markType(PanelInfo, 'PanelInfo');
    return PanelInfo;
}(Base));
export { PanelInfo };
/**
 * @hidden
 */
var PanelAnimationRequest = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PanelAnimationRequest, _super);
    function PanelAnimationRequest() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = 0;
        _this.b = null;
        return _this;
    }
    PanelAnimationRequest.$t = markType(PanelAnimationRequest, 'PanelAnimationRequest');
    return PanelAnimationRequest;
}(Base));
export { PanelAnimationRequest };
