import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { PropertyEditorDescriptionObject as PropertyEditorDescriptionObject_internal } from './PropertyEditorDescriptionObject';
import { IgcPropertyEditorDescriptionObject as IgcPropertyEditorDescriptionObject } from './igc-property-editor-description-object';
var IgcPropertyEditorDescriptionObjectCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcPropertyEditorDescriptionObjectCollection, _super);
    function IgcPropertyEditorDescriptionObjectCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgcPropertyEditorDescriptionObject.$type) {
            IgcPropertyEditorDescriptionObject.$type = markType(IgcPropertyEditorDescriptionObject, "IgcPropertyEditorDescriptionObject");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcPropertyEditorDescriptionObjectCollection.prototype._createInnerColl = function () {
        if (!IgcPropertyEditorDescriptionObject.$type) {
            IgcPropertyEditorDescriptionObject.$type = markType(IgcPropertyEditorDescriptionObject, "IgcPropertyEditorDescriptionObject");
        }
        var coll = new SyncableObservableCollection$2(IgcPropertyEditorDescriptionObject.$type, PropertyEditorDescriptionObject_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgcPropertyEditorDescriptionObject();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgcPropertyEditorDescriptionObjectCollection;
}(IgCollection));
export { IgcPropertyEditorDescriptionObjectCollection };
