import { __extends } from "tslib";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionCheckbox } from "./ToolActionCheckbox";
import { getAllPropertyNames, toSpinal, ensureBool } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcToolActionCheckboxComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionCheckboxComponent, _super);
    function IgcToolActionCheckboxComponent() {
        return _super.call(this) || this;
    }
    IgcToolActionCheckboxComponent.prototype.createImplementation = function () {
        return new ToolActionCheckbox();
    };
    Object.defineProperty(IgcToolActionCheckboxComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionCheckboxComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionCheckboxComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionCheckboxComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent == null) {
                var names = getAllPropertyNames(IgcToolActionCheckboxComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent = names;
            }
            return IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionCheckboxComponent.register = function () {
        if (!IgcToolActionCheckboxComponent._isElementRegistered) {
            IgcToolActionCheckboxComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionCheckboxComponent.htmlTagName, IgcToolActionCheckboxComponent);
        }
    };
    Object.defineProperty(IgcToolActionCheckboxComponent.prototype, "isChecked", {
        /**
         * Gets or sets if the tool action is checked.
        */
        get: function () {
            return this.i.e4;
        },
        set: function (v) {
            this.i.e4 = ensureBool(v);
            this._a("isChecked", this.i.e4);
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionCheckboxComponent.prototype.fromInfo = function (info) {
        this.i.dp(info);
    };
    IgcToolActionCheckboxComponent._observedAttributesIgcToolActionCheckboxComponent = null;
    IgcToolActionCheckboxComponent.htmlTagName = "igc-tool-action-checkbox";
    IgcToolActionCheckboxComponent._isElementRegistered = false;
    return IgcToolActionCheckboxComponent;
}(IgcToolActionComponent));
export { IgcToolActionCheckboxComponent };
