import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { ToolAction as ToolAction_internal } from './ToolAction';
import { IgcToolActionComponent as IgcToolActionComponent } from './igc-tool-action-component';
var IgcToolActionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionCollection, _super);
    function IgcToolActionCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgcToolActionComponent.$type) {
            IgcToolActionComponent.$type = markType(IgcToolActionComponent, "IgcToolActionComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcToolActionCollection.prototype._createInnerColl = function () {
        if (!IgcToolActionComponent.$type) {
            IgcToolActionComponent.$type = markType(IgcToolActionComponent, "IgcToolActionComponent");
        }
        var coll = new SyncableObservableCollection$2(IgcToolActionComponent.$type, ToolAction_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgcToolActionComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgcToolActionCollection;
}(IgCollection));
export { IgcToolActionCollection };
