import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { ToolActionEventDetail as ToolActionEventDetail_internal } from './ToolActionEventDetail';
import { IgcToolActionEventDetail as IgcToolActionEventDetail } from './igc-tool-action-event-detail';
var IgcToolActionEventDetailCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionEventDetailCollection, _super);
    function IgcToolActionEventDetailCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgcToolActionEventDetail.$type) {
            IgcToolActionEventDetail.$type = markType(IgcToolActionEventDetail, "IgcToolActionEventDetail");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcToolActionEventDetailCollection.prototype._createInnerColl = function () {
        if (!IgcToolActionEventDetail.$type) {
            IgcToolActionEventDetail.$type = markType(IgcToolActionEventDetail, "IgcToolActionEventDetail");
        }
        var coll = new SyncableObservableCollection$2(IgcToolActionEventDetail.$type, ToolActionEventDetail_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgcToolActionEventDetail();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgcToolActionEventDetailCollection;
}(IgCollection));
export { IgcToolActionEventDetailCollection };
