import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { PropertyEditorValueType } from "./PropertyEditorValueType";
import { IgcPropertyEditorDescriptionObject } from "./igc-property-editor-description-object";
import { IgcPropertyEditorDescriptionObjectCollection } from "./igc-property-editor-description-object-collection";
import { IgcPropertyEditorPropertyDescriptionCollection } from "./igc-property-editor-property-description-collection";
import { IgcPropertyEditorPropertyDescriptionButtonClickEventArgs } from "./igc-property-editor-property-description-button-click-event-args";
import { IgcPropertyEditorPropertyDescriptionChangedEventArgs } from "./igc-property-editor-property-description-changed-event-args";
import { IgcPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./igc-property-editor-property-description-target-property-updating-event-args";
import { PropertyEditorPropertyDescription } from "./PropertyEditorPropertyDescription";
export declare class IgcPropertyEditorPropertyDescriptionComponent extends IgcHTMLElement {
    protected createImplementation(): PropertyEditorPropertyDescription;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): PropertyEditorPropertyDescription; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcPropertyEditorPropertyDescriptionComponent;
    private onImplementationCreated;
    constructor();
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcPropertyEditorPropertyDescriptionComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    get propertyPath(): string;
    set propertyPath(v: string);
    get label(): string;
    set label(v: string);
    get valueType(): PropertyEditorValueType;
    set valueType(v: PropertyEditorValueType);
    get propertyDescriptionType(): string;
    set propertyDescriptionType(v: string);
    get shouldOverrideDefaultEditor(): boolean;
    set shouldOverrideDefaultEditor(v: boolean);
    get elementDescriptionType(): string;
    set elementDescriptionType(v: string);
    get dropDownNames(): string[];
    set dropDownNames(v: string[]);
    get dropDownValues(): string[];
    set dropDownValues(v: string[]);
    get primitiveValue(): any;
    set primitiveValue(v: any);
    get min(): number;
    set min(v: number);
    get editorWidth(): number;
    set editorWidth(v: number);
    get labelWidth(): number;
    set labelWidth(v: number);
    get max(): number;
    set max(v: number);
    get step(): number;
    set step(v: number);
    get complexValue(): IgcPropertyEditorDescriptionObject;
    set complexValue(v: IgcPropertyEditorDescriptionObject);
    private _complexValues;
    get complexValues(): IgcPropertyEditorDescriptionObjectCollection;
    set complexValues(v: IgcPropertyEditorDescriptionObjectCollection);
    private _properties;
    get properties(): IgcPropertyEditorPropertyDescriptionCollection;
    set properties(v: IgcPropertyEditorPropertyDescriptionCollection);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    private _buttonClicked;
    private _buttonClicked_wrapped;
    get buttonClicked(): (s: IgcPropertyEditorPropertyDescriptionComponent, e: IgcPropertyEditorPropertyDescriptionButtonClickEventArgs) => void;
    set buttonClicked(ev: (s: IgcPropertyEditorPropertyDescriptionComponent, e: IgcPropertyEditorPropertyDescriptionButtonClickEventArgs) => void);
    private _changed;
    private _changed_wrapped;
    get changed(): (s: IgcPropertyEditorPropertyDescriptionComponent, e: IgcPropertyEditorPropertyDescriptionChangedEventArgs) => void;
    set changed(ev: (s: IgcPropertyEditorPropertyDescriptionComponent, e: IgcPropertyEditorPropertyDescriptionChangedEventArgs) => void);
    private _targetPropertyUpdating;
    private _targetPropertyUpdating_wrapped;
    get targetPropertyUpdating(): (s: IgcPropertyEditorPropertyDescriptionComponent, e: IgcPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void;
    set targetPropertyUpdating(ev: (s: IgcPropertyEditorPropertyDescriptionComponent, e: IgcPropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void);
}
