import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionIconButton } from "./ToolActionIconButton";
import { ToolActionInfo } from "igniteui-webcomponents-core";
export declare class IgcToolActionIconButtonComponent extends IgcToolActionComponent {
    protected createImplementation(): ToolActionIconButton;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionIconButton;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcToolActionIconButtonComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets how long it takes before the tooltip is displayed (in milliseconds).
    */
    get tooltipDelay(): number;
    set tooltipDelay(v: number);
    cleanUp(): void;
    openSubMenu(): void;
    closeSubmenu(): void;
    fromInfo(info: ToolActionInfo): void;
}
