import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionRadio } from "./ToolActionRadio";
import { ToolActionInfo } from "igniteui-webcomponents-core";
export declare class IgcToolActionRadioComponent extends IgcToolActionComponent {
    protected createImplementation(): ToolActionRadio;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionRadio;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcToolActionRadioComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets the channel this radio button belongs to.
    */
    get channel(): string;
    set channel(v: string);
    /**
     * Gets or sets if the tool action is checked.
    */
    get isChecked(): boolean;
    set isChecked(v: boolean);
    fromInfo(info: ToolActionInfo): void;
}
