import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionSeparator } from "./ToolActionSeparator";
import { ToolActionInfo } from "igniteui-webcomponents-core";
export declare class IgcToolActionSeparatorComponent extends IgcToolActionComponent {
    protected createImplementation(): ToolActionSeparator;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionSeparator;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcToolActionSeparatorComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets the size of the separator.
    */
    get size(): number;
    set size(v: number);
    /**
     * Gets or sets whether to use group header styling or regular styling on this separator.
    */
    get isGroupHeaderSeparator(): boolean;
    set isGroupHeaderSeparator(v: boolean);
    fromInfo(info: ToolActionInfo): void;
}
